/*

 * Created on Dec 6, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.application.clustering;



import java.util.Iterator;

import yaes.framework.simulation.IContext;

import yaes.framework.simulation.ISimulationCode;

import yaes.framework.simulation.SimulationInputParameters;

import yaes.framework.simulation.SimulationOutputParameters;

import yaes.framework.world.network.sensornetwork.SensorNetwork;

import yaes.framework.world.network.sensornetwork.SensorNode;





/**

 * @author Lotzi Boloni

 *

 * To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

public class EnergySimulation implements ISimulationCode, Constants {



	boolean firstNodeFailed = false;

	boolean percentFailed =false;

	

    /* (non-Javadoc)

     * @see yaes.framework.simulation.ISimulationCode#setup(yaes.framework.simulation.SimulationInputParameters, yaes.framework.simulation.IContext)

     */

    public void setup(SimulationInputParameters sip, IContext theContext) {

    }



    /* (non-Javadoc)

     * @see yaes.framework.simulation.ISimulationCode#update(double, yaes.framework.simulation.SimulationInputParameters, yaes.framework.simulation.SimulationOutputParameters, yaes.framework.simulation.IContext)

     */

    public void update(double time, SimulationInputParameters sip,

            SimulationOutputParameters sop, IContext theContext) {

        ClusteringContext context = (ClusteringContext) theContext;        

        EnergySimulation.updateEnergy(context.n, time);

        EnergySimulation.failNodesBasedOnEnergy(context.n);

        // check if the first node failed

        int failedNodes =  context.n.failedNodes.size();

        int workingNodes = context.n.nodeInfoList.size();

        if (!firstNodeFailed && failedNodes != 0) {

        	sop.update(Constants.ENERGY_FIRST_NODE_FAILED, time);

        	firstNodeFailed = true;

        }

        // check if certain percentage of nodes failed

        double percentageFailed = (double) failedNodes / (double) (failedNodes + workingNodes);

        if (!percentFailed && (percentageFailed > 0.1)) {

        	sop.update(Constants.ENERGY_PERCENT_NODES_FAILED, time);

        	percentFailed = true;

        }        

    }



    /* (non-Javadoc)

     * @see yaes.framework.simulation.ISimulationCode#postprocess(yaes.framework.simulation.SimulationInputParameters, yaes.framework.simulation.SimulationOutputParameters, yaes.framework.simulation.IContext)

     */

    public void postprocess(SimulationInputParameters sip,

            SimulationOutputParameters sop, IContext theContext) {

        // TODO Auto-generated method stub

    }



    /**

     * Updates the energy values of the network, per time

     * 

     * @param n

     * @param time

     */

    public static void failNodesBasedOnEnergy(SensorNetwork n) {

        boolean nodeFailed = true;

        while (nodeFailed) {

            nodeFailed = false;

            synchronized (n) {

                for (Iterator it = n.nodeInfoList.iterator(); it.hasNext();) {

                    SensorNode element = (SensorNode) it.next();

                    double energy = element.getEnergyModel().getEnergy();

                    if (energy <= 0.0) {

                        n.failNode(element);

                        element.failed = true;

                        nodeFailed = true;

                        break;

                    }

                }

            }

        }

    }





    /**

     * Updates the energy values of the network, per time

     * 

     * @param n

     * @param time

     */

    public static void updateEnergy(SensorNetwork n, double time) {

        for (Iterator it = n.nodeInfoList.iterator(); it.hasNext();) {

            SensorNode element = (SensorNode) it.next();

            element.getEnergyModel().updateEnergy(time);

        }

    }

}

