/*

 * Created on Nov 20, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.application.clustering;



import java.io.IOException;

import java.util.ArrayList;

import java.util.List;

import yaes.application.clustering.transmissionscheduling.TransmissionScheduling;

import yaes.framework.Version;

import yaes.framework.simulation.IntegratedSOP;

import yaes.framework.simulation.RandomVariable;

import yaes.framework.simulation.Simulation;

import yaes.framework.simulation.SimulationHelper;

import yaes.framework.simulation.SimulationInputParameters;

import yaes.framework.simulation.SimulationOutputParameters;

import yaes.ui.plot.IntegerValuePlotLineFilter;

import yaes.ui.plot.PlotLineDescription;

import yaes.ui.text.TextUi;



/**

 * @author Lotzi Boloni

 * 

 * To change the template for this generated type comment go to Window -

 * Preferences - Java - Code Generation - Code and Comments

 */

public class Main implements Constants {



	public static void scenarioTransmissionScheduling()

			throws InstantiationException, IllegalAccessException {

		SimulationInputParameters sim = new SimulationInputParameters();

		sim.setParameter(NODECOUNT, 50);

		sim.setParameter(TRANSMISSION_RANGE, 40.0);

		sim.setParameter(MAX_DISPLACEMENT, 5);

		sim.setParameter(VISUALIZE, VISUALIZE_NO);

		sim.setParameter(WCA_W1, 0.7);

		sim.setParameter(WCA_W2, 0.2);

		sim.setParameter(WCA_W3, 0.05);

		sim.setParameter(WCA_W4, 0.05);

		// context.wcapar = new WCAParameters(0.7, 0.2, 0.05, 0.05);

		sim.setStartTime(0);

		sim.setStopTime(10000);

		SimulationOutputParameters sop = Simulation.simulate(sim,

				Clustering.class, ClusteringContext.class);

		ClusteringContext theContext = (ClusteringContext) sop.getTheContext();

		// theContext.writeDistancesToMatlab("distances.m");

		TransmissionScheduling.trySchedulingForAllNodes(theContext);

	}



	public static void scenarioClusterHeads() throws InstantiationException,

			IllegalAccessException, IOException {

		TextUi.println(Version.versionString());

		List<SimulationInputParameters> inputs = new ArrayList<SimulationInputParameters>();

		for (int j = 0; j != N_VALUES.length; j++) {

			for (int i = 0; i != TXRANGE_VALUES.length; i++) {

				SimulationInputParameters sim = new SimulationInputParameters();

				sim.setParameter(WCA_W1, 0.7);

				sim.setParameter(WCA_W2, 0.2);

				sim.setParameter(WCA_W3, 0.05);

				sim.setParameter(WCA_W4, 0.05);

				sim.setParameter(WCA_OPTIMAL_DEGREE, 10);

				sim.setParameter(WCA_FORCED_RECOMPUTE, WCA_FORCED_RECOMPUTE_NO);

				sim.setParameter(NODECOUNT, 50);

				sim.setParameter(TRANSMISSION_RANGE, 50.0);

				sim.setParameter(MAX_DISPLACEMENT, 5);

				sim.setParameter(RECORD_DISTANCES, RECORD_DISTANCES_NO);

    			sim.setParameter(SIMULATION_CODE_CLUSTERING, SC_CLUSTERING_WCA);

				sim.setParameter(SIMULATION_CODE_MOBILITY, SC_MOBILITY_RANDOM);

				sim.setParameter(SIMULATION_CODE_ENERGY, SC_ENERGY_4THPOWER);

				sim.setParameter(VISUALIZE, VISUALIZE_YES);

				sim.setParameter(RECORD_DISTANCES, RECORD_DISTANCES_NO);

				sim.setStartTime(0);

				sim.setStopTime(1000);

				inputs.add(sim);

			}

		}

		List outputs = Simulation.simulationSet(inputs, Clustering.class,

				ClusteringContext.class);

		// plots

		ArrayList<PlotLineDescription> list = new ArrayList<PlotLineDescription>();

		for (int j = 0; j != N_VALUES.length; j++) {

			PlotLineDescription pd = new PlotLineDescription(

					TRANSMISSION_RANGE, RandomVariable.TYPE_AVG,

					NO_CLUSTERHEADS, RandomVariable.TYPE_AVG, "N = "

							+ N_VALUES[j]);

			pd.setPlotLineFilter(new IntegerValuePlotLineFilter(NODECOUNT,

					N_VALUES[j]));

			list.add(pd);

		}

		SimulationHelper.generatePlotFromPlotDescriptionList(

				"data/taskallocation/clusterheads.m", list, outputs);

	}



	private static void scenarioEnergyW(String first, String second,

			String third, String fourth) throws InstantiationException,

			IllegalAccessException, IOException {

		List<SimulationInputParameters> inputs = new ArrayList<SimulationInputParameters>();

		List outputsToIntegrate = new ArrayList();

		for (int i = 1; i != 5; i++) {

			for (double w1 = 0.0; w1 <= 1.0; w1 = w1 + 0.05) {

				SimulationInputParameters sim = new SimulationInputParameters();

				double w2 = (1.0 - w1) / 3;

				double w3 = (1.0 - w1) / 3;

				double w4 = 1.0 - w1 - w2 - w3;

				sim.setParameter(first, w1);

				sim.setParameter(second, w2);

				sim.setParameter(third, w3);

				sim.setParameter(fourth, w4);

				sim.setParameter(WCA_OPTIMAL_DEGREE, 10);

				sim.setParameter(WCA_FORCED_RECOMPUTE, WCA_FORCED_RECOMPUTE_NO);

				sim.setParameter(NODECOUNT, 50);

				sim.setParameter(SIMULATION_CODE_CLUSTERING, SC_CLUSTERING_WCA);

				sim.setParameter(SIMULATION_CODE_MOBILITY, SC_MOBILITY_RANDOM);

				sim.setParameter(SIMULATION_CODE_ENERGY, SC_ENERGY_4THPOWER);

				sim.setParameter(RECORD_DISTANCES, RECORD_DISTANCES_NO);

				sim.setParameter(TRANSMISSION_RANGE, 50.0);

				sim.setParameter(MAX_DISPLACEMENT, 5);

				sim.setParameter(VISUALIZE, VISUALIZE_NO);

				sim.setStartTime(0);

				sim.setStopTime(2000);

				inputs.add(sim);

			}

			List outputs = Simulation.simulationSet(inputs, Clustering.class,

					ClusteringContext.class);

			outputsToIntegrate.add(outputs);

		}

		List outputs = IntegratedSOP.integrateListOfSops(outputsToIntegrate);

		// plots

		List<PlotLineDescription> list = new ArrayList<PlotLineDescription>();

		list.add(new PlotLineDescription(first, RandomVariable.TYPE_AVG,

				ENERGY_FIRST_NODE_FAILED, RandomVariable.TYPE_AVG,

				"First failed"));

		list.add(new PlotLineDescription(first, RandomVariable.TYPE_AVG,

				ENERGY_PERCENT_NODES_FAILED, RandomVariable.TYPE_AVG,

				"10 percent"));

		SimulationHelper.generatePlotFromPlotDescriptionList(

				"data/clustering/energy_" + first + "_n" + ".m", list, outputs);

	}



	public static void scenarioEnergyConservation()

			throws InstantiationException, IllegalAccessException, IOException {

		TextUi.println(Version.versionString());

		scenarioEnergyW(WCA_W1, WCA_W2, WCA_W3, WCA_W4);

		scenarioEnergyW(WCA_W2, WCA_W1, WCA_W3, WCA_W4);

		scenarioEnergyW(WCA_W3, WCA_W2, WCA_W1, WCA_W4);

		scenarioEnergyW(WCA_W4, WCA_W2, WCA_W3, WCA_W1);

	}



	public static void main(String[] args) throws InstantiationException,

			IllegalAccessException, IOException {

		TextUi.println(Version.versionString());

		//scenarioTransmissionScheduling();

		scenarioClusterHeads();

		//scenarioEnergyConservation();

	}

}