/*
 * Created on Feb 1, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.eel6938.classagents;

import java.awt.Point;

import yaes.application.eel6938.game.Constants;
import yaes.application.eel6938.game.objects.Agent;

/**
 * @author Linus Luotsinen
 *	This agent will kill, eat and flee. It uses path-planning to get around.
 */
public class KillerAgent extends Agent { 

	private int direction = 0;		//Keep track of direction
	private int failCount = 0;		//If command failed too many times a direction switch is needed
	private int successCount = 0;	//If command succeeded too many times a direction switch is needed
	
	/**
	 * 
	 */
	public KillerAgent() {
		super();
	}

	/* (non-Javadoc)
	 * @see yaes.application.eel6938.game.objects.Agent#intelligence()
	 */
	public void intelligence() {
		move(direction, 4);	//Default action.
		
		//Was the last command successful or not?
		if(!wasLastCommandSuccessful())
		{
			failCount++;
		}
		else
		{
			successCount++;
		}
		
		if(failCount % 5 == 0)	//Change direction!
		{
			int oldDirection = direction;
			while(direction == oldDirection) //Make sure we don't move in the same direction
			{
				direction = (int)(Math.random()*Constants.Directions.length);
			}
			this.
			move(direction, 4);
			failCount =  1;
		}
		
		if(successCount % 100 == 0)	//Change direction!
		{
			int oldDirection = direction;
			while(direction == oldDirection) //Make sure we don't move in the same direction
			{
				direction = (int)(Math.random()*Constants.Directions.length);
			}
			move(direction, 4);
			successCount =  1;
		}
		
		//Are there any agents in sensor scope?
		if(getSensorAgentList().length > 1)	//Agents in sight
		{
			//Get second agent element, which is also the closest agent element by default (the first element is this agent)
			Point focusPoint = getSensorAgentList()[1]; 
			Point attackingPosition = getClosestOpenNeighbouringPoint(focusPoint);
			if(attackingPosition != null)
			{
				//Get directions to this element (if possible)
				int[] path = getDirections(attackingPosition);
				if(path != null && path.length > 0)
				{
					successCount =  1;
					move(path[0], (int)(Math.random()*4));	//Follow target with random speed! (Aviods state where equal agents are moving equally)
				}
			}
		}
		else if(this.getSensorFoodList().length > 0)	//Food in sight
		{
			//Get first food element, which is also the closest food element by default
			Point focusPoint = getSensorFoodList()[0]; 
			Point eatingPosition = getClosestOpenNeighbouringPoint(focusPoint);
			if(eatingPosition != null)
			{
				//Get directions to this element (if possible)
				int[] path = getDirections(eatingPosition);
				if(path != null && path.length > 0)
				{	
					successCount =  1;
					move(path[0], 1);
				}
			}
		}
		
		//If can eat, then eat.
		if(canEat())
		{
			eat();
		}
		
		//If can attack, then attack.
		if(canAttack())
		{	
			attack();	
		}
		
		//If can flee, go to panic mode and flee randomly!
		if(canFlee())
		{
			direction = (int)(Math.random()*Constants.Directions.length);
			flee(direction);
		}
	}

	/* (non-Javadoc)
	 * @see yaes.application.eel6938.game.objects.Agent#getName()
	 */
	public String getName() {
		return "KillerAgent";
	}

	/* (non-Javadoc)
	 * @see yaes.application.eel6938.game.objects.Agent#getColor()
	 */
	public int[] getColor() {
		int[] rgb = {255,0,0};
		return rgb;
	}

}
