package yaes.application.eel6938.classagents;

import java.awt.Point;

import yaes.application.eel6938.game.Configuration;
import yaes.application.eel6938.game.Constants;
import yaes.application.eel6938.game.objects.Agent;

/**
 * @author Rex Oleson
 */
public class ROlesonGroupAgent extends Agent 
{
   private double violence;
   private double pfA;
   private double pfB;
   private double pfC;
   private int mateEnergyLevel;
   private int mateRestPeriod;
   private int randomMoveRecycle;
   private int randomRecycleTime;
   private int randomDirection;
   private int maxReproduceTime;
   
    
   public ROlesonGroupAgent() 
   {
      super();

      violence = 5;//Math.random()*10;
      pfA = 1;
      pfB = 1;
      pfC = 1;
      
      randomDirection = Constants.DirectionNorth;
      randomRecycleTime = randomMoveRecycle = 20;      
      mateEnergyLevel = 7000;
      maxReproduceTime = 600;
      mateRestPeriod = (int)(Math.random()*maxReproduceTime);

   }

   public void intelligence()
   {
      Point[] foodPoints = getSensorFoodList();
      updatePersonality();
      if(canEat())
      {
         eat();
         return;
      }
      if( canAttack() )
      {
         attack();
      }
      if( wantsToMate() )
      {
         mate();
         return;
      }
      if( foodPoints.length > 0 )
      {
         moveTowardsFood();
         return;
      }
      moveTowardsGroup();
   }

   private void updatePersonality()
   {
      // define the variables to be used by the method.
      ROlesonGroupAgent bob = new ROlesonGroupAgent();
      Agent influenceingAgent;
      
      int xi;
      int yi;
      double newPersonality; 
      double bobPersonality;
      double bobInfluence;
      double bobDistance;
      double xDis = 0.0;
      double yDis = 0.0;
      double xb;
      double yb;
      newPersonality =0;
      xb = 0;
      yb = 0;
      
      Point[] influenceingAgentsPoints = getSensorAgentList();
      int _numOfInfluencingAgents = influenceingAgentsPoints.length;

      for( int i = 0; i < _numOfInfluencingAgents; i++ )
      {
         if( influenceingAgentsPoints[i].getX() != 0 && influenceingAgentsPoints[i].getY() !=0  )
         {
            
            if( getName( influenceingAgentsPoints[i] ).equals( this.getName() ) )
            {
               bobPersonality = getViolenceRating();
            }
            else
            {
               bobPersonality = 10;
            }
               
            xDis = influenceingAgentsPoints[i].getX();
            yDis = influenceingAgentsPoints[i].getY();

            bobDistance = Math.sqrt(Math.pow((xDis),2)+Math.pow((yDis),2));
            bobInfluence = (1/cosh(Math.pow((bobPersonality-violence),2)))*(bobPersonality-violence);
            newPersonality += (bobInfluence/Math.max( Math.pow( bobDistance, 2 ), 4));
         }
      }
      
      violence = newPersonality;
   
   }

   // calculate the personalityFactor is called by move and is used to create a 
   private double calculatePersonalityFactor( double bobViolence )
   {
      double personalityFactor = 0.0;
      double dP = 0.0;
      
      // now pfA, pfB, and pfC are set in the properties file.
      
      dP = Math.abs(getViolenceRating() - bobViolence);
      
      if( dP <= pfB )
      {
         personalityFactor = -1*(pfA/Math.pow(pfB,2))*Math.pow(dP,2)+pfA;
      }
      else if( dP > pfB )
      {
         personalityFactor = pfC*4/Math.pow(10-pfB,2)*Math.pow((dP-(pfB+(10-pfB)/2)),2)-pfC;
      }
      
      return personalityFactor;
   }

   private void moveTowardsFood()
   {
      Point[] foodPoints = getSensorFoodList();
      Point foodLoc = getClosestPoint(foodPoints);
      
      moveTowards( foodLoc, 1 );
   }

   private void moveTowardsGroup()
   {
      // Shortcut done here defined the local variabels and gave them default values in one step.
      double dX = 0.0;
      double dY = 0.0;
      double bobDistance = 1.0;
      double pF = 1.0;
      double xDis = 0.0;
      double yDis = 0.0;
      int dir=0;
      Agent bob = null;
      int speed = 1;
      
      Point[] influenceingAgentsPoints = getSensorAgentList();
      int _numOfInfluencingAgents = influenceingAgentsPoints.length;

      // Loop through all of the surrounding spaces within the motionInfluenceDistance to calculate the effect of others in that area.
      for( int i = 0; i < _numOfInfluencingAgents; i ++ )
      {
         if( influenceingAgentsPoints[i].getX() != 0 && influenceingAgentsPoints[i].getY() != 0 )
         {
         
            xDis = influenceingAgentsPoints[i].getX();
            yDis = influenceingAgentsPoints[i].getY();
         
            bobDistance = distanceTo( xDis, yDis );
         
            if( getName(influenceingAgentsPoints[i]).equals( this.getName() ) )
            {
               pF = calculatePersonalityFactor( getViolenceRating() );
               speed = 4;
            }
            else
            {
               //fleeFrom( influenceingAgentsPoints[i] );
               pF = calculatePersonalityFactor( 10 );
               speed = 7;
            }

            dX = dX + pF*(xDis)/Math.max(Math.pow(bobDistance, 3),1);
            dY = dY + pF*(yDis)/Math.max(Math.pow(bobDistance, 3),1);
         }
         
         if( dX != 0 && dY != 0  )
         {
            if( Math.abs( dX ) > Math.abs( dY ) )
            {
               if( dX < 0 )
               {
                  dir = Constants.DirectionEast;
               }
               else
               {
                  dir = Constants.DirectionWest;
               }
            }
            else
            {
               if( dY > 0 )
               {
                  dir = Constants.DirectionNorth;
               }
               else
               {
                  dir = Constants.DirectionSouth;
               }
            }
         }
         else
         {
            dir = randomMove();
         }
         moveTowards( dir, speed );
      }
   }

   public String getName()
   {
      return "ROlesonGroupAgent";
   }

   /* (non-Javadoc)
    * @see yaes.application.eel6938.game.objects.Agent#getColor()
    */
   public int[] getColor() 
   {
      int[] rgb = new int[3];
      rgb[0]=255; rgb[1]=0; rgb[2]=255;
      return rgb;
   }

   public double getViolenceRating()
   {
      return violence;
   }

   private double distanceTo( double x, double y )
   {
      double distance = 0;
      
      distance = Math.sqrt( Math.pow ( x, 2 ) + Math.pow ( y, 2 ) );
    
      return distance;
   }
   
   private int randomMove()
   {
      randomMoveRecycle--;
      
      if( randomMoveRecycle == 0 )
      {
         randomMoveRecycle = randomRecycleTime;
         int randomDirVal = (int)(Math.random()*100);
         
         if( randomDirVal <= 25 )
         {
            randomDirection = Constants.DirectionWest;
         }
         else if( randomDirVal <= 50 )
         {
            randomDirection = Constants.DirectionEast;
         }
         else if( randomDirVal <= 75 )
         {
            randomDirection = Constants.DirectionSouth;
         }
         else if( randomDirVal <= 100 )
         {
            randomDirection = Constants.DirectionNorth;
         }
      }
      
      return randomDirection;
   }

   public double cosh( double x )
   {
      return (Math.exp(x) + Math.exp(-1*x))/2;
   }

   private Point getClosestPoint(Point p[]) 
   {
      Point currentPoint = p[0];
      for (int i = 0; i < p.length; i++) 
      {
         if (Math.abs(p[i].x) + Math.abs(p[i].y) < Math.abs(currentPoint.x)
               + Math.abs(currentPoint.y)) 
         {
            currentPoint = p[i];
         }
      }
      return currentPoint;
   }
            
   private boolean moveTowards(Point p, int speed)
   {
      int direction;
      if (p.x == 0 && p.y == 0) 
      {
         return true;
      }
      if (Math.abs(p.x) > Math.abs(p.y)) 
      {
         if( p.x > 0 ) 
         {
            direction = Constants.DirectionEast;
         }
         else
         {
            direction = Constants.DirectionWest;
         }
      }
      else 
      {
         if (p.y > 0) 
         {
            direction = Constants.DirectionNorth;
         }
         else 
         {
            direction = Constants.DirectionSouth;
         }
      }
      
      moveTowards( direction, speed );
      return true;
   }
   
   private boolean moveTowards(int direction, int speed)
   {
      direction = avoidObstacles( direction );
      move( direction, speed );
      return true;
   }


   private int avoidObstacles( int direction )
   {
      if( isDirectionOcupied( direction ) )
      {
         if( direction == Constants.DirectionNorth )
         {
            if( !isDirectionOcupied( Constants.DirectionSouth ) )
            {
               direction = Constants.DirectionSouth;
            }
            else if( !isDirectionOcupied( Constants.DirectionEast ) )
            {
               direction = Constants.DirectionEast;
            }
            else if( !isDirectionOcupied( Constants.DirectionWest ) )
            {
               direction = Constants.DirectionWest;
            }
         }
         else if( direction == Constants.DirectionSouth )
         {
            if( !isDirectionOcupied( Constants.DirectionNorth ) )
            {
               direction = Constants.DirectionNorth;
            }
            else if( !isDirectionOcupied( Constants.DirectionEast ) )
            {
               direction = Constants.DirectionEast;
            }
            else if( !isDirectionOcupied( Constants.DirectionWest ) )
            {
               direction = Constants.DirectionWest;
            }
         }
         else if( direction == Constants.DirectionEast )
         {
            if( !isDirectionOcupied( Constants.DirectionWest ) )
            {
               direction = Constants.DirectionWest;
            }
            else if( !isDirectionOcupied( Constants.DirectionNorth ) )
            {
               direction = Constants.DirectionNorth;
            }
            else if( !isDirectionOcupied( Constants.DirectionSouth ) )
            {
               direction = Constants.DirectionSouth;
            }
         }
         else if( direction == Constants.DirectionWest )
         {
            if( !isDirectionOcupied( Constants.DirectionEast ) )
            {
               direction = Constants.DirectionEast;
            }
            else if( !isDirectionOcupied( Constants.DirectionNorth ) )
            {
               direction = Constants.DirectionNorth;
            }
            else if( !isDirectionOcupied( Constants.DirectionSouth ) )
            {
               direction = Constants.DirectionSouth;
            }
         }
      }
      
      randomDirection = direction;  
      return direction;
      
   }

   private boolean fleeFrom(Point p)
   {

      int direction;
      if (p.x == 0 && p.y == 0) 
      {
         return true;
      }
      if (Math.abs(p.x) > Math.abs(p.y)) 
      {
         if (p.x < 0) 
         {
            direction = Constants.DirectionEast;
         }
         else
         {
            direction = Constants.DirectionWest;
         }
      }
      else 
      {
         if (p.y < 0) 
         {
            direction = Constants.DirectionNorth;
         }
         else 
         {
            direction = Constants.DirectionSouth;
         }
      }
      flee(direction);
      return false;
   }
   
   private boolean isDirectionOcupied( int direction )
   {
      Point[] agents = getSensorAgentList();
      
      if( direction == Constants.DirectionNorth )
      {
         if( obstacleAt( 0, 1 )  || agentAt( 0, 1 ) )
         {
            return true;
         }
      }
      if( direction == Constants.DirectionSouth )
      {
         if( obstacleAt( 0, -1 )  || agentAt( 0, -1 ) )
         {
            return true;
         }
      }
      if( direction == Constants.DirectionEast )
      {
         if( obstacleAt( -1, 0 )  || agentAt( -1, 0 ) )
         {
            return true;
         }
      }
      if( direction == Constants.DirectionWest )
      {
         if( obstacleAt( 1, 0 )  || agentAt( 1, 0 ) )
         {
            return true;
         }
      }
      return false;
   }
   
   private boolean obstacleAt( int x, int y )
   {
      Point[] obstacles = getSensorObstacleList();
            
      for( int i = 0; i < obstacles.length; i++ )
      {
         if( obstacles[i].getX() == x && obstacles[i].getY() == y )
         {
            return true;
         }
      }
      
      return false;
   }
   
   private boolean agentAt( int x, int y )
   {
      Point[] agents = getSensorObstacleList();
            
      for( int i = 0; i < agents.length; i++ )
      {
         if( agents[i].getX() == x && agents[i].getY() == y )
         {
            return true;
         }
      }
      
      return false;
   }
   
   private boolean wantsToMate()
   {
      mateRestPeriod--;
      
      if( !canMate() )
      {
         return false;
      }
      if( getEnergyLevel() > mateEnergyLevel && mateRestPeriod == 0 )
      {
         mateRestPeriod = (int)(Math.random()*maxReproduceTime);
         return true;   
      }
      return false;
   }

}
