/*
 * RuleBased.java
 *
 * Created on March 28, 2005, 4:36 PM
 */

package yaes.application.eel6938.classagents;
import java.awt.Point;
import yaes.application.eel6938.game.Constants;
import yaes.application.eel6938.game.objects.Agent;
import yaes.application.eel6938.classagents.ruleEngine.*;

/**
 *
 * @author johann
 */
public class RuleBased extends Agent{
    
    /** Creates a new instance of RuleBased */
    
    final static int[] color = {33,27,3};
    public final static String realName = "RuleBased";
    String name = "RuleBased";
    Point[][] sensed;
    boolean[] actions;
    int direction;
    java.util.Random r;
    int wander;
    int obstacleA;
    
    Engine civic;
    
    public RuleBased(){
        KnowledgeBase k = new BuildRules().build();
        civic = new Engine(k, this);
        sensed = new Point[3][];
        actions= new boolean[7];
        r = new java.util.Random();
        direction = r.nextInt(4);
        wander = k.wanderSpeed;
        obstacleA = k.obstacleAvoidance;
    }

    public RuleBased(KnowledgeBase k){
        civic = new Engine(k, this);
        sensed = new Point[3][];
        actions= new boolean[7];
        r = new java.util.Random();
        direction = r.nextInt(4);
        wander = k.wanderSpeed;
        obstacleA = k.obstacleAvoidance;
    }
    
    public String getName(){
        return "RuleBased";
    }
    
    public int[] getColor(){
        return color;
    }
    
    public void intelligence(){
        
        
        int i;
        sensed[RC.FOOD]=getSensorFoodList();
        sensed[RC.OBSTACLES]=getSensorObstacleList();
        sensed[RC.AGENTS]=getSensorAgentList();
        for(i=0;i<5;i++){
            if(isBlocked(obstacleA)){
                direction = r.nextInt(4);
            }else{
                break;
            }
        }
        if(wander==0){
            move(direction, r.nextInt(4)+1);
        }else{
            move(direction, wander);
        }
        
        doAction(civic.nextAction(sensed[RC.FOOD], sensed[RC.OBSTACLES], getAgentList(),
                getSensorDataMap(), getActionList()));
    }
    
    public void doAction(int[] acts){
        if(acts == null){
            return;
        }
        switch(acts[0]){
            
            case RC.MOVE:
                moveTowardPoint(new Point(acts[1],acts[2]),acts[3]);
                break;
            case RC.ATTACK:
                attack(acts[1]);
                break;
            case RC.EAT:
                eat();
                break;
            case RC.FLEE:
                direction = acts[1];
                for(int i=0;i<4;i++){
                    if(!isBlocked(6)){
                        break;
                    }else{
                        direction= (direction+1)%4;
                    }
                }
                flee(direction);
                break;
            case RC.MATE:
                mate();
                break;
        }
    }
    
    private SensedAgent[] getAgentList(){
        int i;
        Point p;
        SensedAgent[] aList = new SensedAgent[sensed[RC.AGENTS].length];
        for(i=0;i<aList.length;i++){
            p=sensed[RC.AGENTS][i];
            aList[i]=new SensedAgent(getId(p),getEnergyLevel(p),getName(p),p);
        }
        return aList;
    }
    
    private boolean[] getActionList(){
        actions[RC.FLEE]= canFlee();
        actions[RC.MATE]= canMate();
        actions[RC.ATTACK]= canAttack();
        actions[RC.EAT]=canEat();
        return actions;
    }
   
    
    private void moveTowardPoint(Point p, int s){
        int speed;
        if(Math.abs(p.x)>Math.abs(p.y)){
            if(!(moveX(p,s))){
                if(!(moveY(p,s))){
                    if(p.y>0){
                        move(Constants.DirectionSouth,4);
                    }else{
                        move(Constants.DirectionNorth,4);
                    }
                }
            }
            
        }else{
            if(!(moveY(p,s))){
                if(!(moveX(p,s))){
                    if(p.x>0){
                        move(Constants.DirectionWest,4);
                    }else{
                        move(Constants.DirectionEast,4);
                    }
                }
            }
        }
    }

    private boolean moveX(Point p, int speed){
        int s;
        if(p.x>0){
            direction = Constants.DirectionEast;
            if(isBlocked(Math.abs(p.x))){
                return false;
            }
            s = (Math.abs(p.x/2))+1;
        }else{
            direction = Constants.DirectionWest;
            if(isBlocked(Math.abs(p.x))){
                return false;
            }
            s = (Math.abs(p.x/2))+1;
        }
        if(speed!=-1 && speed<=p.x){
            s = speed;
        }
        move(direction,s);
        return true;
    }
    
    private boolean moveY(Point p, int speed){
        int s;
        if(p.y>0){
            direction = Constants.DirectionNorth;
            if(isBlocked(Math.abs(p.y))){
                return false;
            }
            s = (Math.abs(p.y/2))+1;
        }else{
            direction = Constants.DirectionSouth;
            if(isBlocked(Math.abs(p.y))){
                return false;
            }
            s = (Math.abs(p.y/2))+1;
        }
        if(speed!=-1&&speed<=p.x){
            s = speed;
        }
        move(direction,s);
        return true;
    }
    
    private boolean isBlocked(int d){
        int i;
        int[][] sensorMap=getSensorDataMap();
        if(d>18){
            d=18;
        }
        switch(direction){
            case Constants.DirectionEast:
                d= d+21;
                for(i=21;i<d;i++){
                    if(sensorMap[i][20]==3){
                        return true;
                    }
                }
                if(sensorMap[21][20]==2){
                    return true;
                }
                break;
            case Constants.DirectionNorth:
                d = 19-d;
                for(i=19;i>d;i--){
                    if(sensorMap[20][i]==3){
                        return true;
                    }
                }
                if(sensorMap[20][21]==2){
                    return true;
                }
                break;
            case Constants.DirectionSouth:
                d=21+d;
                for(i=21;i<d;i++){
                    if(sensorMap[20][i]==3){
                        return true;
                    }
                }
                if(sensorMap[20][19]==2){
                    return true;
                }
                break;
            case Constants.DirectionWest:
                d=19-d;
                for(i=19;i>d;i--){
                    if(sensorMap[i][20]==3){
                        return true;
                    }
                }
                if(sensorMap[19][20]==2){
                    return true;
                }
                break;
        }
        return false;
    }
    
    public void disguise(String mask){
        name = mask;
    }
    
    private double distance(Point a, Point b){
        int x = a.x-b.x;
        int y = a.y-b.y;
        return (x*x+y*y);
    }
}
