/*
 * Created on Mar 25, 2005
 *
 */
package yaes.application.eel6938.classagents.cxbr;

import java.awt.Point;

import yaes.application.eel6938.game.Constants;
import yaes.application.eel6938.game.objects.Agent;

/**
 * This class represents the AttackContext
 * @author Viet Trinh
 *
 */
public class AttackContext extends CxBR_Context 
{
	private boolean _same_context = false;
	private Point _enemy = null;
	private Point _last_point = null;
	
	/**
	 * Constructor
	 * @param name Name of the Agent
	 * @param a Agent
	 * @param m Map
	 */
	public AttackContext(String name, Agent a, CxBR_Map m) 
	{
		super(name, a, m);
	}

	@Override
	public void execute() 
	{
		if (this._same_context)
			this._last_point = this._enemy;
		this._enemy = this.canAttack(false);
		this._attack(this._enemy);
	}

	/**
	 * Use this function to attack and enemy
	 * @param enemy The relative point where the enemy if located
	 * @return true is it attacks, false if it is moving towards an enemy
	 */
	private boolean _attack(Point enemy)
	{
		int x = enemy.x;
		int y = enemy.y;
		
		if (x == 0 && y == 0) 		{ this._agent.attack(); return true; }
		else if (x == 1 && y == 0) 	{ this._agent.attack(Constants.DirectionEast);  return true; }
		else if (x == -1 && y == 0) { this._agent.attack(Constants.DirectionWest);  return true; }
		else if (x == 0 && y == 1)  { this._agent.attack(Constants.DirectionNorth); return true; }
		else if (x == 0 && y == -1) { this._agent.attack(Constants.DirectionSouth); return true; }
		else  						{ this._move_towards(enemy); return false; }
	}
	
	@Override
	public String executeSentinelRules() 
	{
		if (this.canAttack(false) != null)
		{
			this._same_context = true;
			return this._name;
		}
		else
		{
			this._same_context = false;
			return "ExploreContext";
		}
	}
	
	@Override
	public int[] getColor()
	{
		//Red
		int[] rgb = new int[3];
		rgb[0]=205; rgb[1]=0; rgb[2]=0; 
		return rgb;
	}
}
