/*
 * Created on Mar 25, 2005
 *
 */
package yaes.application.eel6938.classagents.cxbr;

import yaes.application.eel6938.game.objects.Agent;

/**
 * This class represents the BackTrackContext
 * @author Viet Trinh
 *
 */
public class BackTrackContext extends CxBR_Context 
{
	private Move _last_move = null;
	private boolean _same_context = false;
	
	/**
	 * Constructor
	 * @param name Name of the Agent
	 * @param a Agent
	 * @param m Map
	 */
	public BackTrackContext(String name, Agent a, CxBR_Map m) 
	{
		super(name, a, m);
	}

	@Override
	public void execute() 
	{
		//this._map.printMoveTrace();
		int direction;
		
		//Pop the last backtracking move
		if (this._same_context)
			this._last_move = this._map.getLastMove();
		this._last_move = this._map.getLastMove();
		
		//No more backtracking, time to move in the same direction
		if (this._last_move == null)
		{
			direction = this._map.getDirection(); 
			if (this.move(direction, this._map.getSpeed()) == false)
			{
				direction = this._map.getClearDirection(direction, this._map.getSpeed());
				this.move(direction, this._map.getSpeed());
			}
		}
		else
		{
			int speed = this._last_move.getSpeed(); //this._last_move.getSpeed();
			direction = this._map.getOppositeDirection(this._last_move.getDirection());
			this.move(direction, speed);
		}
	}

	@Override
	public String executeSentinelRules() 
	{
		this._same_context = false;
		if (this.canEat())
			return "EatContext";
		else if (this.canAttack(true) != null)
			return "AttackContext";
		else if (this.canAvoid() != -1)
			return "AvoidContext";
		else if (this.canExplore() || this.canBackTrack() == false)
			return "ExploreContext";
		else
		{
			this._same_context = true;
			return this._name;
		}
	}
	
	@Override
	public int[] getColor()
	{
		//Black
		int[] rgb = new int[3];
		rgb[0]=255; rgb[1]=127; rgb[2]=0; 
		return rgb;
	}
}
