/*
 * Created on Mar 25, 2005
 *
 */
package yaes.application.eel6938.classagents.cxbr;

import yaes.application.eel6938.game.objects.Agent;

/**
 * This class represents the ExploreContext
 * @author Viet Trinh
 *
 */
public class ExploreContext extends CxBR_Context 
{
	/**
	 * Constructor
	 * @param name Name of the Agent
	 * @param a Agent
	 * @param m Map
	 */
	public ExploreContext(String name, Agent a, CxBR_Map m) 
	{
		super(name, a, m);
	}

	@Override
	public void execute() 
	{
		int speed = this._map.getSpeed();
		int direction = this._map.getDirection();
		//Check if the direction straight ahead needs exploration
		if (this._map.canExploreDirection(direction))
		{
			if (this.move(direction, speed) == false)
			{
				//direction = this._map.getExplorationDirection();
				direction = this._map.getClearDirection(direction, speed);
				this.move(direction, speed);
			}
		}
		//If not, then explore in another direction
		else
		{
			//There has to be a direction to explore because the agent is in the ExploreContext
			direction = this._map.getExplorationDirection();
			if (direction == -1)
				direction = this._map.getDirection();
			if (this.move(direction, speed) == false)
			{
				//direction = this._map.getExplorationDirection();
				direction = this._map.getClearDirection(direction, speed);
				this.move(direction, speed);
			}
		}
		//System.out.println(direction);
	}

	@Override
	public String executeSentinelRules() 
	{
		if (this.canEat())
			return "EatContext";
		else if (this.canAttack(true) != null)
			return "AttackContext";
		else if (this.canAvoid() != -1)
			return "AvoidContext";
		else if (this.canExplore() == false && this._map.isMaxSpeed() == false && this.canBackTrack())
			return "BackTrackContext";
		else
			return this._name;
	}
	
	@Override
	public int[] getColor()
	{
		//Black
		int[] rgb = new int[3];
		rgb[0]=20; rgb[1]=20; rgb[2]=20; 
		return rgb;
	}
}
