package yaes.application.eel6938.classagents.expertagent;

import java.util.Vector;

import yaes.application.eel6938.game.Constants;

public class AgentHistory {
	private int agentID;
	private String agentName;
	private int[] agentBehavior;
	private int likelyAgentBehavior;
	private int behaviorIndex;
	private static final int Maximum_Behavior = 400;
	
	public AgentHistory() {
		agentBehavior = new int[Maximum_Behavior];
		behaviorIndex = 0;
		for (int i=0; i<Maximum_Behavior; i++)
			agentBehavior[i] = -1;
	}
	public static void main(String[] args) {
		AgentHistory ah = new AgentHistory();
		ah.setAgentBehavior(Constants.CommandAttack);
		ah.setAgentBehavior(Constants.CommandMate);
		ah.setAgentBehavior(Constants.CommandMate);
		ah.setAgentBehavior(Constants.CommandFlee);
		ah.setAgentBehavior(Constants.CommandAttack);
		//System.out.println(ah.getLikelyAgentBehavior());
	}
	
	public void setAgentBehavior(int actionType) {
		agentBehavior[behaviorIndex] = actionType;
		behaviorIndex = (behaviorIndex + 1)%Maximum_Behavior;
	}
	
	public int getAgentID() {
		return agentID;
	}
	
	public void setAgentID(int agentID) {
		this.agentID = agentID;
	}
	
	public String getAgentName() {
		return agentName;
	}
	
	public void setAgentName(String agentName) {
		this.agentName = agentName;
	}
	
	public int getLikelyAgentBehavior() {
		//System.out.println(this);
		likelyAgentBehavior = getLikelyBehavior();
		return likelyAgentBehavior;
	}
	public String toString() {
		String returnValue = "";
		for (int i=0; i<Maximum_Behavior; i++) {
			if (agentBehavior[i] == -1) continue;
			returnValue += "  " + agentBehavior[i];
		}
		returnValue += "\r\n";
		return returnValue;
	}
	private int getLikelyBehavior() {
		int max_number=0, max_id=Constants.CommandNone;
		
		int[] numberOfTimes = new int[6];
		for(int i=0; i<Maximum_Behavior; i++) {
			if (agentBehavior[i] == -1) continue;
			numberOfTimes[agentBehavior[i]]++;
		}
		
		for (int j=0; j<6; j++) {
			if (numberOfTimes[j]>=max_number) {
				max_number = numberOfTimes[j];
				max_id = j;
			}
		}
		return max_id;
	}
	public double getLikelinessOf(int action) {
		double sum_total=0, sum_action=0;
		
		for(int i=0; i<Maximum_Behavior; i++) {
			if (agentBehavior[i] == -1) continue;
			if (agentBehavior[i] == action) sum_action++;
			sum_total++;
		}
		if (sum_total == 0) return 0;
		return sum_action/sum_total;
	}
	

}
