package yaes.application.eel6938.classagents.expertagent;
/* Author: Majid Ali Khan
 * Dated: 04-01-2005
*/
import yaes.application.eel6938.game.Constants;
/*
 * This class represents one step in the game.
 * It contains the map of that step alongwith some useful
 * information. It can be modified to extract other useful information
 * contained in the map.
 */
public class Step {
	private LocalMap m_map;
	private long m_id; 
	public Step(long id, LocalMap map) {
		m_id = id;
		m_map = map;
	}
	public int getNumberOfAgents() {
		return m_map.getNumberOfAgents();
	}
	public int getNumberOfFood() {
		return m_map.getNumberofFood();
	}
	public int getNumberOfAgents(int direction) {
		return m_map.getNumberOfEntites(direction, Constants.ContentAgent);
	}
	public int getNumberOfFood(int direction) {
		return m_map.getNumberOfEntites(direction, Constants.ContentFood);
	}
	public LocalMap getLocalMap() {
		return m_map;
	}
	public String toString() {
		String returnValue = "";
		if (m_map == null)
			returnValue = "Step:"+ m_id + "\r\n";
		else
			returnValue = "Step:"+ m_id +
				"; North:" + getNumberOfAgents(Constants.DirectionNorth) + ","+ getNumberOfFood(Constants.DirectionNorth)+ 
				"; South:" + getNumberOfAgents(Constants.DirectionSouth) + ","+ getNumberOfFood(Constants.DirectionSouth)+
				"; East:" + getNumberOfAgents(Constants.DirectionEast) + ","+ getNumberOfFood(Constants.DirectionEast)+
				"; West:" + getNumberOfAgents(Constants.DirectionWest) + ","+ getNumberOfFood(Constants.DirectionWest)+
				"\r\n";
		return returnValue;
	}
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
