package yaes.application.eel6938.classagents.expertagent;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Iterator;

public class UtilityPlotter {

	/**
	 * @param args
	 */
	double[] xPoints;
	double[] yPoints;
	double[][] zPoints;

	public UtilityPlotter() {
		
	}
	private String getXValuesString() {
		String val = "xvalues = [";
		for (int i = 0; i < xPoints.length; i++) {
			val += xPoints[i] + " ";
		}
		val += "]\n";
	    return val;
	 }

	private String getYValuesString() {
		String val = "yvalues = [";
		for (int i = 0; i < yPoints.length; i++) {
			val += yPoints[i] + " ";
		}
		val += "]\n";
	    return val;		
	}

	private String getZValuesString() {
		String val = "zvalues = [";
			for (int j = 0; j < yPoints.length; j++) {
				for (int i = 0; i < xPoints.length; i++) {				
					val += zPoints[i][j] + " ";
				}
				val += ";";
			}

		
		val += "]\n";
	    return val;		
	}
	
	private void generateValues() {
		double value = 0;
		int i=0, j=0;
		xPoints = new double[10];
		yPoints = new double[200];
		zPoints = new double[10][200];
		for (i=0; i<10; i++) {
			xPoints[i] = value;
			value = value + 0.10;
			//System.out.println(value);
		}
		value = -100;
		for (i=0; i<200; i++) {
			yPoints[i] = value;
			value = value + 10;
		}
		value = 0;
		for (i=0; i<10; i++) {
			for (j=0; j<200; j++) {
				zPoints[i][j] = (1- xPoints[i]) * 100 - yPoints[j] * 0.1; 
			}
		}
		
	}
	public void generateUtilityPlot(String title, String fileName) throws IOException{
		generateValues();
		StringBuffer buffer = new StringBuffer();
		buffer.append(getXValuesString());
		buffer.append(getYValuesString());
		buffer.append(getZValuesString());
		buffer.append("hold off\n");
		
		buffer.append("mesh(xvalues,yvalues,zvalues)\n");

		buffer.append("title('" + title + "')\n");
		buffer.append("xlabel('Probability of Attack')\n");
		buffer.append("ylabel('Difference in Strength')\n");
		buffer.append("zlabel('Utility')\n");
		
	    FileOutputStream out = new FileOutputStream(fileName);
	    PrintWriter pw = new PrintWriter(out);
	    pw.write(buffer.toString());
	    pw.close();
	    out.close();
		//System.out.println("Done.");
	}
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		UtilityPlotter up = new UtilityPlotter();
		try {
			up.generateUtilityPlot("Utility for Flee vs Flee","utilityFF.m");
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

}
