/*
 * BuildRules.java
 *
 * Created on April 4, 2005, 1:18 PM
 */

package yaes.application.eel6938.classagents.ruleEngine;

/**
 *
 * @author johann
 */
public class BuildRules {
    
    java.util.ArrayList rules;
    /** Creates a new instance of BuildRules */
    public BuildRules() {
        rules = new java.util.ArrayList();
    }
    
    public KnowledgeBase build(){
        
        KnowledgeBase facts = new KnowledgeBase();
        Rule tempRule;
        
        facts.wanderSpeed = 0;
        facts.obstacleAvoidance = 10;
        
        tempRule = new Rule(RC.AGENTS, 0);
        tempRule.setAction(new int[]{RC.AGGRESSIVE,33,29});
        add(tempRule);
        
        tempRule = new Rule(RC.AGENTS,20);
        tempRule.setAction(new int[]{RC.FLOCK});
        add(tempRule);
        
        tempRule = new Rule(new int[]{RC.ATTACK}, new String[]{"FLOCK"},30);
        tempRule.setAction(new int[]{RC.ATTACK,0});
        add(tempRule);
        
        tempRule = new Rule(new int[]{RC.ATTACK}, new String[]{"AGGRESSIVE"},40);
        tempRule.setAction(new int[]{RC.ATTACK,0});
        add(tempRule);
        
        tempRule = new Rule(new int[]{RC.ATTACK}, new String[] {"DOUBLEAGENT"},35);
        tempRule.setAction(new int[]{RC.ATTACK,0});
        add(tempRule);
        
        tempRule = new Rule(new int[]{RC.FLEE}, new String[]{"DOUBLEAGENT"},90);
        tempRule.setAction(new int[]{RC.FLEE,0});
        add(tempRule);
        
        tempRule = new Rule(new int[]{RC.FLEE, RC.MATE}, 50);
        tempRule.setAction(new int[]{RC.MATE});
        add(tempRule);
        
        tempRule = new Rule(new int[]{RC.FLEE}, new String[]{"WUSSY"},60);
        tempRule.setAction(new int[]{RC.FLEE,0});
        add(tempRule);
        
        tempRule = new Rule(new int[]{RC.AGENTS}, new String[]{"AGGRESSIVE"},70);
        tempRule.setAction(new int[]{RC.MOVE,0,0,4,RC.TOENEMY});
        add(tempRule);
        
        tempRule = new Rule(new int[]{RC.AGENTS}, new String[]{"FLOCK"},80);
        tempRule.setAction(new int[]{RC.MOVE,0,0,4,RC.TOENEMY});
        add(tempRule);

        tempRule = new Rule(new int[]{RC.AGENTS}, new String[]{"DOUBLEAGENT"},75);
        tempRule.setAction(new int[]{RC.MOVE,0,0,4,RC.TOENEMY});
        add(tempRule);
        
        tempRule = new Rule(new int[]{RC.AGENTS}, new String[]{"WUSSY"},90);
        tempRule.setAction(new int[]{RC.MOVE,0,0,4,RC.AVOIDENEMY});
        add(tempRule);
        
        tempRule = new Rule(RC.FOOD,100);
        tempRule.setAction(new int[]{RC.MOVE,0,0,-1,RC.TOFOOD});
        add(tempRule); 
        
        tempRule = new Rule(RC.EAT,110);
        tempRule.setAction(new int[]{RC.EAT});
        add(tempRule);
        
        tempRule = new Rule(new int[]{RC.AGENTS},new String[]{"FLOCK"},120);
        tempRule.setAction(new int[]{RC.MOVE,0,0,4,RC.FLOCK});
        add(tempRule);
        
        tempRule = new Rule(new int[]{},10);
        tempRule.setAction(new int[]{RC.DOUBLEAGENT});
        add(tempRule);
        
        facts.addRules(rules);
        return facts;
    }
    
    public KnowledgeBase build(int[] ps){
        
        
        KnowledgeBase facts = new KnowledgeBase();
        Rule tempRule;
        if(ps[12]==1){
            facts.add("GREEDY");
        }
        
        facts.wanderSpeed = ps[0];
        facts.obstacleAvoidance = ps[1];
        
        
        //aggressive nature
        tempRule = new Rule(RC.AGENTS, 3);
        tempRule.setAction(new int[]{RC.AGGRESSIVE,ps[2],ps[3]});
        add(tempRule);
        
        //flocking nature
        tempRule = new Rule(RC.AGENTS,ps[16]);
        tempRule.setAction(new int[]{RC.FLOCK});
        add(tempRule);
        
        //always attack when in a flock
        tempRule = new Rule(new int[]{RC.ATTACK}, new String[]{"FLOCK"},ps[4]);
        tempRule.setAction(new int[]{RC.ATTACK,0});
        add(tempRule);
        
        //attack
        tempRule = new Rule(new int[]{RC.ATTACK}, new String[]{"AGGRESSIVE"},ps[5]);
        tempRule.setAction(new int[]{RC.ATTACK,0});
        add(tempRule);
        
        //flee
        tempRule = new Rule(new int[]{RC.FLEE}, new String[]{"WUSSY"},ps[6]);
        tempRule.setAction(new int[]{RC.FLEE,0});
        add(tempRule);
        
        //toward enemy
        tempRule = new Rule(new int[]{RC.AGENTS}, new String[]{"AGGRESSIVE"},ps[8]);
        tempRule.setAction(new int[]{RC.MOVE,0,0,ps[7],RC.TOENEMY});
        add(tempRule);
        
        //flock attack
        tempRule = new Rule(new int[]{RC.AGENTS}, new String[]{"FLOCK"},ps[10]);
        tempRule.setAction(new int[]{RC.MOVE,0,0,ps[9],RC.TOENEMY});
        add(tempRule);
        
        //avoid enemy
        tempRule = new Rule(new int[]{RC.AGENTS}, new String[]{"WUSSY"},ps[11]);
        tempRule.setAction(new int[]{RC.MOVE,0,0,4,RC.AVOIDENEMY});
        add(tempRule);
        
        //to food
        tempRule = new Rule(RC.FOOD,ps[14]);
        tempRule.setAction(new int[]{RC.MOVE,0,0,ps[13],RC.TOFOOD});
        add(tempRule); 
        
        //eat
        tempRule = new Rule(RC.EAT,ps[17]);
        tempRule.setAction(new int[]{RC.EAT});
        add(tempRule);
        
        //flocking
        tempRule = new Rule(new int[]{RC.AGENTS},new String[]{"FLOCK"},ps[16]);
        tempRule.setAction(new int[]{RC.MOVE,0,0,ps[15],RC.FLOCK});
        add(tempRule);
        facts.addRules(rules);
        return facts;
    }
    
    private void add(Rule r){
        Rule temp;
        int i;
        
        rules.add(r);
        for(i=rules.size()-1;i>0;i--){
            temp = (Rule)rules.get(i);
            if(((Rule)rules.get(i-1)).salience>temp.salience){
                rules.set(i,rules.get(i-1));
                rules.set(i-1,temp);
            }else{
                return;
            }
        }
    }
    
     public static int[] parseParams(boolean[] ps){
        int[] params = new int[18];
        int i, b, e, factor;
        int temp=0;
        int n = 0;
        
        //wander
        b=0;
        e=1;
        for(i=b, factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }
        params[n]=temp;
        
        n++;
        temp=0;

        //obstacle avoidance
        b=2;
        e=5;
        for(i=b, factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }
        params[n]=temp+1;
        n++;
        temp=0;
        
        //aggressive self
        b=6;
        e=9;
        for(i=b, factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }
        if(temp==0){
            params[n]=0;
        }else{
            params[n]=temp+3;
        }
        n++;
        temp=0;
        
        //aggressive enemy
        b=10;
        e=13;
        for(i=b, factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }
        if(temp==0){
            params[n]=0;
        }else{
            params[n]=temp+3;
        }
        n++;
        temp=0;
        
        //flock attack
        b=14;
        e=18;
        for(i=b, factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }
        params[n]=temp;
        n++;
        temp=0;
        
        //attack
        b=19;
        e=23;
        for(i=b, factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }
        params[n]=temp;
        n++;
        temp=0;
        
        //flee
        b=24;
        e=28;
        for(i=b, factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }
        params[n]=temp;
        n++;
        temp=0;
        
        //toward enemy speed
        if(ps[29]){
            params[n]=4;
        }else{
            params[n]=-1;
        }
        n++;
        temp=0;
        
        //towards enemy
        b=30;
        e=34;
        for(i=b,factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }
        params[n]=temp;
        n++;
        temp=0;
        
        //flock attack speed
        if(ps[35]){
            params[n]=4;
        }else{
            params[n]=-1;
        }
        n++;
        temp=0;
        
        //flock attack
        b=36;
        e=40;
        for(i=b, factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }
        params[n]=temp;
        n++;
        temp=0;
        
        //avoid enemy
        b=41;
        e=45;
        for(i=b, factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }
        params[n]=temp;
        n++;
        temp=0;
        
        //greedy
        if(ps[46]){
            params[n]=1;
        }else{
            params[n]=0;
        }
        n++;
        temp=0;
        
        //move to food
        b=47;
        e=48;
        for(i=b, factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }
        if(temp==0){
            params[n]=-1;
        }else{
            params[n]=temp+1;
        }
        params[n]=4;
        n++;
        temp=0;
        
        //avoid enemy
        b=49;
        e=53;
        for(i=b, factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }
        params[n]=temp;
        n++;
        temp=0;
        
        //flocking
        if(ps[54]){
            params[n]=4;
        }else{
            params[n]=-1;
        }
        n++;
        temp=0;
        
        //flocking
        b=55;
        e=59;
        for(i=b, factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }

        params[n]=temp;
        temp=0;
        n++;
        
        //eating
        b=60;
        e=64;
        for(i=b, factor=1;i<=e;i++){
            if(ps[i]){
                temp= temp+factor;
            }
            factor = factor*2;
        }
        params[n]=temp;
        
        return params;
    }
     
     public static int[] parseParams(String s){
         boolean[] p = new boolean[s.length()];
         int i;
         for(i=0;i<p.length;i++){
             if(s.charAt(i)=='1'){
                 p[i]=true;
             }else{
                 p[i]=false;
             }
         }
         return parseParams(p);
         
     }
    
    
}
