/*
 * Created on Jan 27, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.eel6938.game;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Properties;

/**
 * @author Linus Luotsinen
 *
 * This file configures the game.
 */
public abstract class Configuration {
	//Agents to run (simply add to the list for more agents in the game)
	public static String AgentClassPath;
	public static String [] Agents;
	
	//General Application Settings
	public static String AppResourcesPath;
	public static String AppConfigurationPath;
	public static String AppName;
	public static String AppImagePath;
	public static String AppIconPath;
	public static int AppWindowWidth;
	public static int AppWindowHeight;
	public static int AppSceneWidth;
	public static int AppSceneHeight;
	public static int AppMaxCycles;
	public static float AppFps;
	public static boolean AppDrawGUI;				//For fastest execution set this to false and FPS to 0
    public static int AppGUIRepaintRate;
    public static boolean AppConsolePrint;	
	public static int AppConsolePrintProgress;
    
    public static String AppLogPath;
    public static boolean AppLogAgentData;
    public static String AppLogStatisticsClassPath;
    public static String AppLogStatisticsPath;
    public static String []AppLogStatistics;
    public static String []AppLogGroupStatistics;
    
	//Energy Specific Settings
	public static int EnergyInitialPopulation;		//Initial energy population
	public static int EnergyMaxPopulation;			//Maximum energy population
	public static int EnergyPopulationIncrease;		//How many energy agents to increase with (see increase step)
	public static int EnergyPopulationIncreaseStep;	//Increase step
	public static int EnergyMaxLevel;				//Maximum/initial energy level
	public static int EnergyMinLevel;				//Minimum/empty energy level
	public static boolean EnergyRemoveWhenEmpty;	//Remove energy unit from game when empty?
	public static boolean EnergyShowPercentage;		//Show energy percentage

	//Agent Specific Settings
	public static int AgentInitialEnergyLevel;	//Initial energy level
	public static int AgentMinEnergyLevel; 		//Minimum energy for processing
	public static int AgentProcessCost; 		//Processing cost
	public static int AgentFleeSpeed; 			//Flee speed (Penalty = speed*speed)
	public static int AgentFleeCycles; 			//Number of flee cycles 
	public static int AgentMaxSpeed;			//Maximum move speed (Penalty = speed*speed)
	public static int AgentMinSpeed;			//Minimum move speed (Penalty = speed*speed)
	public static int AgentMaxFoodReward; 		//Maximum food intake
	public static int AgentInitialSensorRange; 	//Sensor range (area = range*range)
	public static int AgentMateCost;			//Mating cost
	public static float AgentOffspringReward;	//Percentage of energy gained from childs total energy income
	public static int AgentAttackCost;			//Attacking cost
	public static int AgentAttackedCost;		//Being attacked cost
	public static int AgentAttackedKillCycles;	//If attacked agent dies within this cycle frame he is considered being killed by the attacking agent
	public static float AgentKilledReward;		//If agent is killed then gain this percentage of its total income
	
	
	
	public static void SaveToPropertiesFile(Properties p, String filePath)
	{
		//System.out.println("Saving...");
		File propsFile = new File(filePath);
		try {
			propsFile.createNewFile();
			p.store(new FileOutputStream(propsFile), "Game Configuration");
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public static Properties LoadFromPropertiesFile(String filePath)
	{
		//System.out.println("Loading...");
		Properties prop = new Properties();
	 	try 
		{
	 		File propsFile = new File(filePath);
			prop.load(new FileInputStream(filePath));
			Configuration.AppConfigurationPath = filePath;
		} 
	 	catch (FileNotFoundException e) 
		{
			e.printStackTrace();
		}
	 	catch (IOException e) 
		{
			e.printStackTrace();
		}
	 	return prop;
	}
	
	public static Properties LoadFromPropertiesFile(Properties defaultProps, String filePath)
	{
		Properties prop = new Properties(defaultProps);
	 	try 
		{
	 		File propsFile = new File(filePath);
			prop.load(new FileInputStream(filePath));
			Configuration.AppConfigurationPath = filePath;
			return prop;
		} 
	 	catch (FileNotFoundException e) 
		{
			e.printStackTrace();
		} 
	 	catch (IOException e) 
		{
			e.printStackTrace();
		}
	 	return prop;
	}
	
	public static void UpdateConfiguation(Properties p)
	{
		//System.out.println("Updating...");
		//Agent lists
		Configuration.AgentClassPath = (String)p.getProperty("AgentClassPath").trim();
        Configuration.Agents = GetPropertyArray(p, "Agents");
        
		//Application settings
		Configuration.AppName = (String)p.getProperty("AppName").trim();
		Configuration.AppResourcesPath = (String)p.getProperty("AppResourcesPath").trim();
		//Configuration.AppConfigurationPath = (String)p.getProperty("AppConfigurationPath").trim();
		Configuration.AppImagePath = (String)p.getProperty("AppImagePath").trim();
		Configuration.AppIconPath = (String)p.getProperty("AppIconPath").trim();
		Configuration.AppWindowWidth = Integer.parseInt((String)p.getProperty("AppWindowWidth"));
		Configuration.AppWindowHeight = Integer.parseInt((String)p.getProperty("AppWindowHeight"));
		Configuration.AppSceneWidth = Integer.parseInt((String)p.getProperty("AppSceneWidth"));
		Configuration.AppSceneHeight = Integer.parseInt((String)p.getProperty("AppSceneHeight"));
		Configuration.AppMaxCycles = Integer.parseInt((String)p.getProperty("AppMaxCycles"));
		Configuration.AppFps = Float.parseFloat((String)p.getProperty("AppFps"));
		Configuration.AppDrawGUI = Boolean.valueOf((String)p.getProperty("AppDrawGUI")).booleanValue();
        Configuration.AppGUIRepaintRate = Integer.parseInt((String)p.getProperty("AppGUIRepaintRate"));
        Configuration.AppConsolePrint = Boolean.valueOf((String)p.getProperty("AppConsolePrint")).booleanValue();
		Configuration.AppConsolePrintProgress = Integer.parseInt((String)p.getProperty("AppConsolePrintProgress"));	
        Configuration.AppLogPath = (String)p.getProperty("AppLogPath").trim();
        Configuration.AppLogAgentData = Boolean.valueOf((String)p.getProperty("AppLogAgentData")).booleanValue();
        Configuration.AppLogStatisticsClassPath = (String)p.getProperty("AppLogStatisticsClassPath").trim();
        Configuration.AppLogStatisticsPath = (String)p.getProperty("AppLogStatisticsPath").trim();
        Configuration.AppLogStatistics  = GetPropertyArray(p, "AppLogStatistics");
        Configuration.AppLogGroupStatistics  = GetPropertyArray(p, "AppLogGroupStatistics");
        
		//Energy settings
		Configuration.EnergyInitialPopulation = Integer.parseInt((String)p.getProperty("EnergyInitialPopulation"));
		Configuration.EnergyMaxPopulation = Integer.parseInt((String)p.getProperty("EnergyMaxPopulation"));
		Configuration.EnergyPopulationIncrease = Integer.parseInt((String)p.getProperty("EnergyPopulationIncrease"));
		Configuration.EnergyPopulationIncreaseStep = Integer.parseInt((String)p.getProperty("EnergyPopulationIncreaseStep"));
		Configuration.EnergyMaxLevel = Integer.parseInt((String)p.getProperty("EnergyMaxLevel"));
		Configuration.EnergyMinLevel = Integer.parseInt((String)p.getProperty("EnergyMinLevel"));		
		Configuration.EnergyRemoveWhenEmpty = Boolean.valueOf((String)p.getProperty("EnergyRemoveWhenEmpty")).booleanValue();
		Configuration.EnergyShowPercentage = Boolean.valueOf((String)p.getProperty("EnergyShowPercentage")).booleanValue();

		//Agent Specific Settings
		Configuration.AgentInitialEnergyLevel = Integer.parseInt((String)p.getProperty("AgentInitialEnergyLevel"));
		Configuration.AgentMinEnergyLevel = Integer.parseInt((String)p.getProperty("AgentMinEnergyLevel"));
		Configuration.AgentProcessCost = Integer.parseInt((String)p.getProperty("AgentProcessCost"));
		Configuration.AgentFleeSpeed = Integer.parseInt((String)p.getProperty("AgentFleeSpeed"));
		Configuration.AgentFleeCycles = Integer.parseInt((String)p.getProperty("AgentFleeCycles"));
		Configuration.AgentMaxSpeed = Integer.parseInt((String)p.getProperty("AgentMaxSpeed"));
		Configuration.AgentMinSpeed = Integer.parseInt((String)p.getProperty("AgentMinSpeed"));
		Configuration.AgentMaxFoodReward = Integer.parseInt((String)p.getProperty("AgentMaxFoodReward"));
		Configuration.AgentInitialSensorRange = Integer.parseInt((String)p.getProperty("AgentInitialSensorRange"));
		Configuration.AgentMateCost = Integer.parseInt((String)p.getProperty("AgentMateCost"));
		Configuration.AgentOffspringReward = Float.parseFloat((String)p.getProperty("AgentOffspringReward"));
		Configuration.AgentAttackCost = Integer.parseInt((String)p.getProperty("AgentAttackCost"));
		Configuration.AgentAttackedCost = Integer.parseInt((String)p.getProperty("AgentAttackedCost"));
		Configuration.AgentAttackedKillCycles = Integer.parseInt((String)p.getProperty("AgentAttackedKillCycles"));
		Configuration.AgentKilledReward = Float.parseFloat((String)p.getProperty("AgentKilledReward"));	
	}
    
    private static String[] GetPropertyArray(Properties p, String propertyName)
    {
        ArrayList <String>tmpArray = new ArrayList<String>();
        int i = 0;
        while( ((String)p.getProperty(propertyName + "." + i)) != null )
        {
            //System.out.println("Adding: " + propertyName + "." + i);
            tmpArray.add((String)p.getProperty(propertyName + "." + i).trim());
            i++;
        }
        String[] ret = new String[tmpArray.size()];
        tmpArray.toArray(ret);
        return ret;
    }
	
	public static String[] ToString()
	{
		String ret = "";
				
		ret = ret + "AgentClassPath\t" + AgentClassPath + "\n";
		ret = ret + "Agents\t" + Agents.length + "\n";
		for(int i=0; i< Agents.length; i++)
		{
			ret = ret + "Agent\t" + Agents[i] + "\n";
		}
		
		ret = ret + "AppName\t" + AppName + "\n";
		ret = ret + "AppResourcesPath\t" + AppResourcesPath + "\n";
		ret = ret + "AppImagePath\t" + AppImagePath + "\n";
		ret = ret + "AppIconPath\t" + AppIconPath + "\n";
		ret = ret + "AppWindowWidth\t" + AppWindowWidth + "\n";
		ret = ret + "AppWindowHeight\t" + AppWindowHeight + "\n";
		ret = ret + "AppSceneWidth\t" + AppSceneWidth + "\n";
		ret = ret + "AppSceneHeight\t" + AppSceneHeight + "\n";
		ret = ret + "AppMaxCycles\t" + AppMaxCycles + "\n";
		ret = ret + "AppFps\t" + AppFps + "\n";
        ret = ret + "AppDrawGUI\t" + AppDrawGUI + "\n";
        ret = ret + "AppGUIRepaintRate\t" + AppGUIRepaintRate + "\n";
        ret = ret + "AppConsolePrint\t" + AppConsolePrint + "\n";
		ret = ret + "AppConsolePrintProgress\t" + AppConsolePrintProgress + "\n";
        ret = ret + "AppLogPath\t" + AppLogPath + "\n";
        ret = ret + "AppLogAgentData\t" + AppLogAgentData + "\n";
        ret = ret + "AppLogStatisticsClassPath\t" + AppLogStatisticsClassPath + "\n";
        ret = ret + "AppLogStatisticsPath\t" + AppLogStatisticsPath + "\n";
        ret = ret + "AppLogStatistics\t" + AppLogStatistics.length + "\n";
        for(int i=0; i< AppLogStatistics.length; i++)
        {
            ret = ret + "AppLogStatistic\t" + AppLogStatistics[i] + "\n";
        }
		ret = ret + "EnergyInitialPopulation\t" + EnergyInitialPopulation + "\n";
		ret = ret + "EnergyMaxPopulation\t" + EnergyMaxPopulation + "\n";
		ret = ret + "EnergyPopulationIncrease\t" + EnergyPopulationIncrease + "\n";
		ret = ret + "EnergyPopulationIncreaseStep\t" + EnergyPopulationIncreaseStep + "\n";
		ret = ret + "EnergyMaxLevel\t" + EnergyMaxLevel + "\n";
		ret = ret + "EnergyMinLevel\t" + EnergyMinLevel + "\n";
		ret = ret + "EnergyRemoveWhenEmpty\t" + EnergyRemoveWhenEmpty + "\n";
		ret = ret + "EnergyShowPercentage\t" + EnergyShowPercentage + "\n";
				
		ret = ret + "AgentInitialEnergyLevel\t" + AgentInitialEnergyLevel + "\n";
		ret = ret + "AgentMinEnergyLevel\t" + AgentMinEnergyLevel + "\n";
		ret = ret + "AgentProcessCost\t" + AgentProcessCost + "\n";
		ret = ret + "AgentFleeSpeed\t" + AgentFleeSpeed + "\n";
		ret = ret + "AgentFleeCycles\t" + AgentFleeCycles + "\n";
		ret = ret + "AgentMaxSpeed\t" + AgentMaxSpeed + "\n";
		ret = ret + "AgentMinSpeed\t" + AgentMinSpeed + "\n";
		ret = ret + "AgentMaxFoodReward\t" + AgentMaxFoodReward + "\n";
		ret = ret + "AgentInitialSensorRange\t" + AgentInitialSensorRange + "\n";
		ret = ret + "AgentMateCost\t" + AgentMateCost + "\n";
		ret = ret + "AgentOffspringReward\t" + AgentOffspringReward + "\n";
		ret = ret + "AgentAttackCost\t" + AgentAttackCost + "\n";
		ret = ret + "AgentAttackedCost\t" + AgentAttackedCost + "\n";
		ret = ret + "AgentAttackedKillCycles\t" + AgentAttackedKillCycles + "\n";
		ret = ret + "AgentKilledReward\t" + AgentKilledReward + "\n";

		return ret.split("\n");
	}
	
	
	/*//Agents to run (simply add to the list for more agents in the game)
	public static String AgentClassPath = "yaes.application.eel6938.classagents.";
	public static String [] Agents = {
											"KillerAgent", 
											"KillerAgent",
											"KillerAgent",
											"KillerAgent",
											"FleeAgent",
											"RandomMoveAgent",
											"FeedAgent",
											"UserInputAgent"
											};
	
	//General Application Settings
	public static String AppName = "Feed-Flee-Mate Game";
	public static String AppResourcesPath = "yaes/application/eel6938/game/resources/";
	public static String AppLogPath = "yaes/application/eel6938/log/";
	public static boolean AppLogAgentData = true;
	public static String AppImagePath = "complex_800_600.png";
	public static String AppIconPath = "icon.gif";
	public static int AppWindowWidth = 800;
	public static int AppWindowHeight = 600;
	public static int AppSceneWidth = 800;
	public static int AppSceneHeight = 600;
	public static int AppMaxCycles = 100;
	public static float AppFps = 0.0f;
	public static boolean AppDrawGUI = false;				//For fastest execution set this to false and FPS to 0
	public static int AppConsolePrintProgress = 10;
	
	//Energy Specific Settings
	public static int EnergyInitialPopulation = 100;		//Initial energy population
	public static int EnergyMaxPopulation = 200;			//Maximum energy population
	public static int EnergyPopulationIncrease = 1;		//How many energy agents to increase with (see increase step)
	public static int EnergyPopulationIncreaseStep = 1;	//Increase step
	public static int EnergyMaxLevel = 800;				//Maximum/initial energy level
	public static int EnergyMinLevel = 0;					//Minimum/empty energy level
	public static boolean EnergyRemoveWhenEmpty = true;	//Remove energy unit from game when empty?
	public static boolean EnergyShowPercentage = false;	//Show energy percentage

	//Agent Specific Settings
	public static int AgentInitialEnergyLevel = 8000;	//Initial energy level
	public static int AgentMinEnergyLevel = 0; 		//Minimum energy for processing
	public static int AgentProcessCost = 1; 			//Processing cost
	public static int AgentFleeSpeed = 8; 			//Flee speed (Penalty = speed*speed)
	public static int AgentFleeCycles = 10; 			//Number of flee cycles 
	public static int AgentMaxSpeed = 4;				//Maximum move speed (Penalty = speed*speed)
	public static int AgentMinSpeed = 1;				//Minimum move speed (Penalty = speed*speed)
	public static int AgentMaxFoodReward = 200; 		//Maximum food intake
	public static int AgentInitialSensorRange = 20; 	//Sensor range (area = range*range)
	public static int AgentMateCost = 1000;			//Mating cost
	public static float AgentOffspringReward = 0.5f;	//Percentage of energy gained from childs total energy income
	public static int AgentAttackCost = 50;			//Attacking cost
	public static int AgentAttackedCost = 1000;		//Being attacked cost
	public static int AgentAttackedKillCycles = 20;	//If attacked agent dies within this cycle frame he is considered being killed by the attacking agent
	public static float AgentKilledReward = 0.5f;		//If agent is killed then gain this percentage of its total income
	*/
}
