/*
 * Created on Jan 26, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.eel6938.game.cameras;

import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;

import yaes.application.eel6938.game.Configuration;
import yaes.application.eel6938.game.objects.GameObject;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Camera {
	private float m_WindowWidth;
	private float m_WindowHeight;
	private float m_SceneWidth;
	private float m_SceneHeight;
	
	private float m_ScaleX; //Value should be between 0 and 1.
	private float m_ScaleY;
	
	private float m_DeltaX = 0;
	private float m_DeltaY = 0;
	
	private float m_CamX = 0;
	private float m_CamY = 0;
	
	private boolean m_HasMoved;
	private boolean m_HasZoomed;
	
	private AffineTransform m_Transform = null;
    
	private GameObject m_AttachedTo = null;
	
	/**
	 * 
	 */
	public Camera() {
		m_Transform = new AffineTransform();
				
		m_HasMoved = false;
		m_HasZoomed = false;
		
		m_CamX = 0;
		m_CamY = 0;
	}
	
	public void centerAtFullscreen(int appWidth, int appHeight, int sceneWidth, int sceneHeight)
	{
		setCameraPosition((appWidth/2.0f),(appHeight/2.0f));
		move( ((float)sceneWidth/2.0f) - (Configuration.AppWindowWidth/2.0f), ((float)sceneHeight/2.0f) - (appHeight/2.0f));
		float scaleXRatio = (float)(Configuration.AppWindowWidth/sceneWidth);
		float scaleYRatio = (float)(Configuration.AppWindowHeight/sceneHeight);
		if(scaleXRatio < scaleYRatio)
		{
			zoom(scaleXRatio);
		}
		else
		{
			zoom(scaleYRatio);
		}
	}
	
	public AffineTransform applyTransform(Graphics2D g)
	{
		if(m_HasMoved)
		{
			m_Transform.translate(m_DeltaX, m_DeltaY);
			m_HasMoved = false;
		}
		
		if(m_HasZoomed)
		{
			m_Transform.translate(m_CamX, m_CamY);
			m_Transform.scale(m_ScaleX, m_ScaleY);
			m_Transform.translate(-m_CamX, -m_CamY);
			m_HasZoomed = false;
		}
		
		g.setTransform(m_Transform);
		
		return m_Transform;
	}
	
	public void zoom(float deltaZoom)
	{
		m_ScaleX = deltaZoom; //* scaleXRatio;
		m_ScaleY = deltaZoom; //* scaleYRatio;
		//System.out.println("ZOOM: " + m_ScaleX + " " + m_ScaleY);
		m_HasZoomed = true;
	}	
	
	public void move(float x, float y)
	{
		//Update Cam position
		m_CamX += x;
		m_CamY += y;
		
		//Update translation values
		m_DeltaX = -x;
		m_DeltaY = -y;
		
		//Update tranformation
		m_HasMoved = true;
		
		//System.out.println("MOVE: " + m_CamX + " " + m_CamY);
	}
	
	public void setCameraPosition(float x, float y)
	{
		m_CamX = x;
		m_CamY = y;
		//move(0,0);
		//System.out.println("POS: " + m_CamX + " " + m_CamY);
	}
	
	public float getCamX()
	{
		return m_CamX;
	}
	
	public float getCamY()
	{
		return m_CamY;
	}
	
	public void attachCameraTo(GameObject obj)
	{
		m_AttachedTo = obj;
	}
}
