/*
 * Created on Jan 28, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.eel6938.game.commands;

import yaes.application.eel6938.game.Configuration;
import yaes.application.eel6938.game.Constants;
import yaes.application.eel6938.game.objects.Map;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MoveCommand implements ICommandFunction {

	private final Map m_Map;
	private int m_X;
	private int m_Y;
	private int m_Speed;
	private final int m_Direction;
	
	/**
	 * 
	 */
	public MoveCommand(Map map, int xPos, int yPos, int direction, int speed) {
		m_X = xPos;
		m_Y = yPos;
		m_Speed = speed;
		m_Direction = direction;
		m_Map = map;
	}

	/* (non-Javadoc)
	 * @see yaes.application.eel6938.game.commands.ICommandFunction#commandFunction()
	 */
	public CommandReturn commandFunction() {
		//Limit the speed
		if(m_Speed > Configuration.AgentMaxSpeed)
		{
			m_Speed = Configuration.AgentMaxSpeed;
		}
		if(m_Speed < Configuration.AgentMinSpeed)
		{
			m_Speed = Configuration.AgentMinSpeed;
		}
		
		int oldX = m_X;
		int oldY = m_Y;
		
		for(int step=0;step<m_Speed;step++)
		{
			if(m_Direction == Constants.DirectionNorth && m_Map.isOpen(m_X, m_Y-1))
			{
				m_Y -= 1;	
			}
			else if(m_Direction == Constants.DirectionSouth && m_Map.isOpen(m_X, m_Y+1))
			{
				m_Y += 1;
			}
			else if(m_Direction == Constants.DirectionWest && m_Map.isOpen(m_X-1, m_Y))
			{
				m_X -= 1;
			}
			else if(m_Direction == Constants.DirectionEast && m_Map.isOpen(m_X+1, m_Y))
			{
				m_X += 1;
			}
		}
		
		//System.out.println("COMMAND:" + newX + " " + newY);
		int distanceMoved = Math.abs(m_X - oldX) + Math.abs(m_Y - oldY);
		// FIXME: this should be configurable
		int energyDelta = (int) (-0.1 * (distanceMoved*distanceMoved));
		if (energyDelta == 0) {
			energyDelta = -1;
		}
		CommandReturn ret = new CommandReturn(m_X, m_Y, energyDelta);
		return ret;
	}
	
	public int getCommandType() {
		// TODO Auto-generated method stub
		return Constants.CommandMove;
	}
}
