/*
 * Created on Jan 25, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.eel6938.game.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JPanel;


import yaes.application.eel6938.game.Configuration;
import yaes.application.eel6938.game.cameras.Camera;
import yaes.ui.visualization.IPainter;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class VisualMap {
	
	 private JFrame frame = null;
	 private JPanel panel = null;
	 private Camera m_Camera = null;
	 private List<Object> objects;
	 private int border = 1;
	 private Map<Object, IPainter> painters = new HashMap<Object, IPainter>();
	 private int m_Width;
	 private int m_Height;
	 
	 //private Graphics2D g2;
	 
	 
	
    public VisualMap(int width, int height, String icon, boolean showGUI) {
		objects = new ArrayList<Object>();
		frame = new JFrame();
		frame.setTitle(Configuration.AppName);
		panel = new JPanel() {
		    public void paint(Graphics g) {
		    	Graphics2D g2 = (Graphics2D) g;
		        paintVisualMap(g2);
		    }
		};
	    m_Width = width;
	    m_Height = height;
	    panel.setPreferredSize(new Dimension(m_Width, m_Height));
	    
	    frame.addWindowListener(new WindowAdapter() {
	        public void windowClosing(WindowEvent e) {
	    	//System.exit(0);
	        }
	    });
	    frame.getContentPane().add(panel);
	    frame.setIconImage(new ImageIcon(icon).getImage()); 
	    frame.pack();
	    frame.setResizable(false);
	    if(showGUI)
	    {
	    	frame.setVisible(true);
	    }
	}
	
	public JFrame getFrame()
	{
		return frame;
	}
	
	public void addObject(Object o) 
	 {
	 	objects.add(o);
	 }
	
	public void removeObject(Object o) 
	{
		 objects.remove(o);
	}
	
	public  void addObject(Object o, IPainter painter) {
    	objects.add(o);
    	painters.put(o, painter);
	}
	
	public  void addObjectList(List o, IPainter painter) {
		Iterator iter = o.iterator();
    	while(iter.hasNext())
    	{
    		Object obj = iter.next();
    		objects.add(obj);
        	painters.put(obj, painter);
    	}
		
	}
	
	public void AttachCamera(Camera camera)
	{
		m_Camera = camera;
	}
		
	public void paintVisualMap(Graphics2D g) {		
		//Paint background
		g.setColor(Color.gray);
		g.fillRect(0,0,m_Width+10, m_Height+10);
		
		//Apply camera transform
		if(m_Camera != null)
		{
			m_Camera.applyTransform(g);
		}
		
		//Paint map objects
		Object []objArr = new Object[objects.size()];
		objects.toArray(objArr);
		for(int i=0; i< objArr.length; i++)
		{
			Object element = objArr[i];
	        IPainter painter = (IPainter)painters.get(element);
	        if (painter != null) {
	            painter.paint(g, element);
	            continue;
	        }   
		}
		
	}
	
	public void repaint() {
	    panel.invalidate();
	    panel.repaint();
	    //paintVisualMap(g2);
	}
}
