/*
 * Created on Jan 26, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.eel6938.game.gui.painters;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;

import yaes.application.eel6938.game.Configuration;
import yaes.application.eel6938.game.objects.Agent;
import yaes.application.eel6938.game.objects.ObjectController;
import yaes.ui.visualization.IPainter;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class AgentPainter implements IPainter {

	/**
	 * 
	 */
	public AgentPainter() {
		super();
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see yaes.ui.visualization.IPainter#paint(java.awt.Graphics2D, java.lang.Object)
	 */
	public void paint(Graphics2D g, Object o) {
		Agent nl = (Agent) o;
		Color agentColor = Color.PINK;
		
		if(nl.getColor() != null && nl.getColor().length == 3)
		{
			agentColor = new Color(nl.getColor()[0], nl.getColor()[1], nl.getColor()[2]);
		}
		
		int fontSize = 10;
		
        if(ObjectController.isEnabled(nl) && ObjectController.isAlive(nl))
        {
        	g.setColor(agentColor);
        	
        	//Draw out-line of Sensor Range
        	Point point = new Point((int)ObjectController.getX(nl), (int)ObjectController.getY(nl));
	        point.translate(-Configuration.AgentInitialSensorRange, -Configuration.AgentInitialSensorRange);
	        Rectangle rect = new Rectangle(point, new Dimension((Configuration.AgentInitialSensorRange*2+1), (Configuration.AgentInitialSensorRange*2+1)));
	        g.draw(rect);
	        
	        //Draw Sensor range
	        int type = AlphaComposite.SRC_OVER;
	        float alpha = 0.25f;
	        AlphaComposite rule = AlphaComposite.getInstance(type, alpha);
	        g.setComposite(rule);
	        g.fillRect(rect.x, rect.y, rect.width, rect.height);
	        alpha = 1.0f;
	        rule = AlphaComposite.getInstance(type, alpha);
	        g.setComposite(rule);
	        
	        //Draw link to parent
	        if(ObjectController.getParent(nl) != null)
	        {
	        	int pX = ObjectController.getX(ObjectController.getParent(nl));
	        	int pY = ObjectController.getY(ObjectController.getParent(nl));
	        	g.setColor(Color.ORANGE);
	        	g.drawLine(ObjectController.getX(nl), ObjectController.getY(nl), pX, pY);
	        	
	        	g.setColor(Color.BLACK);
	        	type = AlphaComposite.SRC_OVER;
		        alpha = 0.4f;
		        rule = AlphaComposite.getInstance(type, alpha);
		        g.setComposite(rule);
		        g.fillOval(rect.x + Configuration.AgentInitialSensorRange/2, rect.y + Configuration.AgentInitialSensorRange/2, rect.width/2, rect.height/2);
		        alpha = 1.0f;
		        rule = AlphaComposite.getInstance(type, alpha);
		        g.setComposite(rule);
	        }
	        
	        //Draw cross-hair
	        g.setColor(Color.BLACK);
	        Point centerPoint = new Point((int)ObjectController.getX(nl), (int)ObjectController.getY(nl));
	        g.drawLine(centerPoint.x-5, centerPoint.y, centerPoint.x+5, centerPoint.y);
	        g.drawLine(centerPoint.x, centerPoint.y-5, centerPoint.x,centerPoint.y+5);
	        
	        //Draw energy level
	        String name = "Name: " + nl.getName() + " (" + ObjectController.getAgentId(nl) + ")";
	        String energy = "Energy: " + nl.getEnergyLevel() + " Pos: (" + ObjectController.getX(nl) + "," + ObjectController.getY(nl) + ")";
			
	        int stringLenght = 0;
	        if(name.length() > energy.length())
	        	stringLenght = name.length();
	        else
	        	stringLenght = energy.length();
	        
	        int topX = centerPoint.x+Configuration.AgentInitialSensorRange;
	        int topY = centerPoint.y+fontSize*2+Configuration.AgentInitialSensorRange;
	        int bottomX = centerPoint.x+Configuration.AgentInitialSensorRange;
			int bottomY =centerPoint.y+fontSize+Configuration.AgentInitialSensorRange;
	        
			g.setColor(Color.BLACK);
	        g.drawRoundRect(bottomX-4, bottomY - 4 - fontSize, 180,fontSize*2+8,4,4);
	        
	        g.setColor(Color.WHITE);
        	type = AlphaComposite.SRC_OVER;
	        alpha = 0.4f;
	        rule = AlphaComposite.getInstance(type, alpha);
	        g.setComposite(rule);
	        g.fillRoundRect(bottomX-4, bottomY - 4 - fontSize, 180,fontSize*2+8,4,4);
	        alpha = 1.0f;
	        rule = AlphaComposite.getInstance(type, alpha);
	        g.setComposite(rule);
	        
	        Color fontColor = Color.BLACK;
	        g.setColor(fontColor);
	        Font f = g.getFont();
	        Font f2 = f.deriveFont(fontSize);
	        g.setFont(f2);
	        g.drawString( name, topX, topY);
	        g.drawString( energy, bottomX, bottomY);
        }
        else
        {
        	//Draw cross-hair
	        g.setColor(Color.BLACK);
	        Point centerPoint = new Point((int)ObjectController.getX(nl), (int)ObjectController.getY(nl));
	        g.drawLine(centerPoint.x-5, centerPoint.y, centerPoint.x+5, centerPoint.y);
	        g.drawLine(centerPoint.x, centerPoint.y-5, centerPoint.x,centerPoint.y+5);
	        
	        Color fontColor = Color.BLACK;
	        g.setColor(fontColor);
	        Font f = g.getFont();
	        Font f2 = f.deriveFont(fontSize);
	        g.setFont(f2);
	        int topX = centerPoint.x;
	        int topY = centerPoint.y+fontSize;
	        String name = nl.getName() + " is Terminated!" + " (" + ObjectController.getAgentId(nl) + ")";
	        g.drawString( name, topX, topY);
        }
	}

}
