/*
 * Created on Oct 13, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.empiricalpathplanner;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Stroke;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import java.util.Vector;
import javax.imageio.ImageIO;


import yaes.application.empiricalpathplanner.ga.Chromosome;

import yaes.application.empiricalpathplanner.ga.PathPlanner;

import yaes.application.empiricalpathplanner.spline.XYZ;


/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class World
{
	
	public static String [] WorldData = {"data/epp/map_6.png","data/epp/map_5.png","data/epp/map_2.png","data/epp/map_1.png", "data/epp/map_3.png"};
	private int mapDataRed[][];
	private int mapDataGreen[][];
	private int mapDataBlue[][];
	private BufferedImage image;
	private int width;
	private int height;
	
	private Vector knownPaths;	
	private Path startGoalPath;
	
	private PathPlanner pathPlanner;
	
	public static double GRASSLAND = 1.0; //Admissible and cheap
	public static double ROAD = 1.0; //Admissible and cheap
	public static double MOUNTAIN = 100.0; //In-addmissible
	public static double WATER = 100.0; //In-addmissible
	public static double FOREST = 95.0; //Admissible but costly
	public static double UNKNOWN = 95.0; //Admissible but costly
	
	private Vector worldListeners;
		
	public World()
	{
		loadImage(World.WorldData[0]);
		knownPaths = null;
		worldListeners = new Vector();
		startGoalPath = null;
		pathPlanner = new PathPlanner(this);
	}
	
	public void saveImage(String imageOutFileName, IDrawable extra)
	{
		 try 
		 {
		 	BufferedImage imageNew = new BufferedImage(image.getWidth(), image.getHeight(), BufferedImage.TYPE_INT_RGB);
		 	Graphics graphics = imageNew.getGraphics();
		 	String format = "PNG";
		 	extra.draw(graphics);
		 	ImageIO.write(imageNew, format, new File(imageOutFileName));
         } 
		 catch (IOException e) 
		 {
            e.printStackTrace();
		 }
        
	}
	
	public BufferedImage loadImage(String imageFileName) {
        try {
        	image = ImageIO.read(new File(imageFileName));
            ColorModel cm = image.getColorModel();
            
            mapDataRed = new int[image.getHeight()][image.getWidth()];
        	mapDataGreen = new int[image.getHeight()][image.getWidth()];
        	mapDataBlue = new int[image.getHeight()][image.getWidth()];
        	
            width = image.getWidth();
            height = image.getHeight();

            for (int i = 0; i != image.getHeight(); i++)
            {
                for (int j = 0; j != image.getWidth(); j++) 
                {
                    int pixel = image.getRGB(j, i);
                    Color c = new Color(pixel);
    				int red = c.getRed();
    				int blue = c.getBlue();
    				int green = c.getGreen();

    				mapDataRed[i][j] = red;
    				mapDataGreen[i][j] = green;
    				mapDataBlue[i][j] = blue;
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        
        return image;
    }
	
	public double classifyTerrain(int x, int y)
	{
		double ret = 0.0;
		if(x < 0 || y < 0 || y >= height || x >= width)
		{
			ret = UNKNOWN;
		}
		else
		{
			if(mapDataRed[y][x] == 130 && 
					mapDataGreen[y][x] == 130 && 
					mapDataBlue[y][x] == 130)	//Mountain
			{
				ret = MOUNTAIN;
				//System.out.println("Mountain");
			}
			else if(mapDataRed[y][x] == 164 && 
					mapDataGreen[y][x] == 114 && 
					mapDataBlue[y][x] == 27)	//ROAD)
			{
				ret = ROAD; 
			}
			else if(mapDataBlue[y][x] == 170)	//Water
			{
				ret = WATER;
				//System.out.println("Water");
			}
			else if(mapDataGreen[y][x] == 170)	//Grassland
			{
				ret = GRASSLAND;
				//System.out.println("Grassland");
			}
			else if(mapDataGreen[y][x] == 100)	//Forest
			{
				ret = FOREST;
				//System.out.println("Forest");
			}
			else								//Unknown
			{
				ret = UNKNOWN;
				//System.out.println("Unknown");
			}
		}
		return ret;
	}
	
	/**
	 * @return Returns the startGoalPath.
	 */
	public Path getStartGoalPath() {
		return startGoalPath;
	}
	/**
	 * @param startGoalPath The startGoalPath to set.
	 */
	public void setStartGoalPath(Path startGoalPath) {
		this.startGoalPath = startGoalPath;
	}
	/**
	 * @return Returns the height.
	 */
	public int getHeight() {
		return height;
	}
	/**
	 * @return Returns the image.
	 */
	public BufferedImage getImage() {
		return image;
	}
	/**
	 * @return Returns the width.
	 */
	public int getWidth() {
		return width;
	}
	
	/**
	 * @return Returns the height.
	 */
	public Vector getKnownPaths() {
		return knownPaths;
	}
	
	/**
	 * @return Returns the height.
	 */
	public void setKnownPaths(Vector paths) {
		knownPaths = paths;
	}
		
	public void addWorldListener(IWorldListener obj)
	{
		worldListeners.add(obj);
	}
	
	public void removeWorldListener(IWorldListener obj)
	{
		worldListeners.remove(obj);
	}
	
	public void sendMessageEvent(String message)
	{
		Iterator iter = worldListeners.iterator();
		while(iter.hasNext())
		{
			IWorldListener obj = (IWorldListener) iter.next();
			obj.worldMessageEvent(message);
		}
	}
	
	/**
	 * @return Returns the pathPlanner.
	 */
	public PathPlanner getPathPlanner() {
		return pathPlanner;
	}
	
	/* (non-Javadoc)
	 * @see yaes.application.empiricalpathplanner.IDrawable#draw(java.awt.Graphics)
	 */
	public void draw(Graphics g) {
		//Draw image map
		Graphics2D g2d = (Graphics2D) g;
		g2d.drawImage(getImage(),null,null);
		
		//Paint world path library lines
		Iterator iter = knownPaths.iterator();
		while(iter.hasNext())
		{
			Path tmpPath  = (Path) iter.next();
			g.setColor(Color.LIGHT_GRAY);
			
			if(tmpPath.getCurve() != null)
			{
				for(int i=0; i<tmpPath.getCurve().length-1;i++)
				{
					Stroke stroke = new BasicStroke(2,BasicStroke.JOIN_ROUND, 
													BasicStroke.JOIN_ROUND, 0,
													new float[] { 1, 1 }, 0);
					g2d.setStroke(stroke);

					g.drawLine((int)Math.round(tmpPath.getCurve()[i].x),(int)Math.round(tmpPath.getCurve()[i].y),(int)Math.round(tmpPath.getCurve()[i+1].x),(int)Math.round(tmpPath.getCurve()[i+1].y));
				
					//Color oldColor = g.getColor();
					//g.setColor(Color.LIGHT_GRAY);
					//g.drawString(tmpPath.toString(), (int)Math.round(tmpPath.getControlPointArray()[0].x), (int)Math.round(tmpPath.getControlPointArray()[0].y));
					//g.setColor(oldColor);
				}
			}
		}
		
		
		if(true)
		{
			//Paint Chromosomes
			g.setColor(Color.cyan);
			iter = getPathPlanner().getChromosomes().iterator();
			while(iter.hasNext())
			{
				Chromosome tmpChrom  = (Chromosome) iter.next();		
				if(tmpChrom.getChromosomePath().getCurve() != null)
				{
					for(int i=0; i<tmpChrom.getChromosomePath().getCurve().length-1;i++)
					{
						Stroke stroke = new BasicStroke(2,BasicStroke.JOIN_ROUND, 
														BasicStroke.JOIN_ROUND, 0,
														new float[] { 1, 1 }, 0);
						g2d.setStroke(stroke);
	
						g.drawLine((int)Math.round(tmpChrom.getChromosomePath().getCurve()[i].x),(int)Math.round(tmpChrom.getChromosomePath().getCurve()[i].y),(int)Math.round(tmpChrom.getChromosomePath().getCurve()[i+1].x),(int)Math.round(tmpChrom.getChromosomePath().getCurve()[i+1].y));
					}
				}
			}
		}
		
		//Paint start goal path
		g.setColor(Color.YELLOW);
		if(startGoalPath != null && startGoalPath.getCurve() != null)
		{
			Path tmpPath = startGoalPath;
			for(int i=0; i<tmpPath.getCurve().length-1;i++)
			{
				Stroke stroke = new BasicStroke(2,BasicStroke.JOIN_ROUND, 
												BasicStroke.JOIN_ROUND, 0,
												new float[] { 1, 1 }, 0);
				g2d.setStroke(stroke);
				g.drawLine((int)Math.round(tmpPath.getCurve()[i].x),(int)Math.round(tmpPath.getCurve()[i].y),(int)Math.round(tmpPath.getCurve()[i+1].x),(int)Math.round(tmpPath.getCurve()[i+1].y));
			}
			Color oldColor = g.getColor();
			g.setColor(Color.LIGHT_GRAY);
			g.drawString("Start-Goal", (int)Math.round(tmpPath.getControlPointArray()[0].x), (int)Math.round(tmpPath.getControlPointArray()[0].y));
			g.setColor(oldColor);
		}
		
		//	Paint evolved world path library lines based on start and goal path
		if(getStartGoalPath() != null)
		{	
			g.setColor(Color.WHITE);
			iter = getPathPlanner().getChromosomes().iterator();
			while(iter.hasNext())
			{
				Chromosome tmpChrom  = (Chromosome) iter.next();		
				Path compoundPath = new Path(3, 50);	//The goal start path (the two first points and the last point) + choromosome path
				Vector startGoalPoints = getStartGoalPath().getControlPoints();
				
				//Add first and second point
				compoundPath.addControlPoint((XYZ)startGoalPoints.firstElement(), false);
				compoundPath.addControlPoint((XYZ)startGoalPoints.elementAt(1), false);
				//Add intermediate points
				Vector otherPoints = tmpChrom.getChromosomePath().getControlPoints();
				Iterator iter2 = otherPoints.iterator();
				while(iter2.hasNext())
				{
					XYZ p = (XYZ)iter2.next();
					compoundPath.addControlPoint(p, false);
				}	
				//Add goal point from startgoal & update curve!
				compoundPath.addControlPoint((XYZ)startGoalPoints.lastElement());
				
				if(compoundPath.getCurve() != null)
				{
					for(int i=0; i<compoundPath.getCurve().length-1;i++)
					{
						Stroke stroke = new BasicStroke(2,BasicStroke.JOIN_ROUND, 
														BasicStroke.JOIN_ROUND, 0,
														new float[] { 1, 1 }, 0);
						g2d.setStroke(stroke);
	
						g.drawLine((int)Math.round(compoundPath.getCurve()[i].x),(int)Math.round(compoundPath.getCurve()[i].y),(int)Math.round(compoundPath.getCurve()[i+1].x),(int)Math.round(compoundPath.getCurve()[i+1].y));
					}
				}
				break;  //Now only the best is shown
			}
		}
	}	
}
