/*
 * Created on Oct 13, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.empiricalpathplanner.ga.crossover;


import java.util.HashSet;
import java.util.Set;

import yaes.application.empiricalpathplanner.Path;
import yaes.application.empiricalpathplanner.ga.Chromosome;
import yaes.application.empiricalpathplanner.spline.XYZ;
import yaes.framework.algorithm.geneticalgorithm.IChromosome;
import yaes.framework.algorithm.geneticalgorithm.ICrossover;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Crossover implements ICrossover {

	private int crossOverCount;
	public Crossover()
	{
		crossOverCount = 0;
	}
	
	
	/**
	 * @return Returns the crossOverCount.
	 */
	public int getCrossOverCount() {
		return crossOverCount;
	}
	/* (non-Javadoc)
	 * @see yaes.framework.algorithm.geneticalgorithm.ICrossover#canMate(yaes.framework.algorithm.geneticalgorithm.IChromosome, yaes.framework.algorithm.geneticalgorithm.IChromosome)
	 */
	public boolean canMate(IChromosome chromosome1, IChromosome chromosome2) {
		// TODO Auto-generated method stub
		Chromosome a = (Chromosome)chromosome1;
		Chromosome b = (Chromosome)chromosome2;
		
		if(a.equals(b))
		{
			//System.out.println("canMate failed: " + a.getChromosomePath().getId() +" == " + b.getChromosomePath().getId());
			return false;
		}
		
		if(a.getChromosomePath().getControlPoints().size() == b.getChromosomePath().getControlPoints().size() 
				&& a.getChromosomePath().getControlPoints().size() > 1 )
		{
			return true;
		}
		return false;
	}

	/* (non-Javadoc)
	 * @see yaes.framework.algorithm.geneticalgorithm.ICrossover#crossover(yaes.framework.algorithm.geneticalgorithm.IChromosome, yaes.framework.algorithm.geneticalgorithm.IChromosome)
	 */
	public IChromosome singleCrossover(IChromosome chromosome1,
			IChromosome chromosome2) {
		Chromosome a = (Chromosome)chromosome1;
		Chromosome b = (Chromosome)chromosome2;
		int index = (int)Math.round(Math.random() * (a.getChromosomePath().getControlPoints().size() - 1));
		
		System.out.println("Crossover between: " + a.getChromosomePath().getId() +" and  " + b.getChromosomePath().getId() + " index:" + index);
		
		Path newPath = new Path(3, 50);
		XYZ [] aArr = a.getChromosomePath().getControlPointArray();
		XYZ [] bArr = b.getChromosomePath().getControlPointArray();
		
		for(int i=0;i<index; i++)
		{
			newPath.addControlPoint(new XYZ(aArr[i].x, aArr[i].y, aArr[i].z), false);
		}
		
		for(int i=index;i<aArr.length; i++)
		{
			newPath.addControlPoint(new XYZ(bArr[i].x, bArr[i].y, bArr[i].z), false);
		}
		
		newPath.update(); //Update this path (calculate its curve);
		
		crossOverCount++;
		Chromosome c = new Chromosome(newPath);
		return c;
	}
	/* (non-Javadoc)
	 * @see yaes.framework.algorithm.geneticalgorithm.ICrossover#multipleCrossover(yaes.framework.algorithm.geneticalgorithm.IChromosome, yaes.framework.algorithm.geneticalgorithm.IChromosome)
	 */
	public Set multipleCrossover(IChromosome chromosome1, IChromosome chromosome2) {
		Set set = new HashSet();
		
		Chromosome a = (Chromosome)chromosome1;
		Chromosome b = (Chromosome)chromosome2;
		int index = (int)Math.round(Math.random() * (a.getChromosomePath().getControlPoints().size() - 1));
		
		Path newPath = new Path(3, 50);
		Path newPath2 = new Path(3, 50);
		XYZ [] aArr = a.getChromosomePath().getControlPointArray();
		XYZ [] bArr = b.getChromosomePath().getControlPointArray();
		
		for(int i=0;i<index; i++)
		{
			newPath.addControlPoint(new XYZ(aArr[i].x, aArr[i].y, aArr[i].z), false);
			newPath2.addControlPoint(new XYZ(bArr[i].x, bArr[i].y, bArr[i].z), false);
		}
		
		for(int i=index;i<aArr.length; i++)
		{
			newPath.addControlPoint(new XYZ(bArr[i].x, bArr[i].y, bArr[i].z), false);
			newPath2.addControlPoint(new XYZ(aArr[i].x, aArr[i].y, aArr[i].z), false);
		}
		newPath.update(); //Update this path (calculate its curve);
		newPath2.update();
		
		set.add(new Chromosome(newPath));
		set.add(new Chromosome(newPath2));
		
		return set;
	}
	
	public String toString()
	{
		return "One Point Crossover (Select Random)";
	}
}
