/*
 * Created on Oct 22, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.empiricalpathplanner.ga.crossover;

import java.util.HashSet;
import java.util.Set;

import yaes.application.empiricalpathplanner.Path;
import yaes.application.empiricalpathplanner.ga.Chromosome;
import yaes.application.empiricalpathplanner.spline.XYZ;
import yaes.framework.algorithm.geneticalgorithm.IChromosome;
import yaes.framework.algorithm.geneticalgorithm.ICrossover;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class OnePointCrossover implements ICrossover {

	
	public OnePointCrossover()
	{
		
	}
	
	/* (non-Javadoc)
	 * @see yaes.framework.algorithm.geneticalgorithm.ICrossover#canMate(yaes.framework.algorithm.geneticalgorithm.IChromosome, yaes.framework.algorithm.geneticalgorithm.IChromosome)
	 */
	public boolean canMate(IChromosome chromosome1, IChromosome chromosome2) {
		// TODO Auto-generated method stub
		return true;
	}

	/* (non-Javadoc)
	 * @see yaes.framework.algorithm.geneticalgorithm.ICrossover#singleCrossover(yaes.framework.algorithm.geneticalgorithm.IChromosome, yaes.framework.algorithm.geneticalgorithm.IChromosome)
	 */
	public IChromosome singleCrossover(IChromosome chromosome1,
			IChromosome chromosome2) {
		Chromosome a = (Chromosome)chromosome1;
		Chromosome b = (Chromosome)chromosome2;
		
		int indexA = Math.round(a.getChromosomePath().getControlPoints().size()/2);
		int indexB = Math.round(b.getChromosomePath().getControlPoints().size()/2);
		
		int index;
		if(indexA >= indexB)	//If a has more points than b. Then we must select b's index!!
		{
			index = indexB;
		}
		else
		{
			index = indexA;
		}
			
		Path newPath = new Path(3, 50);
		XYZ [] aArr = a.getChromosomePath().getControlPointArray();
		XYZ [] bArr = b.getChromosomePath().getControlPointArray();
		
		for(int i=0;i<index; i++)
		{
			newPath.addControlPoint(new XYZ(aArr[i].x, aArr[i].y, aArr[i].z), false);
		}
		for(int i=index;i<aArr.length; i++)
		{
			newPath.addControlPoint(new XYZ(bArr[i].x, bArr[i].y, bArr[i].z), false);
		}
		
		newPath.update(); //Update this path (calculate its curve);
		
		Chromosome c = new Chromosome(newPath);
		return c;
	}

	/* (non-Javadoc)
	 * @see yaes.framework.algorithm.geneticalgorithm.ICrossover#multipleCrossover(yaes.framework.algorithm.geneticalgorithm.IChromosome, yaes.framework.algorithm.geneticalgorithm.IChromosome)
	 */
	public Set multipleCrossover(IChromosome chromosome1,
			IChromosome chromosome2) {
		Chromosome a = (Chromosome)chromosome1;
		Chromosome b = (Chromosome)chromosome2;
		
		int indexA = Math.round(a.getChromosomePath().getControlPoints().size()/2);
		int indexB = Math.round(b.getChromosomePath().getControlPoints().size()/2);
		
		int index;
		if(indexA >= indexB)	//If a has more points than b. Then we must select b's index!!
		{
			index = indexB;
		}
		else
		{
			index = indexA;
		}
			
		Path newPath = new Path(3, 50);
		Path newPath2 = new Path(3,50);
		XYZ [] aArr = a.getChromosomePath().getControlPointArray();
		XYZ [] bArr = b.getChromosomePath().getControlPointArray();
		
		for(int i=0;i<index; i++)
		{
			newPath.addControlPoint(new XYZ(aArr[i].x, aArr[i].y, aArr[i].z), false);
			newPath2.addControlPoint(new XYZ(bArr[i].x, bArr[i].y, bArr[i].z), false);
		}
		
		for(int i=index;i<aArr.length; i++)
		{
			newPath2.addControlPoint(new XYZ(aArr[i].x, aArr[i].y, aArr[i].z), false);
		}
		
		for(int i=index;i<bArr.length; i++)
		{
			newPath.addControlPoint(new XYZ(bArr[i].x, bArr[i].y, bArr[i].z), false);
		}
		
		newPath.update(); //Update this path (calculate its curve);
		newPath2.update();
		
		Chromosome c = new Chromosome(newPath);
		Chromosome d = new Chromosome(newPath2);
		
		HashSet set = new HashSet();
		set.add(c);
		set.add(d);
		return set;
	}
	
	public String toString()
	{
		return "One Point Crossover";
	}

}
