/*
 * Created on Nov 16, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.empiricalpathplanner.ga.crossover;

import java.util.HashSet;
import java.util.Set;
import java.util.Vector;

import yaes.application.empiricalpathplanner.Path;
import yaes.application.empiricalpathplanner.ga.Chromosome;
import yaes.application.empiricalpathplanner.spline.XYZ;
import yaes.framework.algorithm.geneticalgorithm.IChromosome;
import yaes.framework.algorithm.geneticalgorithm.ICrossover;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TwoPointCrossover implements ICrossover {

	Vector knownPaths = null;
	public TwoPointCrossover(Vector knownPaths)
	{
		this.knownPaths = knownPaths;
	}
	/* (non-Javadoc)
	 * @see yaes.framework.algorithm.geneticalgorithm.ICrossover#canMate(yaes.framework.algorithm.geneticalgorithm.IChromosome, yaes.framework.algorithm.geneticalgorithm.IChromosome)
	 */
	public boolean canMate(IChromosome chromosome1, IChromosome chromosome2) {
		return true;
	}

	/* (non-Javadoc)
	 * @see yaes.framework.algorithm.geneticalgorithm.ICrossover#singleCrossover(yaes.framework.algorithm.geneticalgorithm.IChromosome, yaes.framework.algorithm.geneticalgorithm.IChromosome)
	 */
	public IChromosome singleCrossover(IChromosome chromosome1,
			IChromosome chromosome2) {
		return null;
	}

	/* (non-Javadoc)
	 * @see yaes.framework.algorithm.geneticalgorithm.ICrossover#multipleCrossover(yaes.framework.algorithm.geneticalgorithm.IChromosome, yaes.framework.algorithm.geneticalgorithm.IChromosome)
	 */
	public Set multipleCrossover(IChromosome chromosome1,
			IChromosome chromosome2) {
		HashSet set = new HashSet();
		Chromosome a = (Chromosome) chromosome1;
		Chromosome b = (Chromosome)knownPaths.get((int)(Math.random()*knownPaths.size()));
		Path bigPath;
		Path smallPath;
		Path newPath = new Path(3,50);
		
		//Make sure the path with most control points is returned!
		if(a.getChromosomePath().getControlPoints().size() >= b.getChromosomePath().getControlPoints().size())
		{
			bigPath = a.getChromosomePath();
			smallPath = b.getChromosomePath();
		}
		else
		{
			bigPath = b.getChromosomePath();
			smallPath = a.getChromosomePath();
		}
		
		int point1 = (int)(smallPath.getControlPoints().size() * Math.random());
		int point2 = point1;
		while(point1 == point2)
		{
			point2 = (int)(smallPath.getControlPoints().size() * Math.random());
		}
		
		if(point1 > point2)
		{
			int tmpPoint = point1;
			point1 = point2;
			point2 = tmpPoint;
		}
		
		
		
		int lenMask = point2 - point1 + 1;
		XYZ[] smallPathPoints = smallPath.getControlPointArray();
		XYZ[] bigPathPoints = bigPath.getControlPointArray();
		int startPoint = (int)(bigPath.getControlPoints().size() * Math.random());
		int maxChroms = bigPathPoints.length;
		int minChroms = smallPathPoints.length;
		
		/*if(maxChroms != minChroms)
		{
			System.out.println("Crossover of mixed set of chromosomes!! (" + maxChroms + " and " +minChroms + ")");
		}*/
		
		//System.out.print("Start:" + startPoint  + " F: " + point1 + " L: " + point2 + " ");
		//Add the first section
		for(int i=0;i<startPoint;i++)
		{
			//System.out.print("+");
			newPath.addControlPoint(new XYZ(bigPathPoints[i].x,bigPathPoints[i].y,bigPathPoints[i].z), false);
		}
		//Add second section
		for(int i=point1; i<(point2+1); i++)
		{
			if(maxChroms == newPath.getControlPoints().size())
			{
				//System.out.print("-----------------------------------------------BREAK!");
				break;
			}
			//System.out.print("-");
			newPath.addControlPoint(new XYZ(smallPathPoints[i].x, smallPathPoints[i].y, smallPathPoints[i].z), false);
		}
		//Add third section
		for(int i=newPath.getControlPoints().size(); i<bigPathPoints.length; i++)
		{
			if(maxChroms == newPath.getControlPoints().size())
			{
				//System.out.print("-----------------------------------------------BREAK!");
				break;
			}
			//System.out.print("+");
			newPath.addControlPoint(new XYZ(bigPathPoints[i].x,bigPathPoints[i].y,bigPathPoints[i].z), false);
		}	
		newPath.update();
		set.add(new Chromosome(newPath));
		//System.out.println(bigPath);
		//System.out.println(smallPath);
		//System.out.println(newPath);
		//System.out.println(" POINTS: " + newPath.getControlPoints().size());
		return set;
	}

}
