/*
 * Created on Oct 22, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.empiricalpathplanner.ga.selection;


import java.util.Iterator;
import java.util.List;

import yaes.framework.algorithm.geneticalgorithm.IChromosome;
import yaes.framework.algorithm.geneticalgorithm.IFittnessFunction;
import yaes.framework.algorithm.geneticalgorithm.ISelectionMethod;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class RouletteWheelSelection implements ISelectionMethod {

	private IFittnessFunction fitness;
	public double[] fitnessValues = null;
	private int recal = 0;
	
	public RouletteWheelSelection(IFittnessFunction fitness)
	{
		this.fitness = fitness;
	}
	
	public void ResetFitnessValues()
	{
		fitnessValues = null;
	}
	
	/* (non-Javadoc)
	 * @see yaes.framework.algorithm.geneticalgorithm.ISelectionMethod#SelectChromosomes(java.util.List, int)
	 */
	public IChromosome SelectChromosomes(List population) {
		int i;
		double r;
		double current;
		
		if(fitnessValues == null)
		{
			//recal++;
			//System.out.println("Recalculatin fitness values: " + recal);
			fitnessValues = calculateFitness(population);
		}
		
		double sum = fitnessValues[population.size()];
		
		r = (Math.random()*sum)/sum;
		current = 0;
		//System.out.print("Roulette started... ");
		for(i=0; i<population.size()-1;i++)
		{
			current += fitnessValues[i];
			
			if(current > r)
			{
				//System.out.println("Fitness: " + fitnessValues[i] + " Index: " + i + " Sum: " + sum + " r: " +  r + " current: " + current + "... ");
				break;
			}
		}
		//System.out.println("Roulette stopped!");
		return (IChromosome)population.get(i);
	}
	
	private double[] calculateFitness(List population)
	{
		//Last element will contain the total fitness value
		double ret[] = new double[population.size() + 1]; 
		double tmp[] = new double[population.size()]; 
		int index = 0;
		double total = 0.0;
		Iterator iter = population.iterator();
		while(iter.hasNext())
		{
			IChromosome a = (IChromosome) iter.next(); 
			ret[index] = fitness.fittness(a);
			total += ret[index];	//Add to total
			index++;
		}
		
		
		//Now fix the propabilities. 
		//High probability needs to be a low probability due to the fitness interpretation
		//Low fitness is good and should be preferred!
		for(int i=0;i<ret.length-1;i++)
		{
			
			ret[i] = ret[i]/total;
			tmp[ret.length-2-i] = ret[i];
		}
		
		//System.out.println("----------");
		for(int i=0;i<ret.length-1;i++)
		{
			ret[i] = tmp[i];
			
			//System.out.println(ret[i]);
		}

		//Insert total fitness at the very end!
		index = population.size();
		ret[index] = total;
		return ret;
	}
	
	public String toString()
	{
		return "Roulette Wheel Selection";
	}
}
