/*
 * Created on Oct 13, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.empiricalpathplanner.gui;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Iterator;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import yaes.application.empiricalpathplanner.Path;
import yaes.application.empiricalpathplanner.World;
import yaes.application.empiricalpathplanner.ga.Chromosome;
import yaes.application.empiricalpathplanner.ga.IPathPlannerListener;
import yaes.application.empiricalpathplanner.ga.PathPlanner;
import yaes.application.empiricalpathplanner.spline.BSpline;
import yaes.application.empiricalpathplanner.spline.XYZ;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class GAPanel 
	extends JPanel
	implements ActionListener,ItemListener, IPathPlannerListener
{
	/**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3979266967112661305L;
    private Map map;
	private World world;
	private PathPlanner pathPlanner;
	private JButton startButton;
	
	private static int MaxNumChromosome = 100;
	private static int MaxNumControlPoints = 100;
	private static int MaxNumEpochs = 500;
	
	private JLabel generateChromosomesLabel;
	private JComboBox generateChromosomesComboBox;
	private JLabel chromosomesControlPointsLabel;
	private JComboBox chromosomesControlPointsComboBox;
	private JCheckBox chromosomesRandomControlPointsCheckBox;
	private JCheckBox chromosomesRandomControlPointsFilterCheckBox;
	private JLabel chromosomesControlPointsMinDistanceLabel;
	private JComboBox chromosomesControlPointsMinDistanceComboBox;
	private JLabel chromosomesControlPointsMaxDistanceLabel;
	private JComboBox chromosomesControlPointsMaxDistanceComboBox;
	
	private JCheckBox drawChromosomesCheckBox;
	
	private JLabel mutationRateLabel;
	private JComboBox mutationRateComboBox;
	private JLabel crossoverRateLabel;
	private JComboBox crossoverRateComboBox;
	
	private JLabel epochsLabel;
	private JComboBox epochsComboBox;
	private JCheckBox epochsQuitWhenConvergedCheckBox;
	private JLabel epochsRepaintLabel;
	private JComboBox epochsRepaintComboBox;

	private JButton generateChromosomesButton;
	private JButton clearChromosomesButton;

	
	public GAPanel(Map map)
	{
		this.map = map;
		this.world = map.getWorld();
		this.pathPlanner = world.getPathPlanner();
		pathPlanner.addPathPlannerListener(this);
		
		this.setLayout(new GridLayout(20, 1, 2, 2));
		
		startButton = new JButton("Start");
		startButton.addActionListener(this);
		
		drawChromosomesCheckBox = new JCheckBox("Draw Chromosomes?");
		drawChromosomesCheckBox.setSelected(true);
		generateChromosomesLabel = new JLabel("Select Number of Chromosomes:");
		drawChromosomesCheckBox.addItemListener(this);
		
		generateChromosomesButton = new JButton("Generate Chromosomes");
		generateChromosomesButton.addActionListener(this);
		
		clearChromosomesButton = new JButton("Clear Chromosomes");
		clearChromosomesButton.addActionListener(this);
		
		generateChromosomesComboBox = new JComboBox();
		for(int i = 1; i<=GAPanel.MaxNumChromosome; i++)
		{
			generateChromosomesComboBox.addItem(new Integer(i));
		}
		generateChromosomesComboBox.setSelectedIndex(19);
		
		chromosomesControlPointsLabel = new JLabel("Select Number of Control Points:");
		chromosomesControlPointsComboBox = new JComboBox();
		for(int i = 3; i<=GAPanel.MaxNumControlPoints; i++)
		{
			chromosomesControlPointsComboBox.addItem(new Integer(i));
		}
		chromosomesControlPointsComboBox.setSelectedIndex(8-3);
		chromosomesRandomControlPointsCheckBox = new JCheckBox();
		chromosomesRandomControlPointsCheckBox.setText("Random Control Point Lenght?");
		chromosomesRandomControlPointsFilterCheckBox = new JCheckBox();
		chromosomesRandomControlPointsFilterCheckBox.setText("Filter In-Admissible?");
		chromosomesRandomControlPointsFilterCheckBox.setSelected(true);
		
		
		mutationRateLabel = new JLabel("Select Mutation Rate (%):");
		mutationRateComboBox = new JComboBox();
		for(int i = 0; i<=100; i++)
		{
			mutationRateComboBox.addItem(new Integer(i));
		}
		mutationRateComboBox.setSelectedIndex(15);
		
		crossoverRateLabel = new JLabel("Select Crossover Rate (%):");;
		crossoverRateComboBox = new JComboBox();
		for(int i = 0; i<=100; i++ )
		{
			crossoverRateComboBox.addItem(new Integer(i));
		}
		crossoverRateComboBox.setSelectedIndex(15);
		
		epochsLabel = new JLabel("Select Number of Epochs to Run:");
		epochsComboBox = new JComboBox();
		for(int i=1;i<=GAPanel.MaxNumEpochs;i++)
		{
			epochsComboBox.addItem(new Integer(i));
		}
		epochsComboBox.setSelectedIndex(19);
		epochsQuitWhenConvergedCheckBox = new JCheckBox();
		epochsQuitWhenConvergedCheckBox.setText("Activate Convergence Detection?");
		epochsQuitWhenConvergedCheckBox.setEnabled(false);
		
		
		epochsRepaintLabel = new JLabel("Select Repaint Interval (epochs):");
		epochsRepaintComboBox = new JComboBox();
		for(int i=1;i<=GAPanel.MaxNumEpochs;i++)
		{
			epochsRepaintComboBox.addItem(new Integer(i));
		}
		epochsRepaintComboBox.setSelectedIndex(0);
		epochsRepaintComboBox.setEnabled(false);
		
		//Initial chromosome generation
		this.add(generateChromosomesLabel);
		this.add(generateChromosomesComboBox);
		this.add(chromosomesControlPointsLabel);
		this.add(chromosomesControlPointsComboBox);
		this.add(chromosomesRandomControlPointsCheckBox);
		this.add(chromosomesRandomControlPointsFilterCheckBox);
		this.add(generateChromosomesButton);
		this.add(clearChromosomesButton);
		this.add(drawChromosomesCheckBox);
		this.add(new JLabel());
		
		//Mutation rate and Crossover rate
		this.add(mutationRateLabel);
		this.add(mutationRateComboBox);
		this.add(crossoverRateLabel);
		this.add(crossoverRateComboBox);
		this.add(epochsLabel);
		this.add(epochsComboBox);
		//this.add(epochsRepaintLabel);
		//this.add(epochsRepaintComboBox);
		//this.add(epochsQuitWhenConvergedCheckBox);
		
		this.add(new JLabel());
		this.add(startButton);
	}
	
	/**
	 * @return Returns the chromosomesControlPointsComboBox.
	 */
	public JComboBox getChromosomesControlPointsComboBox() {
		return chromosomesControlPointsComboBox;
	}
	/**
	 * @return Returns the chromosomesRandomControlPointsCheckBox.
	 */
	public JCheckBox getChromosomesRandomControlPointsCheckBox() {
		return chromosomesRandomControlPointsCheckBox;
	}
	/**
	 * @return Returns the crossoverRateComboBox.
	 */
	public JComboBox getCrossoverRateComboBox() {
		return crossoverRateComboBox;
	}
	/**
	 * @return Returns the generateChromosomesButton.
	 */
	public JButton getGenerateChromosomesButton() {
		return generateChromosomesButton;
	}
	/**
	 * @return Returns the generateChromosomesComboBox.
	 */
	public JComboBox getGenerateChromosomesComboBox() {
		return generateChromosomesComboBox;
	}
	/**
	 * @return Returns the mutationRateComboBox.
	 */
	public JComboBox getMutationRateComboBox() {
		return mutationRateComboBox;
	}
	
	
	public boolean isInAdmissible(XYZ[] curve)
	{
		boolean inAdmissible = false; //Curve is ok
		
		if(curve != null)
		{
			for(int i=0; i<curve.length-1;i++)	 
			{
				//Get the first and second point
				XYZ[] inpArr = new XYZ[2];
				inpArr[0] = curve[i];
				inpArr[1] = curve[i+1];
				int tmpDist = (int)Math.round(XYZ.distance(curve[i],curve[i+1]));
				
				if(tmpDist > 1)
				{
					XYZ[] tmpCurve = BSpline.createSpline(2,tmpDist,inpArr);
					
					for(int j=0;j<tmpCurve.length;j++)
					{
						if(world.classifyTerrain((int)Math.round(tmpCurve[j].x),(int)Math.round(tmpCurve[j].y)) == World.MOUNTAIN)
						{
							return true; //Curve is not ok!
						}
					}
				}
			}
		}
		return inAdmissible;
	}
	
	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent arg0) {
		
		if(arg0.getSource() == clearChromosomesButton)
		{
			this.pathPlanner.getChromosomes().clear();
			map.repaint();
		}
		
		if(arg0.getSource() == generateChromosomesButton)
		{
		
			Integer chromosomes = (Integer)this.getGenerateChromosomesComboBox().getSelectedItem();
			Integer maxControlPoints = (Integer)this.getChromosomesControlPointsComboBox().getSelectedItem();
			
			for(int i = 0; i< chromosomes.intValue(); i++)
			{
				Path p;
				int points;
				//Random number of chrmosome lenght
				if(chromosomesRandomControlPointsCheckBox.isSelected())
				{
					points = Math.round( (int)(Math.random() * maxControlPoints.intValue()));
					if(points < 3)
					{
						points = 3;
					}
				}
				else
				{
					points = maxControlPoints.intValue();
				}
				p = Path.GenerateRandomPath(points,3,50,world.getHeight(),world.getWidth(),50,40);
				
				if(isInAdmissible(p.getCurve()) && chromosomesRandomControlPointsFilterCheckBox.isSelected())
				{
					//System.out.println("InAdmissible curve detected!");
					i--;
				}
				else
				{
					//System.out.println("Ok curve detected!");
					Chromosome chrom1 = new Chromosome(p);
					world.getPathPlanner().getChromosomes().add(chrom1);
					map.sendMapMessageEvent("New chromosome path created (ID: " + p + ").");
				}
				
			}
			map.repaint();
		}
		
		// TODO Auto-generated method stub
		if(arg0.getSource() == startButton)
		{
			if(map.getStartGoalPath() == null)
			{
				map.sendMapMessageEvent("No Start-Goal Path was created. Aborting!");
				return;
			}
			Integer iMutationRate = (Integer) this.getMutationRateComboBox().getSelectedItem();
			float mutationRate = iMutationRate.intValue()/100.0f;
			Integer iCrossoverRate = (Integer) this.getCrossoverRateComboBox().getSelectedItem();
			float crossoverRate = iCrossoverRate.intValue()/100.0f;
			Integer iEvolutions = (Integer)epochsComboBox.getSelectedItem();
			int evolutions = iEvolutions.intValue();
			
			pathPlanner.SetCrossoverRate(crossoverRate);
			pathPlanner.SetMutationRate(mutationRate);
			
			//IChromosome chrom = (IChromosome)pathPlanner.getGeneratedPaths();
			startButton.setEnabled(false);
			//map.setMainFrameResizable(false);
			//map.repaint();
			List l = map.getWorld().getPathPlanner().getChromosomes();
			
			/*System.out.println("GAPanel- BEFORE -- Population size: " + l.size());
			Iterator iter = l.iterator();
			while(iter.hasNext())
			{
				Chromosome c = (Chromosome)iter.next();
				System.out.println("GAPanel- BEFORE -- " + c.getChromosomePath().toString());
			}*/
			
			
			pathPlanner.evolve(evolutions);
		}
	}

	/* (non-Javadoc)
	 * @see yaes.application.empiricalpathplanner.ga.IPathPlannerListener#OnEpochComplete()
	 */
	public void OnEpochComplete(int epoch, int mutations, int crossovers) {
		// TODO Auto-generated method stub
		map.sendMapMessageEvent("Epoch: " + epoch);	
		if(!pathPlanner.getChromosomes().isEmpty())
		{
			Chromosome c = (Chromosome) pathPlanner.getChromosomes().get(0);
			map.sendMapMessageEvent("Best path size: " + c.getChromosomePath().getControlPoints().size() + " Fitness: " + pathPlanner.getGeneticPool().getFittnessFunction().fittness(c));
		}
		
		Integer i = (Integer)epochsRepaintComboBox.getSelectedItem();
		/*if((epoch > 0) && (i.intValue() % epoch == 0))
		{
			//map.sendMapMessageEvent("Repainting: " + epoch);	
			//pathPlanner.sleepEvolve(1000);
			//pathPlanner.suspendEvolve();
			//map.repaint();
			//pathPlanner.resumeEvolve();
		}*/
	}

	/* (non-Javadoc)
	 * @see yaes.application.empiricalpathplanner.ga.IPathPlannerListener#OnEvolveComplete()
	 */
	public void OnEvolveComplete() {
		// TODO Auto-generated method stub
		map.sendMapMessageEvent("Path-Planner successfully executed!");
		
		Chromosome chrom1 = (Chromosome)this.pathPlanner.getChromosomes().get(0);
		if(chrom1 != null)
		{
			map.setCurrentPath(map.mergeStartGoalWithPath(chrom1.getChromosomePath()));
		}
		
		List l = map.getWorld().getPathPlanner().getChromosomes();
		
		System.out.println("GAPanel-- Population size: " + l.size());
		Iterator iter = l.iterator();
		while(iter.hasNext())
		{
			Chromosome c = (Chromosome)iter.next();
			double out = world.getPathPlanner().getGeneticPool().getFittnessFunction().fittness(c);
			System.out.println("GAPanel: " + c.getChromosomePath().toString() + " " + out);
		}
		//
		
		startButton.setEnabled(true);
		
		world.saveImage("c:\\test.png", map);
		
		//map.setMainFrameResizable(true);
		//map.repaint();
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ItemListener#itemStateChanged(java.awt.event.ItemEvent)
	 */
	public void itemStateChanged(ItemEvent arg0) {
		// TODO Auto-generated method stub
		if(arg0.getSource()== drawChromosomesCheckBox)
		{
			if(arg0.getStateChange() == ItemEvent.SELECTED)
			{
				map.setDrawChromosomes(true);
				map.repaint();
			}
			
			if(arg0.getStateChange() == ItemEvent.DESELECTED)
			{
				map.setDrawChromosomes(false);
				map.repaint();
			}
		}
	}
	
}
