/*
 * Created on Oct 13, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.empiricalpathplanner.gui;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import yaes.application.empiricalpathplanner.Path;
import yaes.application.empiricalpathplanner.World;
import yaes.application.empiricalpathplanner.spline.XYZ;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class WorldPanel 
	extends JPanel
	implements ActionListener, ItemListener
{
	/**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 4049635702650516021L;
    private JButton saveButton;
	private JButton newButton;
	private JButton deleteButton;
	private JButton saveStartGoalButton;
	private JButton selectStartGoalButton;
	private JLabel knownPathsLabel;
	private JLabel widthLabel;
	private JLabel heightLabel;
	private JLabel libraryLabel;
	private JComboBox knownPathsComboBox;
	
	private JLabel worldLabel;
	private JComboBox worldComboBox;
	
	
	private JButton saveSettingsButton;
	
	Map map;
	int selectedPath;
	
	public WorldPanel(Map map)
	{
		this.map = map;
		this.setLayout(new GridLayout(20, 1, 2, 2));
		
		worldLabel = new JLabel("Select World:");
		worldComboBox = new JComboBox();
		for(int i=0;i<World.WorldData.length; i++)
		{
			worldComboBox.addItem(World.WorldData[i]);
		}
		
		saveSettingsButton = new JButton("Save Settings");
		
		deleteButton = new JButton("Delete Path");
		saveButton = new JButton("Save Path");
		selectStartGoalButton = new JButton("Select Start-Goal Path");
		saveStartGoalButton = new JButton("Set Current Path as Start-Goal");
		newButton = new JButton("New path");
			
		knownPathsLabel = new JLabel("Known paths: " + map.getWorld().getKnownPaths().size());
		widthLabel = new JLabel("World Width: " + map.getWorld().getWidth());
		heightLabel = new JLabel("World Height: " + map.getWorld().getHeight());
		libraryLabel = new JLabel("Path Library:");
		knownPathsComboBox = new JComboBox();
		
		saveSettingsButton.addActionListener(this);
		selectStartGoalButton.addActionListener(this);
		saveButton.addActionListener(this);
		newButton.addActionListener(this);
		saveStartGoalButton.addActionListener(this);
		deleteButton.addActionListener(this);
		
		worldComboBox.addItemListener(this);
		knownPathsComboBox.addItemListener(this);
		knownPathsComboBox.addActionListener(this);
		
		this.add(worldLabel);
		this.add(worldComboBox);
		this.add(new JLabel());
		this.add(widthLabel);
		this.add(heightLabel);
		this.add(knownPathsLabel);
		this.add(new JLabel());
		this.add(newButton);
		this.add(saveButton);
		this.add(deleteButton);
		this.add(saveStartGoalButton);
		this.add(selectStartGoalButton);
		this.add(new JLabel());
		this.add(libraryLabel);
		this.add(knownPathsComboBox);
		this.add(new JLabel());
		this.add(saveSettingsButton);
	}

	private void updateContents()
	{
		knownPathsLabel.setText("Known Paths: " + map.getSavedPaths().size());
		widthLabel.setText("World Width: " + map.getWorld().getWidth());
		heightLabel.setText("World Height: " + map.getWorld().getHeight());
	}
	
	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent arg0) {
		
		if(arg0.getSource() == saveSettingsButton)
		{
			Vector knownPaths = map.getWorld().getKnownPaths();
			Path startGoal = map.getWorld().getStartGoalPath();
			
			File outputFile = new File("data\\epp\\guiscenario.xml");
			FileWriter out;
			try {
				out = new FileWriter(outputFile);
				out.write("<experiment>\n");
				
				out.write("\t<knownpaths>\n");
				Iterator iter = knownPaths.iterator();
				while(iter.hasNext())
				{
					Path p = (Path)iter.next();
					out.write("\t\t<path>\n");
					XYZ[] points = p.getControlPointArray();
					for(int i=0; i<points.length;i++)
					{
						out.write("\t\t\t<point x=\"" + points[i].x + "\" y=\"" + points[i].y + "\" z=\"" + points[i].z + "\"/>\n" );
					}
					out.write("\t\t</path>\n");
				}				
				out.write("\t</knownpaths>\n");
				
				if(startGoal!=null)
				{
					out.write("\t<startgoalpath>\n");
					XYZ[] points = startGoal.getControlPointArray();
					for(int i=0; i<points.length;i++)
					{
						out.write("\t\t<point x=\"" + points[i].x + "\" y=\"" + points[i].y + "\" z=\"" + points[i].z + "\"/>\n" );
					}
					out.write("\t</startgoalpath>\n");
				}
				out.write("</experiment>\n");
				out.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		
		if(arg0.getSource() == selectStartGoalButton)
		{
			if(map.getStartGoalPath() != null)
			{
				map.setCurrentPath(map.getStartGoalPath());
				map.repaint();
			}
		}
		
		if(arg0.getSource() == deleteButton)
		{
			Path current = map.getCurrentPath();
			if(current != null && map.getSavedPaths().contains(current))
			{
				knownPathsComboBox.removeItem(current);
				map.getSavedPaths().remove(current);
				map.setCurrentPath(new Path(3, 50));
				if(knownPathsComboBox.getItemCount()!= 0)
				{
					knownPathsComboBox.setSelectedIndex(0);
					map.setCurrentPath((Path)knownPathsComboBox.getSelectedItem());
				}
				map.repaint();
			}
			updateContents();
		}
		
		if(arg0.getSource() == saveButton)
		{
			Path current = map.saveCurrentPath();
			if(current != null)
			{
				knownPathsComboBox.addItem(current);
				knownPathsComboBox.setSelectedItem(current);
				map.sendMapMessageEvent("Saved path (ID: " + current + ").");
			}
			updateContents();
		}
		
		if(arg0.getSource() == saveStartGoalButton)
		{
			Path current = map.setStartGoalPath();
			if(current != null)
			{
				map.getSavedPaths().remove(current);
				
				if(knownPathsComboBox.getItemCount()!= 0)
				{
					knownPathsComboBox.removeItem(current);
				}
				if(knownPathsComboBox.getItemCount()!= 0)
				{
					knownPathsComboBox.setSelectedIndex(0);
					map.setCurrentPath((Path)knownPathsComboBox.getSelectedItem());
				}
				map.repaint();
				
				//map.getWorld().setStartGoalPath(current);
				map.sendMapMessageEvent("Start-goal path selected (ID: " + current + ").");
			}
		}
		
		if(arg0.getSource() == newButton)
		{
			Path current = map.resetCurrentPath();
			map.sendMapMessageEvent("New path created (ID: " + current + ").");
		}
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ItemListener#itemStateChanged(java.awt.event.ItemEvent)
	 */
	public void itemStateChanged(ItemEvent arg0) {
		
		if(arg0.getSource() == worldComboBox)
		{
			if(arg0.getStateChange() == ItemEvent.SELECTED)
			{
				map.sendMapMessageEvent("New map selected: " + (String)worldComboBox.getSelectedItem());
				map.getWorld().loadImage((String)worldComboBox.getSelectedItem());
				map.repaint();
			}
		}
		
		
		if(arg0.getSource() == knownPathsComboBox)
		{
			if(arg0.getStateChange() == ItemEvent.SELECTED)
			{
				map.sendMapMessageEvent("New path selected: " + (Path)knownPathsComboBox.getSelectedItem());
				map.setCurrentPath((Path)knownPathsComboBox.getSelectedItem());
			}
		}
	}
}
