/*
 * Created on Nov 10, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.empiricalpathplanner.testharness;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Experiment {
	private String title;
	private String map;
	private int experiments;
	private Operator[] operators;
	private float crossoverRate;
	private float mutationRate;
	private int epochs;
	private int convergenceCriteria;
	private int chromosomes;
	private int chromosomeLength;
	private boolean chromosomesRandom;
	private boolean chromosomesFilter;
	
	private Path startGoalPath;			//One Path
	private KnownPaths knownPaths;		//Multiple paths
	
	public Experiment(	String title,
						String map,
						int experiments,
						Operator[] operators,
						float crossoverRate, 
						float mutationRate, 
						int epochs,
						int convergenceCriteria,
						int chromosomes, 
						int chromosomeLength,
						boolean chromosomesRandom,
						boolean chromosomesFilter,
						Path startGoalPath,
						KnownPaths knownPaths)
	{
		this.title = title;
		this.map = map;
		this.experiments = experiments;
		this.operators = operators;
		this.crossoverRate = crossoverRate;
		this.mutationRate = mutationRate;
		this.epochs = epochs;
		this.convergenceCriteria = convergenceCriteria;
		this.chromosomes = chromosomes;
		this.chromosomeLength = chromosomeLength;
		this.chromosomesRandom = chromosomesRandom;
		this.chromosomesFilter = chromosomesFilter;
		this.startGoalPath = startGoalPath;
		this.knownPaths = knownPaths;
	}
	
	public String toString()
	{
		return "Title: " + title + "\n" + 
				"Map: " + map + "\n" +
				"Experiments: " + experiments + "\n" +
				"Operators: " + operators.length + "\n" +
				"Crossover Rate: " + crossoverRate + "\n" +
				"Mutation Rate: " + mutationRate + "\n" +
				"Epochs: " + epochs + "\n" + 
				"Convergence Criteria: " + convergenceCriteria + "\n" +
				"Chromosomes: " + chromosomes + "\n" +
				"Chromosome Length: " + chromosomeLength + "\n" +
				"Random Chromosomes: " + chromosomesRandom + "\n" +
				"Random Filter: " + chromosomesFilter + "\n" +
				"Start-Goal Path Points: " + startGoalPath.getPoints().length + "\n" +
				"Known Paths: " +  knownPaths.getPaths().length;
	}
	
	
	/**
	 * @return Returns the convergenceCriteria.
	 */
	public int getConvergenceCriteria() {
		return convergenceCriteria;
	}
	/**
	 * @return Returns the world.
	 */
	public String getMap() {
		return map;
	}
	
	
	/**
	 * @return Returns the operators.
	 */
	public Operator[] getOperators() {
		return operators;
	}
	/**
	 * @return Returns the experiments.
	 */
	public int getExperiments() {
		return experiments;
	}
	/**
	 * @return Returns the chromosomeLength.
	 */
	public int getChromosomeLength() {
		return chromosomeLength;
	}
	/**
	 * @return Returns the chromosomes.
	 */
	public int getChromosomes() {
		return chromosomes;
	}
	/**
	 * @return Returns the chromosomesFilter.
	 */
	public boolean isChromosomesFilter() {
		return chromosomesFilter;
	}
	/**
	 * @return Returns the chromosomesRandom.
	 */
	public boolean isChromosomesRandom() {
		return chromosomesRandom;
	}
	/**
	 * @return Returns the crossoverRate.
	 */
	public float getCrossoverRate() {
		return crossoverRate;
	}
	/**
	 * @return Returns the epochs.
	 */
	public int getEpochs() {
		return epochs;
	}
	/**
	 * @return Returns the knownPaths.
	 */
	public KnownPaths getKnownPaths() {
		return knownPaths;
	}
	/**
	 * @return Returns the mutationRate.
	 */
	public float getMutationRate() {
		return mutationRate;
	}
	/**
	 * @return Returns the startGoalPath.
	 */
	public Path getStartGoalPath() {
		return startGoalPath;
	}
	/**
	 * @return Returns the title.
	 */
	public String getTitle() {
		return title;
	}
}
