/*
 * Created on Nov 4, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.gridbrokerage;

import java.util.ArrayList;
import yaes.framework.simulation.SimulationOutputParameters;
import java.util.Iterator;
import java.util.Random;
import yaes.framework.simulation.SimulationInputParameters;
import umontreal.iro.lecuyer.randvar.ExponentialGen;
import umontreal.iro.lecuyer.rng.RandMrg;
import umontreal.iro.lecuyer.probdist.ExponentialDist;
import umontreal.iro.lecuyer.randvar.NormalGen;
import umontreal.iro.lecuyer.probdist.NormalDist;
import java.util.Collections;

/**
 * @author Xin Bai
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class Broker implements Constants {

	public Broker(BrokerageSimulationContext theContext,
			SimulationInputParameters sip, SimulationOutputParameters sop,
			int s, double u, boolean sLabel) {

		ArrayList consumers = new ArrayList();
		ArrayList producers = new ArrayList();
		ArrayList events = new ArrayList();

		// create the producers
		int noOfProducers = 100;
		// Random rd_c = new Random();

		NormalGen gen_c;
		gen_c = new NormalGen(new RandMrg(), new NormalDist(1000, 500));

		Random rd_xi = new Random();

		double a, b;

		for (int i = 0; i < noOfProducers; i++) {
			// a = 100;
			// b = 500;
			// double c = b - (b - a) * (1 - rd_c.nextDouble());
			double c = gen_c.nextDouble();
			if (c < 0) {
				c = -c;
			}

			a = 1;
			b = 10;
			double xi = b - (b - a) * (1 - rd_xi.nextDouble());

			Producer producer = new Producer(c, xi);
            //set different values for different simulation
            //producer.setLinearPrice(true);
            producer.setLinearPrice(false);
			producers.add(producer);
		}

		// create the consumers
		int timeUnit = sip.getParameterInteger(TIMEUNIT);

		Random rd_omega = new Random();
		// Random rd_zeta = new Random();
		Random rd_kappa = new Random();
		Random rd_mu = new Random();
		Random rd_phi = new Random();
		Random rd_epsilon = new Random();
		// Random rd_r = new Random();

		ExponentialGen gen_r;
		gen_r = new ExponentialGen(new RandMrg(), new ExponentialDist());
		ExponentialGen gen_arriveInterval;
		gen_arriveInterval = new ExponentialGen(new RandMrg(),
				new ExponentialDist());
		ExponentialGen gen_duration;
		gen_duration = new ExponentialGen(new RandMrg(), new ExponentialDist());

		// for (int i = 0; i < timeUnit; i++) {
		double currentTime = 0;

		while (currentTime < timeUnit) {
			// map x in [0,1] to y in [a,b]
			// y=b-(b-a)(1-x)

			// create omega
			a = 20;
			b = 40;
			double omega = b - (b - a) * (1 - rd_omega.nextDouble());

			// create r according to exponential distribution
			double x = gen_r.nextDouble();
			// map x in [0,5] to y in [a,b]
			// y=(b-a) * x / 5 + a
			a = 50;
			b = 1050;
			double r = (b - a) * x / 5 + a;
			if (r < 0) {
				r = -r;
			}

			// create zeta accoring to omega and r
			// zeta = ln(u-(1-u))/ln(r/omega)
			// here u = 0.9
			double zeta = Math.log(0.9 / (1 - 0.9)) / Math.log(r / omega);
			// a = 2;
			// b = 4;
			// double zeta = b - (b - a) * (1 - rd_zeta.nextDouble());
			// a = -Math.log(0.1);
			// b = -Math.log(0.9);
			if (zeta <= 0) {
				System.out.println("omega=" + omega + "   r=" + r + "   zeta="
						+ zeta);
			}

			// create kappa
			a = 2;
			b = 4;
			double kappa = b - (b - a) * (1 - rd_kappa.nextDouble());

			// create mu
			a = 2;
			b = 4;
			double mu = b - (b - a) * (1 - rd_mu.nextDouble());

			// create phi
			a = 1800;
			b = 2000;
			double phi = b - (b - a) * (1 - rd_phi.nextDouble());

			// create epsilon
			a = 2;
			b = 4;
			double epsilon = b - (b - a) * (1 - rd_epsilon.nextDouble());
			// a = 10;
			// b = 50;
			// double r = b - (b - a) * (1 - rd_r.nextDouble());

			// create duration time for this request
			// create dt according to exponential distribution
			double dt = gen_duration.nextDouble();
			if (dt < 0) {
				dt = -dt;
				System.out.println(dt);
			}
			// map x in [0,5] to y in [a,b]
			// y=(b-a) * x / 5 + a
			// a = 3000;
			// b = 5000;
			a = sip.getParameterInteger(DURATIONVALUE);
			b = a + 500;
			double duration = (b - a) * dt / 5 + a;

			Consumer consumer = new Consumer(omega, zeta, kappa, mu, phi,
					epsilon, u);
			consumers.add(consumer);
			consumer.setDuration(duration);

			// create events for this consumer
			Event joinEvent = new Event("JOIN", consumer, currentTime);
			events.add(joinEvent);
			if ((currentTime + duration) < timeUnit) {
				Event leaveEvent = new Event("LEAVE", consumer, currentTime
						+ duration);
				events.add(leaveEvent);
			}
			// create arriving time for next request
			// create at according to exponential distribution
			double at = gen_arriveInterval.nextDouble();
			if (at < 0) {
				at = -at;
			}
			// map x in [0,5] to y in [a,b]
			// y=(b-a) * x / 5 + a
			a = 2;
			b = 10;
			currentTime += (b - a) * at / 5 + a;
		}

		// sort the event list
		Collections.sort(events);

		// start brokerage
		Random rd = new Random();

		for (Iterator iter = events.iterator(); iter.hasNext();) {
			Event event = (Event) iter.next();
			Consumer consumer = event.consumer;

			if (event.type.equals("JOIN")) {

				ArrayList available = new ArrayList();
				for (Iterator iter2 = producers.iterator(); iter2.hasNext();) {
					Producer producer = (Producer) iter2.next();
					if (producer.left > 0) {
						available.add(producer);
					}
				}

				// keep 's' producers with the largest degrees of satisfaction
				ArrayList ok = new ArrayList();

				if ((s != 0) && (u != 0) && (available.size() > s)) {
					while (ok.size() < s) {
						double max = Double.MIN_VALUE;
						Producer theProducer = null;
						Producer producer = null;
						for (Iterator iter2 = available.iterator(); iter2
								.hasNext();) {
							producer = (Producer) iter2.next();
							if (producer.testSatisfaction(consumer) > max) {
								max = producer.testSatisfaction(consumer);
								theProducer = producer;
							}
						}
						if (theProducer == null) {
							theProducer = producer;
						}
						ok.add(theProducer);
						available.remove(theProducer);
					}
				} else {
					ok = available;
				}

				if (ok.size() > 0) {
					// randomly choose one
					int choice = rd.nextInt(ok.size());
					Producer producer = (Producer) ok.get(choice);
					producer.addConsumer(consumer);
				}
			} else {
				// release allocated resource
				consumer.releaseResource();
			}
		}

		// compute statistical data

		double revenue = 0;
		double allocatedResource = 0;
		double admittedUsers = 0;
		double resourceUtility = 0;
		double resourceSatisfaction = 0;
		double userUtility = 0;
		double userSatisfaction = 0;
		double userAdmissionRate = 0;
		double allocationBalance = 0;
		double allocationPercentageBalance = 0;

		double maxAllocation = Double.MIN_VALUE;
		double minAllocation = Double.MAX_VALUE;
		double allocation[] = new double[producers.size()];
		double allocationPercentage[] = new double[producers.size()];

		int j = 0;

		for (Iterator iter = producers.iterator(); iter.hasNext();) {
			Producer producer = (Producer) iter.next();

			revenue += producer.getTotalRevenue();
			allocatedResource += producer.getCurrentAllocation();
			// System.out.println(producer.c);
			// if (producer.c-producer.left>1)
			// System.out.println(producer.c-producer.left);;
			admittedUsers += producer.getTotalUsers();
			resourceUtility += producer.getTotalUtility();
			resourceSatisfaction += producer.getTotalSatisfaction();
			allocation[j] = producer.getCurrentAllocation();
			allocationPercentage[j++] = producer
					.getCurrentAllocationPercentage();

			if ((producer.c - producer.left) > maxAllocation) {
				maxAllocation = producer.c - producer.left;
			}
			if ((producer.c - producer.left) < minAllocation) {
				minAllocation = producer.c - producer.left;
			}
		}

		revenue = revenue / producers.size() / timeUnit * 3600; // hourly revenue
		allocatedResource = allocatedResource / producers.size();
		// System.out.println(allocatedResource);
		admittedUsers = admittedUsers / producers.size() / timeUnit * 3600; // hourly revenue
		resourceUtility = resourceUtility / producers.size();
		resourceSatisfaction = resourceSatisfaction / producers.size();

		// compute balance
		double t1 = 0;
		double t2 = 0;
		double t3 = 0;
		double t4 = 0;

		for (int n = 0; n < allocationPercentage.length; n++) {
			t1 += allocation[n];
			t2 += allocation[n] * allocation[n];
			t3 += allocationPercentage[n];
			t4 += allocationPercentage[n] * allocationPercentage[n];
		}

		int numProducers = producers.size();

		allocationBalance = 1
				- Math
						.acos(t1
								/ (Math.sqrt(t2) * Math.sqrt(allocation.length)))
				/ (Math.PI / 2);
		// (Math.acos(Math.sqrt(numProducers)/numProducers));
		allocationPercentageBalance = 1
				- Math.acos(t3
						/ (Math.sqrt(t4) * Math
								.sqrt(allocationPercentage.length)))
				/ (Math.PI / 2);
		// (Math.acos(Math.sqrt(numProducers)/numProducers));

		for (Iterator iter = consumers.iterator(); iter.hasNext();) {
			Consumer consumer = (Consumer) iter.next();
			if (consumer.producer != null) {
				userUtility += consumer.getUtility();
				userSatisfaction += consumer.getSatisfaction();
				if (consumer.producer != null) {
					userAdmissionRate++;
				}
				// System.out.println("USERSATISTFACTION="+consumer.getSatisfaction());
			}
		}

		userUtility = userUtility / consumers.size();
		userSatisfaction = userSatisfaction / consumers.size();

		userAdmissionRate = userAdmissionRate / consumers.size();

		String whichLabel;
		if (sLabel) {
			whichLabel = Integer.toString(s);
		} else {
			whichLabel = Double.toString(u);
		}

		sop.update(REVENUE + whichLabel, revenue);
		sop.update(ALLOCATEDRESOURCE + whichLabel, allocatedResource);
		sop.update(ADMITTEDUSERS + whichLabel, admittedUsers);
		sop.update(RESOURCEUTILITY + whichLabel, resourceUtility);
		sop.update(RESOURCESATISFACTION + whichLabel, resourceSatisfaction);
		sop.update(USERUTILITY + whichLabel, userUtility);
		sop.update(USERSATISFACTION + whichLabel, userSatisfaction);
		sop.update(USERADMISSIONRATE + whichLabel, userAdmissionRate);
		sop.update(ALLOCATIONBALANCE + whichLabel, allocationBalance);
		sop.update(ALLOCATIONPERCENTAGEBALANCE + whichLabel,
				allocationPercentageBalance);

	}
}
