/*
 * Created on Nov 4, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.gridbrokerage;

/**
 * @author Xin Bai
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class Consumer {

	double omega;

	double zeta;

	double kappa;

	double mu;

	double phi;

	double epsilon;

	double threshold; // initial u_threshold

	double r;

	double duration;
    
    double price;

	Producer producer = null;

	Consumer(double omega, double zeta, double kappa, double mu, double phi,
			double epsilon, double threshold) {
		this.omega = omega;
		this.zeta = zeta;
		this.kappa = kappa;
		this.mu = mu;
		this.phi = phi;
		this.epsilon = epsilon;
		this.threshold = threshold;

		// create r according to t
		r = Math.exp(Math.log(threshold / (1 - threshold)) / zeta
				+ Math.log(omega));

	}

	public double getUtility() {
		return (Math.pow(r / omega, zeta) / (1 + Math.pow(r / omega, zeta)));
	}

	public double getUtility(double t) {
		return (Math.pow(t / omega, zeta) / (1 + Math.pow(t / omega, zeta)));
	}

	public double getSatisfaction() {
		if (producer == null) {
			return 0;
		} else if (r == 0) {
			return 0;
		} else {
			double utility = getUtility();
			double actualPrice = r * price;

			double degree = 1 - Math.exp(-kappa * Math.pow(utility, mu)
					* Math.pow(actualPrice / phi, -epsilon));

			if (degree < 0.01) {
				degree = 0.01;
			}

			// if (degree > 1) {
			// System.out.println(degree);
			// }
			//
			return degree;
		}
	}

	public void setDuration(double duration) {
		this.duration = duration;
	}

	public void releaseResource() {
		if (producer != null) {
			producer.left += r;
		}
	}
}
