/*
 * Created on Nov 4, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.marketgrid;

import java.util.ArrayList;
import java.util.List;

import yaes.application.marketgrid.clients.SerialClient;
import yaes.application.marketgrid.providers.MultiProvider;
import yaes.application.marketgrid.providers.Provider;
import yaes.framework.agent.ICommunicatingAgent;
import yaes.framework.simulation.IContext;
import yaes.framework.simulation.SimulationInputParameters;
import yaes.framework.world.World;

/**
 * @author Lotzi Boloni
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MarketGridContext implements IContext, Constants {

    public List<SerialClient> clients = new ArrayList<SerialClient>();
    public List<Provider> providers = new ArrayList<Provider>();
    public List<MatchMaker> matchmakers = new ArrayList<MatchMaker>();
    public List<Broker> brokers = new ArrayList<Broker>();
    public List<MarketMaker> marketmakers = new ArrayList<MarketMaker>();
    public List<ICommunicatingAgent> allAgents = new ArrayList<ICommunicatingAgent>();
    World world = new World();
           
    public void initialize(SimulationInputParameters sip) {
		//int scenario = sip.getParameterInteger(SCENARIO);
		//ScenarioHelper.scenarioDispatcher(scenario, this, sip);
	
		int initMoney = sip.getParameterInteger(INITMONEY);
		
		// providers
		int providerCount = sip.getParameterInteger(NO_PROVIDERS);			
		double providerResource = sip.getParameterDouble(PROVIDER_RESOURCE);
        for (int i = 0; i < providerCount; i++) {
            // SimpleProvider p = new SimpleProvider("Provider_" + i, world, initMoney);
            MultiProvider p = new MultiProvider("Provider_" + i, world, providerResource, initMoney);
            providers.add(p);
            allAgents.add(p);
        }

		// matchmakers
		int matchMakerCount = sip.getParameterInteger(NO_MATCHMAKERS);
		for(int i = 0; i < matchMakerCount; i++) {
			MatchMaker matchmaker = new MatchMaker("MatchMaker_" + i, world, initMoney);
	        matchmakers.add(matchmaker);
	        allAgents.add(matchmaker);
		}
		// brokers
		int brokerCount = sip.getParameterInteger(NO_BROKERS);
		for(int i = 0; i < brokerCount; i++) {
			Broker broker = new Broker("Broker_" + i, world,  initMoney);
			brokers.add(broker);
			allAgents.add(broker);
		}
		// marketmakers
		int marketMakerCount = sip.getParameterInteger(NO_MARKETMAKERS);
		for(int i = 0; i < marketMakerCount; i++) {
		   MarketMaker marketmaker = new MarketMaker("MarketMaker_" + i, world, initMoney);
           marketmakers.add(marketmaker);
           allAgents.add(marketmaker);
		}
		// clients
		int clientCount = sip.getParameterInteger(NO_CLIENTS);
        for (int i = 0; i < clientCount; i++) {
            //SimpleClient c = new SimpleClient("Client_" + i, initMoney);
            SerialClient c = new SerialClient("Client_" + i, world, 100.0, 3, initMoney);
            clients.add(c);
            allAgents.add(c);
        }
        // add all the agents to the directory
        for(ICommunicatingAgent agent: allAgents) {
            world.getDirectory().addAgent(agent);
        }
    }
}
