/*
 * Created on Nov 4, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.marketgrid;

import yaes.application.marketgrid.Constants;
import yaes.application.marketgrid.clients.SerialClient;
import yaes.framework.agent.ICommunicatingAgent;
import yaes.framework.simulation.IContext;
import yaes.framework.simulation.ISimulationCode;
import yaes.framework.simulation.SimulationInputParameters;
import yaes.framework.simulation.SimulationOutputParameters;
import yaes.ui.text.TextUi;

/**
 * @author Lotzi Boloni
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class MarketGridSimulation implements ISimulationCode, Constants {

	boolean allClientsTerminated = false;

	/*
	 * (non-Javadoc)
	 * 
	 * @see yaes.framework.simulation.ISimulationCode#setup(yaes.framework.simulation.SimulationInputParameters,
	 *      yaes.framework.simulation.IContext)
	 */
	public void setup(SimulationInputParameters sip, IContext theContext) {
		TextUi.println("Setting up MarketGrid simulation");
		MarketGridContext myContext = (MarketGridContext) theContext;
		myContext.initialize(sip);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see yaes.framework.simulation.ISimulationCode#update(double,
	 *      yaes.framework.simulation.SimulationInputParameters,
	 *      yaes.framework.simulation.SimulationOutputParameters,
	 *      yaes.framework.simulation.IContext)
	 */
	public void update(double time, SimulationInputParameters sip,
			SimulationOutputParameters sop, IContext theContext) {
		TextUi.println("MarketGrid simulation step at time: " + time);
		MarketGridContext myContext = (MarketGridContext) theContext;
		for (ICommunicatingAgent i : myContext.allAgents) {
			i.action();
		}
		TextUi.drawLine();
		for (ICommunicatingAgent i : myContext.allAgents) {
			TextUi.println("" + i);
		}
		TextUi.drawLine();
		doMeasurements(time, sip, sop, myContext);
	}

	private void doMeasurements(double time, SimulationInputParameters sip,
			SimulationOutputParameters sop, MarketGridContext myContext) {
		// measure the time when all the clients are have finished.
		if (!allClientsTerminated) {
			boolean finished = true;
			for (SerialClient sc : myContext.clients) {
				if (!sc.isFinished()) {
					finished = false;
					break;
				}
			}
			if (finished) {
				sop.update(TIME_TERMINATION_ALL_CLIENTS, time);
				allClientsTerminated = true;
			}
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see yaes.framework.simulation.ISimulationCode#postprocess(yaes.framework.simulation.SimulationInputParameters,
	 *      yaes.framework.simulation.SimulationOutputParameters,
	 *      yaes.framework.simulation.IContext)
	 */
	public void postprocess(SimulationInputParameters sip,
			SimulationOutputParameters sop, IContext theContext) {
		TextUi.println("MarketGrid simulation was finished, postprocessing...");
	}
}
