package yaes.application.marketgrid.clients;

import yaes.application.marketgrid.resource.AllocationDescriptor;
import yaes.application.marketgrid.resource.IResource;

public class Task {

    private AllocationDescriptor requiredResources;
    double targetExecutionTime;
    double variance;

    public Task(double minResourceReq, double maxResourceReq, double targetExecutionTime, double variance) {
        requiredResources = new AllocationDescriptor();
        requiredResources.quantityLowerBound = minResourceReq;
        requiredResources.quantityUpperBound = maxResourceReq;
        this.targetExecutionTime = targetExecutionTime;
        this.variance = variance;
    }

    public AllocationDescriptor getRequiredResources() {
        return requiredResources;
    }
    
    public double getEstimatedExecutionTime(IResource allocatedResources) {
        return targetExecutionTime;
    }

    public double getRealExecutionTime(IResource allocatedResources) {        
        return targetExecutionTime;
    }
}
