package yaes.application.marketgrid.providers;

import java.util.Collection;

/**
      Allocation segments are generally manipulated using ProviderAllocation
      as managing tool.
 */
public class ProviderAllocationChunk{

  /**
      Allocation state can be
        FREE     - not allocated or bound by any means of obligations
        RESERVED - in process of negotiations but not finally bound
        COMMITED - bound by some kind of reseller contract. Provider has
                   obligations related to them
        SOLD     - sold to end user.
   */
  public enum AllocationState{ FREE, RESERVED, COMMITED, SOLD }
  /**
      Portion of resource that is allocated
   */
  public double quantity = 0.0;
  /**
      type of allocation
   */
  public AllocationState allocationState = AllocationState.FREE;
  /**
      Identifier that puts lock on manipulation (usually some task running on it)
   */
  public String lockingSource = null;

  public String user = null;
  /**
      @param quantity with which resource has been created
   */
  public ProviderAllocationChunk(double quantity, AllocationState allocationState){
    this.quantity = quantity;
    this.allocationState = allocationState;
  }
  private ProviderAllocationChunk(){
  }
  /**
   *    Copies instance of data
   *    @return new instance with copied values
   */
  public ProviderAllocationChunk getCopy(){
    ProviderAllocationChunk copy = new ProviderAllocationChunk();
    copy.user = user;
    copy.quantity = quantity;
    copy.allocationState = allocationState;
    copy.lockingSource = lockingSource;

    return copy;
  }
}

