package yaes.application.marketgrid.providers;

import java.util.ArrayList;

import yaes.application.marketgrid.clients.Task;
import yaes.application.marketgrid.resource.AllocationDescriptor;
import yaes.application.marketgrid.resource.IResource;


public class ProviderExecutionManager{

  private ArrayList<IResource> resources = new ArrayList<IResource>();

  /**
      Adds new resource
      @param resource
   */
  public void addResource(IResource resource){
    resources.add(resource);
  }

  public IResource getResourceForTask(Task task){
    AllocationDescriptor required = task.getRequiredResources();
    // try to allocate upper bound first
    for(IResource resource : resources){
      if(resource.getAvailableQuantity() > required.quantityUpperBound)
        return resource;
    }

    // try to allocate lower bound
    for(IResource resource : resources){
      if(resource.getAvailableQuantity() > required.quantityLowerBound)
        return resource;
    }
    return null;
  }

}
