package yaes.application.marketgrid.resource;

import java.util.Collection;


public interface IPricePolicy{

  /**
      @param quantity quantity for which calculation is requested
      @return total (cummulative) value of price for given quantity using stored pricing rules
   */
  public double getPrice(double quantity);
  /**
      @param quantity quantity for which calculation is requested
      @return total (cummulative) value of price for given quantity using given pricing rules
   */
  public double getPrice(double quantity, Collection<IPricingRule>rules);

  /**
      @param usage set of fragments that describe usage for which calculation is requested
      @return total (cummulative) value of price for given usage using stored pricing rules
   */
  public double getPrice(Collection<UsageChunk>usage);
  /**
      @param usage set of fragments that describe usage for which calculation is requested
      @return total (cummulative) value of price for given usage using given pricing rules
   */
  public double getPrice(Collection<UsageChunk>usage, Collection<IPricingRule>rules);

}
