package yaes.application.marketgrid.subprotocols;

import yaes.application.marketgrid.brokers.Offer;
import yaes.application.marketgrid.resource.AllocationDescriptor;
import yaes.framework.agent.AbstractCommunicatingAgent;
import yaes.framework.agent.ExtendedMessage;

public class SubProtBroker extends AbstractSubprotocol {

    public static final String MSG_QUERY = "Query";
    public static final String MSG_ANSWER = "Answer";
    public static final String PARAM_OFFER = "Offer";
    public static final String BROKER_SUBPROTOCOL = "BrokerQuery";

    public SubProtBroker (AbstractCommunicatingAgent agent) {
      super(BROKER_SUBPROTOCOL, agent);
    }

    public ExtendedMessage createResourceQueryMessage(String destination,
        AllocationDescriptor allocationDescriptor) {
      ExtendedMessage message = new ExtendedMessage(destination, agent
          .getName(), ExtendedMessage.Performative.REQUEST);
      message.setSubprotocol(getName());
      message.setSubprotocolMessage(MSG_QUERY);
      message.setValue(SubProtMatchmakerQuery.PARAM_REQUESTED_RESOURCES, allocationDescriptor);
      return message;
    }

    public ExtendedMessage createResourceAnswerMessage(String destination, String conversation,
        Offer offer) {
      ExtendedMessage message = new ExtendedMessage(destination, agent
          .getName(), ExtendedMessage.Performative.ANSWER);
      message.setSubprotocol(getName());
      message.setSubprotocolMessage(MSG_ANSWER);
      message.setConversation(conversation);
      message.setValue(PARAM_OFFER, offer);
      return message;
    }

}
