package yaes.application.marketgrid.subprotocols;

import yaes.application.marketgrid.resource.AllocationDescriptor;
import yaes.framework.agent.AbstractCommunicatingAgent;
import yaes.framework.agent.ExtendedMessage;

public class SubProtProviderPriceQuery extends AbstractSubprotocol {

    static public final String PARAM_ASKING_PRICE = "AskingPriceFree";
    static public final String MSG_PRICE_QUERY = "PriceQueryFree";
    static public final String MSG_PRICE_OFFER = "PriceOfferFree";

    public SubProtProviderPriceQuery(AbstractCommunicatingAgent agent) {
        super("ProviderPriceQuery", agent);
    }

    public ExtendedMessage createQueryMessage(String destination, String conversation,
            AllocationDescriptor allocationDescriptor) {
        ExtendedMessage message = createQueryMessage(destination, allocationDescriptor);
        message.setConversation(conversation);
        return message;
    }

    public ExtendedMessage createQueryMessage(String destination,
            AllocationDescriptor allocationDescriptor) {
        ExtendedMessage message = new ExtendedMessage(destination, agent
                .getName(), ExtendedMessage.Performative.REQUEST);
        message.setValue(PARAM_ASKING_PRICE, allocationDescriptor);
        return message;
    }

    public ExtendedMessage createPriceOfferMessage(String destination, String conversation, double priceOffer) {
        ExtendedMessage message = new ExtendedMessage(destination, agent.getName(), ExtendedMessage.Performative.ACCEPT);
        message.setSubprotocol(getName());
        message.setSubprotocolMessage(MSG_PRICE_OFFER);
        message.setConversation(conversation);
        message.setValue(SubProtProviderPriceQuery.PARAM_ASKING_PRICE, priceOffer);
        return message;
    }
}
