 /*

 * Created on Sep 28, 2004

 *

 * TODO To change the template for this generated file go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

package yaes.application.taskallocation;



import java.io.IOException;

import java.util.ArrayList;

import java.util.Iterator;

import java.util.List;

import yaes.framework.Version;

import yaes.framework.simulation.RandomVariable;

import yaes.framework.simulation.Simulation;

import yaes.framework.simulation.SimulationHelper;

import yaes.framework.simulation.SimulationInputParameters;

import yaes.framework.simulation.SimulationOutputParameters;

import yaes.ui.plot.PlotLineDescription;

import yaes.ui.text.TextUi;





public class Main implements Constants {



	public static void main(String[] args) throws InstantiationException,

			IllegalAccessException, IOException {

	    

	    int scalingFactor = 10; // 1000 for 1 million

		TextUi.println(Version.versionString());

		List<SimulationInputParameters> inputs = new ArrayList<SimulationInputParameters>();

		for (int taskPerSec = scalingFactor; taskPerSec < 20 * scalingFactor; taskPerSec = taskPerSec + scalingFactor) {

			SimulationInputParameters sim = new SimulationInputParameters();

			sim.setParameter(NODECOUNT, 1000 * scalingFactor);

			sim.setParameter(UPLINKS, 5);

			sim.setParameter(MAX_HOPS, 200);

			sim.setParameter(TASKPERSEC, taskPerSec);

			//sim.setParameter(ALGORITHM, ALGORITHM_WEIGHTED);

			sim.setParameter(ALGORITHM, ALGORITHM_RANDOM);

			sim.setParameter(PREWALKNUMBER, 0);

			//sim.setParameter(TASKARRIVAL, TASKARRIVAL_CONSTANT);

			sim.setParameter(TASKARRIVAL, TASKARRIVAL_POISSON);

			//sim.setParameter(TASKINSERTION, TASKINSERTION_ONEPOINT);			

			sim.setParameter(TASKINSERTION, TASKINSERTION_RANDOM);			

			sim.setStartTime(0);

			sim.setStopTime(5000); // normal 5000

			inputs.add(sim);

		}

		List outputs = Simulation.simulationSet(inputs,

				DDTASimulationCode.class, GridContext.class);

		for (Iterator iter = outputs.iterator(); iter.hasNext();) {

			SimulationOutputParameters element = (SimulationOutputParameters) iter

					.next();

			TextUi.println("" + element);

		}

		// the hop plots

		List<PlotLineDescription> list = new ArrayList<PlotLineDescription>();

		list.add(new PlotLineDescription(TASKPERSEC,

				RandomVariable.TYPE_AVG, HOPS,

				RandomVariable.TYPE_AVG, "Average hops"));

		list.add(new PlotLineDescription(TASKPERSEC,

				RandomVariable.TYPE_AVG, HOPS,

				RandomVariable.TYPE_MAX, "Maximum hops"));

		SimulationHelper.generatePlotFromPlotDescriptionList("data/taskallocation/hops.m", list, outputs);



		// the fairness plots

		list = new ArrayList<PlotLineDescription>();

		list.add(new PlotLineDescription(TASKPERSEC,

				RandomVariable.TYPE_AVG, TASKS_PER_NODE_MIN,

				RandomVariable.TYPE_AVG, "Minimum tasks"));

		list.add(new PlotLineDescription(TASKPERSEC,

				RandomVariable.TYPE_AVG, TASKS_PER_NODE_PERC5,

				RandomVariable.TYPE_MAX, "5 percent tasks"));

		list.add(new PlotLineDescription(TASKPERSEC,

		                 				RandomVariable.TYPE_AVG, TASKS_PER_NODE_PERC95,

		                 				RandomVariable.TYPE_MAX, "95 percent tasks"));

		list.add(new PlotLineDescription(TASKPERSEC,

		                 				RandomVariable.TYPE_AVG, TASKS_PER_NODE_MAX,

		                 				RandomVariable.TYPE_MAX, "Maximum tasks"));

		SimulationHelper.generatePlotFromPlotDescriptionList("data/taskallocation/fairness.m", list, outputs);



		

		SimulationHelper.generatePlotFromSimulationResults("data/taskallocation/load.m", outputs,

				TASKPERSEC, RandomVariable.TYPE_AVG,

				BUSY, RandomVariable.TYPE_AVG, "Average load"); // "Average load" 

	}



}