package yaes.application.uavaltclient.coalitionformation;



import java.util.ArrayList;

import java.util.List;



/**

 * Represents a single coalition formed by coalition formation.

 * 

 * @author dejongp

 */

public class Coalition

{

	private List uavReps = new ArrayList();

	private MissionRepresentation missionRep;

	

	/**

	 * Constructs a new Coalition.

	 * 

	 * @param uavRepresentations representation of the UAVs in the coalition

	 * @param mission representation of the mission to which the coalition has been assigned

	 */

	public Coalition(List uavRepresentations, MissionRepresentation mission)

	{

		this.uavReps = uavRepresentations;

		this.missionRep = mission;

	}

	

	/**

	 * 

	 * @param uavRep

	 */

	public void addUAVRepresentation(UAVRepresentation uavRepresentation)

	{

		uavReps.add(uavRepresentation);

	}

	

	/**

	 * 

	 * @return

	 */

	public List getUAVRepresentations()

	{

		return uavReps;

	}



  /**

   * @return

   */

  public MissionRepresentation getMissionRep()

  {

    return missionRep;

  }



  /**

   * @param representation

   */

  public void setMissionRep(MissionRepresentation representation)

  {

    missionRep = representation;

  }



}

