package yaes.application.uavaltclient.coalitionformation;



import yaes.application.uavaltclient.nav.Pos;



/**

 * Represents a single mission, with its required capabilities.

 * 

 * @author dejongp

 */

public class MissionRepresentation

{	

	private String name;

	private double firepower;

	private int numBombs;

	private double visibility;

	private double maxVelocity;

	private double stealth;

	private Pos targetPos; //location of mission target



  /**

   * Constructor

   * 

   * Negative values for capability requirements indicate that this ability is not required for the mission.

   * 

   * @param name

   * @param firepower

   * @param visibility

   * @param maxVelocity

   * @param stealth

   */

	public MissionRepresentation(String name, double firepower, int numBombs, double visibility, double maxVelocity, double stealth, Pos targetPos)

	{

		this.name = name;

		this.firepower = firepower;

		this.numBombs = numBombs;

		this.visibility = visibility;

		this.maxVelocity = maxVelocity;

		this.stealth = stealth;

		this.targetPos = targetPos;

	}

	

  /**

   * @return

   */

  public double getFirepower()

  {

    return firepower;

  }



  /**

   * @return

   */

  public double getMaxVelocity()

  {

    return maxVelocity;

  }



  /**

   * @return

   */

  public String getName()

  {

    return name;

  }



  /**

   * @return

   */

  public double getStealth()

  {

    return stealth;

  }



  /**

   * @return

   */

  public double getVisibility()

  {

    return visibility;

  }



  /**

   * @param d

   */

  public void setFirepower(double d)

  {

    firepower = d;

  }



  /**

   * @param d

   */

  public void setMaxVelocity(double d)

  {

    maxVelocity = d;

  }



  /**

   * @param string

   */

  public void setName(String string)

  {

    name = string;

  }



  /**

   * @param d

   */

  public void setStealth(double d)

  {

    stealth = d;

  }



  /**

   * @param d

   */

  public void setVisibility(double d)

  {

    visibility = d;

  }



  /**

   * @return

   */

  public int getNumBombs()

  {

    return numBombs;

  }



  /**

   * @param i

   */

  public void setNumBombs(int i)

  {

    numBombs = i;

  }



  /**

   * @return

   */

  public Pos getTargetPos()

  {

    return targetPos;

  }



  /**

   * @param pos

   */

  public void setTargetPos(Pos pos)

  {

    targetPos = pos;

  }



}

