package yaes.application.uavaltclient.coalitionformation.ga;



import java.util.ArrayList;

import java.util.List;



/**

 * @author dejongp

 *

 */

public class BitmapUtils

{

	/**

	 * Obtain String bitmap representation of the bitmap (e.g, "01010001")

	 * 

	 * @param bitmap bitmap to return string of

	 * @return string version of bitmap

	 */

	public static String toString(boolean[] bitmap)

	{

		char[] chs = new char[bitmap.length];

		

		for (int i=0; i<bitmap.length; i++)

		{

			if (bitmap[i]) chs[i] = '1';

			else chs[i] = '0';

		}

		

    return new String(chs);	

	}

	

	/**

	 * Form a potential coalition list from the supplied bitmap and candidates

	 * 

	 * @param bitmap boolean array indicating which uavs from candidates list are present

	 * @param candidates list of all uavs still available for selection

	 * @return potential coalition list

	 */

	public static List formCoalitionList(boolean[] bitmap, List candidates)

	{

		List coalition = new ArrayList();

		

		for (int i=0; i < bitmap.length; i++)

		{

			if (bitmap[i])

				coalition.add(candidates.get(i));

		}

		

		return coalition;

	}

}

