package yaes.application.uavaltclient.coalitionformation.ga;



import java.util.Random;

import java.util.Set;



import yaes.framework.algorithm.geneticalgorithm.IChromosome;

import yaes.framework.algorithm.geneticalgorithm.ICrossover;



/**

 * @author dejongp

 *

 * To change the template for this generated type comment go to

 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments

 */

public class CrossoverImpl implements ICrossover

{

	private static Random generator = new Random();

		

	/**

	 * Any two chromosomes may mate

	 */

  public boolean canMate(IChromosome chromosome1, IChromosome chromosome2)

  {

    return true;

  }



  /**

   * Combine two chromosomes into one, returning result.  Crossover point is random.

   */

  public IChromosome singleCrossover(IChromosome chromosome1, IChromosome chromosome2)

  {

		ChromosomeImpl chromo1 = (ChromosomeImpl) chromosome1;

		ChromosomeImpl chromo2 = (ChromosomeImpl) chromosome2;

  	

		boolean[] c1Bitmap = chromo1.getSquadBitmap();

		boolean[] c2Bitmap = chromo2.getSquadBitmap();

		  	

  	boolean[] newBitmap = new boolean[c1Bitmap.length];

  	

  	//old code, always crosses over in "middle" of bitmap

//		System.arraycopy(c1Bitmap, 0, newBitmap, 0, c1Bitmap.length / 2);

//		System.arraycopy(c2Bitmap, c2Bitmap.length / 2, newBitmap, c2Bitmap.length / 2, c2Bitmap.length - c2Bitmap.length / 2);	

		

		int crossoverPoint = generator.nextInt(newBitmap.length);		

		System.arraycopy(c1Bitmap, 0, newBitmap, 0, crossoverPoint);

		System.arraycopy(c2Bitmap, crossoverPoint, newBitmap, crossoverPoint, c2Bitmap.length - crossoverPoint);		

  	

//  	System.out.println("CROSSOVER @" + crossoverPoint + ": A:" + BitmapUtils.toString(c1Bitmap) + 

//                       " B:" + BitmapUtils.toString(c2Bitmap) + " RESULT:" + BitmapUtils.toString(newBitmap));

  	

		return new ChromosomeImpl(newBitmap);

  }

  



  /**

   * Not implemented.  Use singleCrossover() instead.

   */

  public Set multipleCrossover(IChromosome chromosome1, IChromosome chromosome2) throws Error

  {

    throw new Error("Not implemented.  Used singleCrossover() instead.");

  }

}

