package yaes.application.uavaltclient.coalitionformation.timing;



import com.vladium.utils.timing.ITimer;

import com.vladium.utils.timing.TimerFactory;



/**

 * Native win32 implementation of Timing (uses native system calls, requires Windows OS.  

 * Set Timing.USE_NATIVE_WINDOWS_TIMER to false for other OS').

 * 

 * @author dejongp

 */

public class Win32NativeTiming extends Timing

{

	private ITimer timer = TimerFactory.newTimer();

	

	private boolean stopped = false;

  

	/**

	 * Returns time taken between startT and finishT, in seconds.

	 * 

	 * @return time taken between startT and finishT, in seconds 

	 * @throws TimingException is it is not possible to get the time

	 */

  public double getElapsedTime() throws TimingException

  {

		if (! stopped)

			throw new TimingException("You must stop timer before getting final elapsed time");

			  	

    return timer.getDuration() / 1000;

  }

  

	/**

	 * Start the timer.

	 */

  public void start()

  {

		timer.start();

  }

  

	/**

	 * Finish the timer.

	 */

  public void finish()

  {

		stopped = true;

		timer.stop();

  }

}

