/*

 * Created on Oct 19, 2004

 *

 * TODO To change the template for this generated file go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

package yaes.application.ugvteam.agents;



import java.util.ArrayList;

import java.util.Iterator;

import java.util.List;



import yaes.application.ugvteam.UGVConvoy;

import yaes.framework.entity.vehicle.ugv.UGV;

import yaes.framework.world.World;

import yaes.framework.world.map.Location;

import yaes.framework.world.map.MapHelper;

import yaes.ui.text.TextUi;



/**

 * @author Lotzi Boloni

 *

 * TODO To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

public class EagerJoinerAgent extends AbstractUgvAgent {



	private UGVConvoy currentConvoy = null; // represented by the leader

	private UGVConvoy currentConvoyTarget; // the one it is attempting to join

	private List convoys; // the list of convoys	

	

    public boolean isDestinationReached() {

    	if (MapHelper.distance(destination, theUGV.getLocation()) < 3.0) {

    		return true;

    	}

    	return false;

    }	

	

	/**

	 * @param theUGV

	 */

	public EagerJoinerAgent(UGV theUGV, World world, Location destination) {

		super(theUGV, world, destination);

	}



	/* (non-Javadoc)

	 * @see yaes.framework.agent.IAgent#action(yaes.framework.world.World)

	 */

	public void action() {

		// create the list of feasible convoys

	    ArrayList feasible = new ArrayList();

        for (Iterator iter = world.getConvoys().iterator(); iter.hasNext();) {

            UGVConvoy element = (UGVConvoy) iter.next();

            UGV leader = element.getLeader().getUGV();

            Location location = leader.getLocation();

            if (MapHelper.distance(theUGV.getLocation(), location) < 100) {

                feasible.add(element);

            }

        }

	    // find the most useful convoy

	    double currentBestUtility;

	    if (currentConvoy == null) {

	        currentBestUtility = Double.MIN_VALUE;

	    } else {

	        currentBestUtility = getUtility(currentConvoy);

	    }

	    UGVConvoy currentBest = currentConvoy;

	    for (Iterator iter = feasible.iterator(); iter.hasNext();) {

            UGVConvoy element = (UGVConvoy) iter.next();

            double utility = getUtility(element);

            if (utility > currentBestUtility) {

                currentBestUtility = utility;

                currentBest = element;

            }

        }

	    if (currentBest != currentConvoy) {

	        currentConvoy = currentBest;

	        theUGV.setControl(currentConvoy.getMemberStrategy());

	        TextUi.println("Changing convoy to:" + currentConvoy.destination);

	    }

		// three different controls for the UGC (switching between them)

		   // 1. follow destination - when alone

		   // 2. follow leader - when in the convoy

		   // 3. rendezvous with the convoy   

	}



	/**

     * @param currentConvoy2

     * @return

     */

    private double getUtility(UGVConvoy convoy) {        

        Location convoyDestination = convoy.destination;

        double distance = MapHelper.distance(destination, convoyDestination);

        return 10000 - distance;

    }



    /**

	 * @return Returns the convoys.

	 */

	public List getConvoys() {

		return convoys;

	}

	/**

	 * @param convoys The convoys to set.

	 */

	public void setConvoys(List convoys) {

		this.convoys = convoys;

	}

}

