/*

 * Created on Oct 19, 2004

 *

 * TODO To change the template for this generated file go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

package yaes.application.ugvteam.agents;



import java.util.ArrayList;

import java.util.Iterator;



import yaes.application.ugvteam.UGVConvoy;

import yaes.framework.algorithm.pathplanning.cache.PathCache;

import yaes.framework.entity.control.speedcontrol.PathFollowControl;

import yaes.framework.entity.vehicle.ugv.UGV;

import yaes.framework.world.World;

import yaes.framework.world.map.GrayIsAccessible;

import yaes.framework.world.map.Location;

import yaes.framework.world.map.MapHelper;

import yaes.framework.world.map.Path;

import yaes.framework.world.map.PathLength;

import yaes.framework.world.map.PlannedPath;

import yaes.framework.world.map.SegmentHelper;

import yaes.framework.world.map.SegmentedPlannedPath;

import yaes.framework.world.map.SimpleFreeGround;

import yaes.framework.world.map.WhiteIsAccessible;



/**

 * This agent directs the UGV towards its destination while deciding to join

 * convoys when approprieate.

 *  

 */

public class RendezvousAgent extends AbstractUgvAgent {



	private UGVConvoy currentConvoy = null; // represented by the leader

	private UGVConvoy currentConvoyTarget; // the one it is attempting to join

	// private List convoys; // the list of convoys

	Location rendezvousLocation;

	Location currentRendezvousLocation;

	private boolean isMovingTowardRendezvousLocation;

	private boolean isMovingTowardUltimateLocation;

	private boolean isFollowingLeader;

	private boolean planToMoveTowardsRendezvousLocation;

	private boolean planToMoveTowardsUltimateLocation;

	private boolean planToFollowingLeader;

	private int waitTimeThreshold = 0;

	private int countPlanningInterval = 1;

	private double currentBestUtility = 0.0;

	private UGVConvoy currentBest = null;



	/**

	 * @param theUGV

	 */

	public RendezvousAgent(UGV theUGV, World world, Location destination) {

		super(theUGV, world, destination);

		isMovingTowardUltimateLocation = true;

		planToMoveTowardsUltimateLocation = false;

		isMovingTowardRendezvousLocation = false;

		planToMoveTowardsRendezvousLocation = false;

		isFollowingLeader = false;

		planToFollowingLeader = false;

	}





	

	/*

	 * (non-Javadoc)

	 * 

	 * @see yaes.framework.agent.IAgent#action(yaes.framework.world.World)

	 */

	public void action() {		

		if (isDestinationReached()) {

			//TextUi.println("Destination was reached. No further processing needed.");

		}

		// Wait for given interval before re-planning

		if (countPlanningInterval % 50 != 0 && planToFollowingLeader == false) {

			countPlanningInterval++;

			return;

		} else if (countPlanningInterval % 10 != 0) {

			countPlanningInterval++;

			return;

		}

		countPlanningInterval = 1;

		// If moving toward ultimate location (self), compute self utility

		if (isMovingTowardUltimateLocation) {

			PathLength pathCost = new PathLength();

			double distance = pathCost.cost(theUGV.getCurrentPath(),

					MapHelper.getRoundedLocation(theUGV.getLocation(),

							new WhiteIsAccessible(), world.getMap()), this.destination);

			//if (theUGV.getSpeed().magnitude() > 0) {

			//currentBestUtility = distance / theUGV.getSpeed().magnitude();

			currentBestUtility = distance;

			//}

			System.out.println("Self Utility:" + currentBestUtility);

		}

		// Check for feasible convoys out of available convoys

		ArrayList feasible = new ArrayList();

		for (Iterator iter = world.getConvoys().iterator(); iter.hasNext();) {

			UGVConvoy element = (UGVConvoy) iter.next();

			UGV leader = element.getLeader().getUGV();

			Location location = leader.getLocation();

			if (MapHelper.distance(theUGV.getLocation(), location) < 80

					&& !element.destination.equals(location

							.getRoundedLocation())) {

				System.out.println("convoy destination:" + element.destination

						+ " and location:" + location.getRoundedLocation());

				feasible.add(element);

			}

		}

		System.out.println("Feasible convoys:" + feasible.size());

		// Compute utiliy for each of these convoys

		if (isFollowingLeader == false

				&& isMovingTowardRendezvousLocation == false) {

			for (Iterator iter = feasible.iterator(); iter.hasNext();) {

				UGVConvoy element = (UGVConvoy) iter.next();

				// get the utility of joiing the convoy at any segment point

				double utility = getUtilityWithinThreshold(element, world);

				System.out.println("Best Utility:" + currentBestUtility

						+ ":utility:" + utility);

				// If utility is less than current best utility

				// 1. make it current best utility (currentBestUtility =

				// utility;)

				// 2. make committment to join this convoy at the rendezvous

				// location

				//    which provides this utility

				// (isMovingTowardrendezvousLocation=true)

				// 3. Jot down the convoy that will be joined (currentBest)

				if (utility > 0 && utility < currentBestUtility) {

					currentBestUtility = utility;

					currentRendezvousLocation = rendezvousLocation;

					isMovingTowardRendezvousLocation = false;

					planToMoveTowardsRendezvousLocation = true;

					currentBest = element;

					System.out

							.println("New best Utility:" + currentBestUtility);

				}

			}

		}

		// If isMovingTowardrendezvousLocation is true,

		// make plans to move towards rendezvous location

		if (planToMoveTowardsRendezvousLocation == true

				&& isMovingTowardRendezvousLocation == false) {

			System.out.println("planning to move to rendezvous location");

			theUGV.setLocation(MapHelper.getRoundedLocation(theUGV.getLocation(),

					new WhiteIsAccessible(), world.getMap()));

			PlannedPath path = new PlannedPath();

			path.setSource(theUGV.getLocation());

			path.setDestination(currentRendezvousLocation);

			/*

			AbstractPathCost pathCost = new PathLength();

			IHeuristic heuristic = new DistanceHeuristic(

					currentRendezvousLocation);

			AStarPP hc = new AStarPP(path, world.getMap(), pathCost, heuristic);

			hc.setReturnFirst(true);

			hc.setAccessibilityChecker(new WhiteIsAccessible());

			hc.planPath(path, world.getMap());

			*/

			PathCache.findPath(path, world.getMap(), true);

			//visual.addObject(path);

			PathFollowControl control = new PathFollowControl(path);

			theUGV.setControl(control);

			isMovingTowardRendezvousLocation = true;

			isMovingTowardUltimateLocation = false;

			planToFollowingLeader = false;

			isFollowingLeader = false;

		}

		UGVConvoy element = currentBest;

		Location leaderLocation = null;

		UGV leader = null;

		if (element != null) {

			leader = element.getLeader().getUGV();

			leaderLocation = leader.getLocation();

		}

		if (leaderLocation != null

				&& (MapHelper.distance(theUGV.getLocation(), leaderLocation) < 25)) {

			planToFollowingLeader = true;

		}

		// if moving towards rendezvous location and convoy within limit, join

		// it.

		if (isMovingTowardRendezvousLocation == true

				&& (MapHelper.distance(theUGV.getLocation(), leaderLocation) < 5)

				&& leaderLocation != null && isFollowingLeader == false) {

			System.out.println("leader follow up");

			theUGV.setControl(element.getMemberStrategy());

			isFollowingLeader = true;

			planToMoveTowardsRendezvousLocation = false;

			isMovingTowardRendezvousLocation = false;

			isMovingTowardUltimateLocation = false;

			planToFollowingLeader = false;

		}

		if (isFollowingLeader == true

				&& currentBest != null

				&& MapHelper.distance(theUGV.getLocation(),

						currentBest.destination) < 5

				&& isMovingTowardUltimateLocation == false) {

			System.out.println("planning for ultimate destination");

			PlannedPath path = new PlannedPath();

			theUGV.setLocation(MapHelper.getRoundedLocation(theUGV.getLocation(),

					new WhiteIsAccessible(),world.getMap()));

			path.setSource(theUGV.getLocation());

			path.setDestination(this.destination);

			/*

			AbstractPathCost pathCost = new PathLength();

			IHeuristic heuristic = new DistanceHeuristic(this.destination);

			AStarPP hc = new AStarPP(path, world.getMap(), pathCost, heuristic);

			hc.setReturnFirst(true);

			//hc.setAccessibilityChecker(new GrayIsAccessible());

			hc.setAccessibilityChecker(new WhiteIsAccessible());

			hc.planPath(path, world.getMap());

			*/

			PathCache.findPath(path, world.getMap(), true);

			//visual.addObject(path);

			PathFollowControl control = new PathFollowControl(path);

			theUGV.setControl(control);

			isMovingTowardUltimateLocation = true;

			isFollowingLeader = false;

			planToFollowingLeader = false;

			isMovingTowardRendezvousLocation = false;

		}

	}



	private double getUtilityWithinThreshold(UGVConvoy convoy, World world) {

		double convoyUtility = 0.0;

		Location convoyDestination = convoy.destination;

		PathLength pathCost = new PathLength();

		UGV leader = convoy.getLeader().getUGV();

		double leaderSpeed = leader.getSpeed().magnitude();

		double ugvSpeed = theUGV.getSpeed().magnitude();

		PlannedPath leaderPath = (PlannedPath) leader.getCurrentPath();

		// check if there is a path known to the convoy

		if (leaderPath == null) {

			return -1;

		}

		SegmentedPlannedPath segPath = SegmentHelper.segmentOnGrayAreas(

				leaderPath, (SimpleFreeGround) world.getMap(),

				new WhiteIsAccessible(), leader.getLocation()

						.getRoundedLocation(), convoy.destination);

		ArrayList segLocations = segPath.getSegmentLocations();

		System.out.println("segment location:" + segLocations);

		Path ugvPath = null;

		Path ugvLeaderDestinationPath = null;

		Location segLocation = null;

		double distance = 0.0;

		double leaderTime = 0.0;

		double ugvSeekTime = 0.0;

		double leaderGuidedTime = 0.0;

		double leaderDestinationTime = 0.0;

		for (Iterator iter = segLocations.iterator(); iter.hasNext();) {

			segLocation = (Location) iter.next();

			distance = pathCost.cost(leaderPath, MapHelper.getRoundedLocation(leader

					.getLocation(), new GrayIsAccessible(), world.getMap()), segLocation);

			leaderTime = distance;// /leaderSpeed;

			ugvPath = getUGVPath(MapHelper.getRoundedLocation(theUGV.getLocation(),

					new WhiteIsAccessible(), world.getMap()), segLocation, world);

			distance = pathCost.cost(ugvPath, MapHelper.getRoundedLocation(theUGV

					.getLocation(), new WhiteIsAccessible(), world.getMap()), segLocation);

			ugvSeekTime = distance;// /ugvSpeed;

			System.out.println(segLocation + ":leader time:" + leaderTime

					+ ":UGV Time:" + ugvSeekTime);

			if (ugvSeekTime > 0 && ugvSeekTime < leaderTime + waitTimeThreshold) {

				leaderGuidedTime = pathCost.cost(leaderPath, segLocation,

						convoyDestination);

				ugvLeaderDestinationPath = getUGVPath(convoyDestination,

						this.destination, world);

				leaderDestinationTime = pathCost.cost(ugvLeaderDestinationPath,

						convoyDestination, this.destination);

				convoyUtility = ugvSeekTime + leaderGuidedTime

						+ leaderDestinationTime;

				rendezvousLocation = segLocation;

				break;

			}

		}

		return convoyUtility;

	}



	private Path getUGVPath(Location source, Location destination, World world) {

		PlannedPath path = new PlannedPath();

		path.setSource(source);

		path.setDestination(destination);

		//DepthFirstPP hc = new DepthFirstPP(path, world.getMap());

		/*

		AbstractPathCost pathCost = new PathLength();

		IHeuristic heuristic = new DistanceHeuristic(destination);

		AStarPP hc = new AStarPP(path, world.getMap(), pathCost, heuristic);

		hc.setReturnFirst(true);

		hc.setAccessibilityChecker(new WhiteIsAccessible());

		hc.planPath(path, world.getMap());

		*/

		PathCache.findPath(path, world.getMap(), true);

		return path;

	}

}