/*

 * Created on Sep 26, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.framework.algorithm.pathplanning;



import java.util.Comparator;

import java.util.Iterator;

import yaes.framework.algorithm.search.IHeuristic;

import yaes.framework.algorithm.search.SortedFringe;

import yaes.framework.algorithm.search.TreeSearchNode;

import yaes.framework.world.map.AbstractPathCost;

import yaes.framework.world.map.Location;





/**

 * @author Lotzi Boloni

 *

 * To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

public class AStarFringe extends SortedFringe {



    AbstractPathCost pathCost;

    IHeuristic heuristic;

    Location destination;

    double ignoreBorder = Double.MAX_VALUE;

    Comparator sortingComp;

    

    /**

     * @param sortingComp

     * @param pathCost

     */

    public AStarFringe(Comparator sortingComp, AbstractPathCost pathCost, Location destination, IHeuristic heuristic) {

        super(sortingComp);

        this.sortingComp = sortingComp;

        this.pathCost = pathCost;

        this.heuristic = heuristic;

        this.destination = destination;

    }



    public static double getTreeNodeCost(AbstractPathCost pathCost, TreeSearchNode object) {

        double partialCost = pathCost.cost(object);

        return partialCost;

    }

    

    public void addNode(TreeSearchNode node) {        

        if (node.getObject() == null) {

            throw new Error("Adding node with no object, should not happen!!");

        }

        Location location = (Location) node.getObject();        

        node.tmp = heuristic.heuristic(node) + pathCost.cost(node);

        set.add(node);        

        /*

        //if (!ignoreDecision(node)) {

        if (set.contains(node)) {

            for (Iterator iter = set.iterator(); iter.hasNext();) {

                TreeSearchNode element = (TreeSearchNode) iter.next();

                if (element.equals(node)) {

                    double newCost = getTreeNodeCost(pathCost, node);

                    double oldCost = getTreeNodeCost(pathCost, element);

                    if (newCost < oldCost) {

                        set.remove(element);

                        set.add(node);

                        // TextUi.println("Adjusting node" + node.getObject() + " newCost " + newCost + " oldCost" + oldCost);

                        return;

                    }

                }

            }

        } else {

           set.add(node);

        }

        */

        //}        

        // TextUi.println("Fringe size = " + set.size());

    }    

    

    /* 

     * Returns true if the node is to be ignored in the fringe, because it has 

     * low prospects. 

     */

    public boolean ignoreDecision(TreeSearchNode object) {

        return false;

        /*

        TreeSearchNode node = (TreeSearchNode) object;

        Location location = (Location)node.getObject();

        double partialCost = getTreeNodeCost(pathCost, object);

        double heuristics = MapHelper.distance(destination, location);

        //double heuristics = 0;

        if (ignoreBorder < (partialCost + heuristics)) {

            //System.out.println("Ignore: true = ignoreBorder = " + ignoreBorder + " partialCost = " + partialCost + " heuristics = " + heuristics);

            return true;

        } else {

            //System.out.println("Ignore: false = ignoreBorder = " + ignoreBorder + " partialCost = " + partialCost + " heuristics = " + heuristics);

            return false;

        }

        */

        //return false; // never ignore

        // FIXME: if I set this to false, it will get the right solution. But funny 

        // enough it will also finish faster, which is weird. 

    }

    

    /* (non-Javadoc)

     * @see simulation.algorithms.treesearch.IFringe#isEmpty()

     */

    public boolean isEmpty() {

        // TreeSearchNode toReturn = (TreeSearchNode) set.first();

        for (Iterator iter = set.iterator(); iter.hasNext();) {

            TreeSearchNode element = (TreeSearchNode) iter.next();

            if (!ignoreDecision(element)) {

                return false;

            }

        }

        return true;

    }



    /* (non-Javadoc)

     * @see simulation.algorithms.treesearch.IFringe#chooseNodeToExpand()

     */

    /*

    public TreeSearchNode chooseNodeToExpand() {

        // TreeSearchNode toReturn = (TreeSearchNode) set.first();

        //ArrayList list = new ArrayList();

        //list.addAll(set);

        //Collections.sort(list, sortingComp);

        TreeSearchNode toReturn = null;

        for (Iterator iter = set.iterator(); iter.hasNext();) {

            TreeSearchNode element = (TreeSearchNode) iter.next();

            if (!ignoreDecision(element)) {

                toReturn = element;

                break;

            }

        }

        if (toReturn != null) {

            set.remove(toReturn);

        }

        //TextUi.println("fringe size" + set.size());

        return toReturn;

    }

    */



    /**

     * @param currentBestCost

     */

    public void setIgnoreBorder(double currentBestCost) {

        ignoreBorder = currentBestCost;

    }    

    

    

}

