/*

 * Created on Nov 29, 2004

 *

 * TODO To change the template for this generated file go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

package yaes.framework.algorithm.pathplanning.cache;



import java.io.FileInputStream;

import java.io.FileOutputStream;

import java.io.IOException;

import java.io.ObjectInputStream;

import java.io.ObjectOutputStream;

import java.util.HashMap;



import yaes.framework.algorithm.pathplanning.AStarPP;

import yaes.framework.algorithm.pathplanning.DistanceHeuristic;

import yaes.framework.algorithm.search.IHeuristic;

import yaes.framework.world.map.AbstractPathCost;

import yaes.framework.world.map.GrayIsAccessible;

import yaes.framework.world.map.IMap;

import yaes.framework.world.map.PathLength;

import yaes.framework.world.map.PlannedPath;

import yaes.framework.world.map.WhiteIsAccessible;

import yaes.ui.text.TextUi;



/**

 * @author Lotzi Boloni

 * 

 * TODO To change the template for this generated type comment go to Window -

 * Preferences - Java - Code Style - Code Templates

 */

public class PathCache {



	private static final String PATHCACHE_DAT = "pathcache.dat";



	private HashMap paths = new HashMap();



	private static PathCache theCache;



	private void save(String fileName) throws IOException {

		FileOutputStream fos = new FileOutputStream(fileName);

		ObjectOutputStream oos = new ObjectOutputStream(fos);

		oos.writeObject(paths);

		oos.close();

		fos.close();

		TextUi

				.println("Saved path cache " + paths.entrySet().size()

						+ " items");

	}



	private void load(String fileName) throws IOException,

			ClassNotFoundException {

		FileInputStream fis = new FileInputStream(fileName);

		ObjectInputStream ois = new ObjectInputStream(fis);

		paths = (HashMap) ois.readObject();

		TextUi.println("Loaded path cache: " + paths.entrySet().size()

				+ " items");

		ois.close();

		fis.close();

	}



	public static void initPathCache() {

		try {

			theCache = new PathCache();

			theCache.load(PATHCACHE_DAT);

		} catch (IOException e) {

			TextUi.println("Could not open the path cache " + PATHCACHE_DAT);

			TextUi.println("" + e);

		} catch (ClassNotFoundException e) {

			e.printStackTrace();

		}

	}



	public static void flush() {

		try {

			theCache.save(PATHCACHE_DAT);

		} catch (IOException iox) {

			iox.printStackTrace();

		}

	}



	/**

	 * This function attempts to look up the path in its hashtable, and if it

	 * can not find it, computes it.

	 * 

	 * @param path

	 * @param mapName

	 * @param whiteAccessible

	 */

	public static void findPath(PlannedPath path, IMap map,

			boolean whiteAccessible) {

		PathPlanDescriptor ppd = new PathPlanDescriptor();

		ppd.setSource(path.getSource());

		ppd.setDestination(path.getDestination());

		ppd.setMapName(map.getMapName());

		ppd.setWhiteAccessible(whiteAccessible);

		PlannedPath computed = (PlannedPath) theCache.paths.get(ppd);

		if (computed != null) {

			TextUi.println("Path was found in cache...");

			path.getLocationList().addAll(computed.getLocationList());

			//TextUi.println("path:" + path);

			return;

		}

		TextUi.println("Path not found in cache... Computing...");

		AbstractPathCost pathCost = new PathLength();

		IHeuristic heuristic = new DistanceHeuristic(path.getDestination());

		AStarPP hc = new AStarPP(path, map, pathCost, heuristic);

		hc.setReturnFirst(true);

		if (whiteAccessible) {

			hc.setAccessibilityChecker(new WhiteIsAccessible());

		} else {

			hc.setAccessibilityChecker(new GrayIsAccessible());

		}

		hc.planPath(path, map);

		theCache.paths.put(ppd, path);

		flush();



	}



}

