/*
 * Created on Sep 20, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.framework.algorithm.routing.wca;

import yaes.framework.world.network.cluster.ClusterHead;
import yaes.framework.world.network.sensornetwork.SensorNode;

/**
 * @author lboloni
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class WCAParameters {

    private double W1;

    private double W2;

    private double W3;

    private double W4;
    
    private int optimalDegree = 10;

    /**
     * @param w1
     * @param w2
     * @param w3
     * @param w4
     */
    public WCAParameters(double w1, double w2, double w3, double w4, int optimalDegree) {
        super();
        W1 = w1;
        W2 = w2;
        W3 = w3;
        W4 = w4;
        this.optimalDegree = optimalDegree;
    }


    /**
     * This formula computes the weight for the WCA algorithm
     * @param ch
     * @param am
     * @return
     */
    double getTotalWeight(ClusterHead ch, int networkSize, double currentTime, double maxDisplacement) {
        SensorNode theNode = ch.getTheNode();
        // OLD double weight1 = (ch.getTheNode().getNodeWeight() / (double) (networkSize - Constants.MAX_DEGREE));
        double weight1 = theNode.getNodeWeight() / ((double) optimalDegree);
        if (weight1 > 1.0) {
            weight1 = 1.0;
        }
        double weight2 = (theNode.getAccumulateWeight() / (double) (networkSize * theNode.getTxRange()));
        double weight3 = (theNode.getMobility() / (float) (maxDisplacement * Math
                        .sqrt(2.0)));
        double weight4 = 0;
        if (currentTime != 0) {
            weight4 = theNode.getTotalCHTime() / (float) (currentTime);
        } else {
            weight4 = 0;
        }
        // FIXME: this is not the model of the old WCA
        //weight4 = weight4 - 1;
        // TextUi.println("weigths: (" + weight1 + ", " + weight2 + ", " + weight3 + ", " + weight4 + ")");
        return W1 * weight1 + W2 * weight2 + W3 * weight3 + W4 * weight4;
    }
    /**
     * @return Returns the optimalDegree.
     */
    public int getOptimalDegree() {
        return optimalDegree;
    }
}