package yaes.framework.entity.control.accelerationcontrol;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import yaes.framework.entity.control.ControlException;
import yaes.framework.entity.control.IAccelerationControl;
import yaes.framework.entity.control.IAccelerationControllable;
import yaes.framework.world.map.Acceleration;
import yaes.framework.world.map.Location;
import yaes.framework.world.map.Speed;


/**
 * @author lboloni
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MultiAccelerationControl implements IAccelerationControl, IAccelerationControllable {

    IAccelerationControllable controllable;
    List controllerLists;

    
    /**
     * 
     */
    public MultiAccelerationControl() {
        controllerLists = new ArrayList();
    }
    
    
    /* (non-Javadoc)
     * @see simulation.control.IAccelerationControl#setControllable(simulation.control.IAccelerationControllable)
     */
    public void setControllable(IAccelerationControllable controllable) {
        this.controllable = controllable;
    }

    public void addController(IAccelerationControl control) {
        control.setControllable(this);
        controllerLists.add(control);
    }
    
    /* (non-Javadoc)
     * @see simulation.control.IControl#control()
     */
    public void control() throws ControlException {
        controllable.controlAcceleration(new Acceleration(0,0));
        for (Iterator iter = controllerLists.iterator(); iter.hasNext();) {
            IAccelerationControl element = (IAccelerationControl) iter.next();
            element.control();
        }
    }

    /* (non-Javadoc)
     * @see simulation.vehicles.IMovingObject#getLocation()
     */
    public Location getLocation() {
        return controllable.getLocation();
    }

    /* (non-Javadoc)
     * @see simulation.vehicles.IMovingObject#getSpeed()
     */
    public Speed getSpeed() {
        return controllable.getSpeed();
    }

    /* (non-Javadoc)
     * @see simulation.vehicles.IMovingObject#getAcceleration()
     */
    public Acceleration getAcceleration() {
        return controllable.getAcceleration();
    }

    /* (non-Javadoc)
     * @see simulation.control.IAccelerationControllable#controlAcceleration(simulation.environment.maps.Acceleration)
     */
    public void controlAcceleration(Acceleration acceleration) throws ControlException {
        // summary
        Acceleration prev = controllable.getAcceleration();
        double newX = prev.getXAcceleration() + acceleration.getXAcceleration();
        double newY = prev.getYAcceleration() + acceleration.getYAcceleration();
        Acceleration newAcc = new Acceleration(newX, newY);
        controllable.controlAcceleration(newAcc);
    }

}
