package yaes.framework.entity.control.speedcontrol;





import yaes.framework.world.map.Location;

import yaes.framework.world.map.MapHelper;

import yaes.framework.world.map.PlannedPath;

import yaes.framework.world.map.Speed;

import yaes.framework.entity.vehicle.Vehicle;



public class SimpleSpeedControl extends AbstractSpeedCoalitionControl{



  int lastCheckPoint;

  Location nextCheckPoint;

  PlannedPath thePath;

  double resolution = 3.0;

  double distanceEpsilon = 1.0;



  public SimpleSpeedControl(PlannedPath thePath) {

      this.thePath = thePath;

      lastCheckPoint = -1;

      nextCheckPoint = thePath.getSource();

  }



  public void control() {

      // if we are at the destination, then stop.

      Location currentLocation = controllable.getLocation();

      System.out.println("CID:"+((Vehicle)controllable).getCoalitionId());

      if (informedCoalitionId == ((Vehicle)controllable).getCoalitionId() ) {

        if (controllable.getLocation().getY() - informedLocation.getY() < 0) {

          ((Vehicle)controllable).setLastSpeed(controllable.getSpeed());

          controllable.controlSpeed(informedSpeed);

        }

      }



      if (lastCheckPoint == thePath.getLocationList().size()) {

          controllable.controlSpeed(new Speed(0, 0));

          return;

      }

      // identify if we reached the next checkpoint.

      double distance = MapHelper.distance(currentLocation, nextCheckPoint);



      if (distance < distanceEpsilon) {

          // move to next checkpoint

          lastCheckPoint++;

          if (lastCheckPoint < thePath.getLocationList().size()) {

              nextCheckPoint = (Location) thePath.getLocationList().get(

                      lastCheckPoint);



              Speed speed = new Speed(

                      (nextCheckPoint.getX() - currentLocation.getX())

                              / resolution,

                      (nextCheckPoint.getY() - currentLocation.getY())

                              / resolution);

              controllable.controlSpeed(speed);

          }

      }

  }



  public void offerToJoin(int vehicleId, int coalitionId, Speed informSpeed, Location informLocation) {

    ((Vehicle) controllable).setCoalitionId(coalitionId);

  }



}