/*

 * Created on Dec 14, 2004

 *

 * TODO To change the template for this generated file go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

package yaes.framework.simulation;



import java.util.ArrayList;

import java.util.Iterator;

import java.util.List;



/**

 * @author Lotzi Boloni

 * 

 * This class provides an integration of the output parameters from a number of

 * simulations.

 *  

 */

public class IntegratedSOP {



	/**

	 * Integrates a set of simulation output parameters, by computing their average

	 * @param sops

	 * @return

	 */

	public static SimulationOutputParameters integrate(List sops) {

		SimulationOutputParameters sop = new SimulationOutputParameters(null, null);

		SimulationOutputParameters first = (SimulationOutputParameters) sops.get(0);

		List randomVariables = first.getRandomVariableNames();

		for (Iterator iter = randomVariables.iterator(); iter.hasNext();) {

			String varName = (String) iter.next();

			for (Iterator iterator = sops.iterator(); iterator

					.hasNext();) {

				SimulationOutputParameters element = (SimulationOutputParameters) iterator.next();

				sop.update(varName, element.getAvg(varName));

				

			}

		}

		return sop;

	}

	

	/**

	 * Integrates a list of list of simulation output parameters 

	 * -- the typical output of a simulationSet

	 * @param listOflists

	 * @return

	 */

	public static List integrateListOfSops(List listOflists) {

		List first = (List)listOflists.get(0);

		int size = first.size();

		List outputs = new ArrayList();

		for(int i=0; i != size; i++) {

			List prepared = new ArrayList();

			for (Iterator iter = listOflists.iterator(); iter.hasNext();) {

				List element = (List) iter.next();

				prepared.add(element.get(i));

			}

			SimulationOutputParameters sop = integrate(prepared);

			outputs.add(sop);

		}

		return outputs;

	}

	

}