/*
 * Created on Sep 30, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.framework.simulation;

import umontreal.iro.lecuyer.stat.Tally;

/**
 * @author Lotzi Boloni
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class RandomVariable {

	public static final int TYPE_AVG = 0;
	public static final int TYPE_COUNT = 1;
	public static final int TYPE_SUM = 2;
	public static final int TYPE_MAX = 3;
	public static final int TYPE_MIN = 4;
	public static final int TYPE_CONFINT_LOW = 5;
	public static final int TYPE_CONFINT_HIGH = 6;
        public static final int TYPE_CONFINT_RADIUS = 7;
	public static final int TYPE_VARIANCE = 8;

	private String name;
	private Tally tally = new Tally();
	private int count;
	//private double sum;
	//private double avg;
	//private double max;
	//private double min;

	// other measures

	public RandomVariable(String name) {
		this.name = name;
		this.count = 0;
	}

	public void update(double currentValue) {
		tally.add(currentValue);
		count++;
	}

	public double getValue(int type) {
		switch (type) {
			case TYPE_AVG :
				return tally.average();
			case TYPE_COUNT :
				return getCount();
			case TYPE_MAX :
				return tally.max();
			case TYPE_MIN :
				return tally.min();
		    case TYPE_CONFINT_LOW:
		    	return getConfidenceInterval()[0]-getConfidenceInterval()[1];
		    case TYPE_CONFINT_HIGH:
		    	return getConfidenceInterval()[0]+getConfidenceInterval()[1];
                    case TYPE_CONFINT_RADIUS:
                        return getConfidenceInterval()[1];
		    case TYPE_VARIANCE:
		    	return getVariance();
	        default:
	        	throw new Error("Can not understand the type" + type);
		}
	}

	public double[] getConfidenceInterval() {
		double confint[] = new double[2];
		tally.confidenceIntervalStudent(0.95, confint);
		return confint;
	}

	public double[] getConfidenceInterval(double percent) {
		double confint[] = new double[2];
		tally.confidenceIntervalStudent(percent, confint);
		return confint;
	}


	/**
	 * @return Returns the avg.
	 */
	public double getAvg() {
		return tally.average();
	}
	/**
	 * @return Returns the count.
	 */
	public int getCount() {
		return count;
	}
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @return Returns the sum.
	 */
	public double getSum() {
		return tally.sum();
	}

	public String toString() {
	    if (count == 1) {
	        return name + " = " + getAvg() + "\n";
	    }
		String temp = name + "\n";
		temp += "\tAverage:\t" + getAvg() + "\t\t";
		temp += "Range: [" + getMin() + ".." + getMax() + "]";
		temp += "\tCount:\t" + count + "\n";
		return temp;
	}
	/**
	 * @return Returns the max.
	 */
	public double getMax() {
		return tally.max();
	}
	/**
	 * @return Returns the min.
	 */
	public double getMin() {
		return tally.min();
	}

	/**
	 * @return Returns the min.
	 */
	public double getVariance() {
		return tally.variance();
	}
}
