/*
 * Created on Sep 7, 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */

package yaes.ui.plot;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * @author Lotzi Boloni
 *
 * To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
public class SimulationPlot {
  private double[] xPoints;
  private ArrayList plotNames = new ArrayList();
  private ArrayList values = new ArrayList();
  private ArrayList plotLineTypes = new ArrayList();
  private ArrayList yValueStrings = new ArrayList();
  private String xLabel = " nothing ";
  private String yLabel = " nothing ";
  private String title = " unknown ";
  private String sign[] = {
      "*", "+", "s", "x", "d", ".", "o", "v", "^", "<",
      ">", "p", "h", }; // modified by Xin on Feb 14, 2005
  private String type[] = {
      "-", "--", ":", "-." }; // added by Xin on Feb 14, 2005
  private String color[] = {
      "r", "g", "b", "c", "m", "y", "k" }; // added by Xin on Feb 14, 2005
  private int count = 0;

  public SimulationPlot() {
  }

  /**
   * This is the one used by Majid, for relative distances
   * @param plotName
   * @param plotValues
   * @param plotLineType
   * @param yValueString
   */
  public void addOneRelativeDistancePlot(String plotName, double[] plotValues,
                                         String plotLineType,
                                         String yValueString) {
    plotNames.add(plotName);
    values.add(plotValues);
    plotLineTypes.add(plotLineType);
    yValueStrings.add(yValueString);
  }

  public void addOnePlot(String plotName, double[] plotValues,
                         String plotLineType) {
    plotNames.add(plotName);
    values.add(plotValues);
    plotLineTypes.add(plotLineType);
  }

  public void addOnePlot(String plotName, double[] plotValues) {
    plotNames.add(plotName);
    values.add(plotValues);
    plotLineTypes.add(sign[count]);
  }

  private double[] extractDoubleArray(ArrayList list) {
    double arrayValues[] = new double[list.size()];
    int i = 0;
    for (Iterator iter = list.iterator(); iter.hasNext(); ) {
      Double element = (Double) iter.next();
      arrayValues[i] = element.doubleValue();
      i++;
    }
    return arrayValues;
  }

  public void addOnePlot(String plotName, ArrayList plotValues,
                         String plotLineType) {
    addOnePlot(plotName, extractDoubleArray(plotValues), plotLineType);
  }

  public void addOneErrorBarPlot(String plotName, ArrayList plotValues,
                                 ArrayList plotRadiusValues,
                                 String plotLineType) {
    plotNames.add(plotName);
    values.add(extractDoubleArray(plotValues));
    values.add(extractDoubleArray(plotRadiusValues));
    plotLineTypes.add(plotLineType);

  }

  public void setXPoints(double[] xPoints) {
    this.xPoints = xPoints;
  }

  public void setXPoints(ArrayList list) {
    this.xPoints = extractDoubleArray(list);
  }

  public void setXLabel(String xLabel) {
    this.xLabel = xLabel;
  }

  public void setYLabel(String yLabel) {
    this.yLabel = yLabel;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public void generateMatlabRelativeDistancePlotFile(String fileName) throws
      IOException {
    StringBuffer buffer = new StringBuffer();
    buffer.append(getXValuesString());
    buffer.append(getValuesString());
    buffer.append("hold off\n");

    for (int i = 0; i != values.size(); i++) {
      buffer.append("plot(xvalues, value_" + i + yValueStrings.get(i)
                    + ", '" + plotLineTypes.get(i) + "')\n");
      buffer.append("hold on\n");
    }
    //buffer.append("plot(xvalues, value_1, 'b-*')\n");
    //buffer.append("hold on\n");
    //buffer.append("plot(xvalues, value_2,'b-s')\n");
    FileOutputStream out = new FileOutputStream(fileName);
    PrintWriter pw = new PrintWriter(out);
    //PrintWriter(fileName);
    pw.write(buffer.toString());
    pw.close();
    out.close();
  }

  public void generateMatlabPlotFile(String fileName) throws IOException {
    StringBuffer buffer = new StringBuffer();
    buffer.append(getXValuesString());
    buffer.append(getValuesString());
    buffer.append("hold off\n");

    for (int i = 0; i != values.size(); i++) {
      buffer.append("plot(xvalues, value_" + i + ", '"
                    + plotLineTypes.get(i) + "')\n");
      buffer.append("hold on\n");
    }
    //buffer.append("plot(xvalues, value_1, 'b-*')\n");
    //buffer.append("hold on\n");
    //buffer.append("plot(xvalues, value_2,'b-s')\n");
    FileOutputStream out = new FileOutputStream(fileName);
    PrintWriter pw = new PrintWriter(out);
    //PrintWriter(fileName);
    pw.write(buffer.toString());
    pw.close();
    out.close();
  }

  public void generateMatlabPlotFileWithLegend(String fileName) throws
      IOException {

    StringBuffer buffer = new StringBuffer();
    buffer.append(getXValuesString());
    buffer.append(getValuesString());
    buffer.append("hold off\n");
    for (int i = 0; i != values.size(); i++) {
      buffer.append("plot(xvalues, value_" + i + ", 'b-" + sign[i]
                    + "')\n");
      buffer.append("hold on\n");
    }
    // generate the legend
    buffer.append("legend(");
    for (int i = 0; i != plotNames.size(); i++) {
      buffer.append("'" + (String) plotNames.get(i) + "'");
      if (i != plotNames.size() - 1) {
        buffer.append(", ");
      }
    }
    buffer.append(")\n");
    FileOutputStream out = new FileOutputStream(fileName);
    PrintWriter pw = new PrintWriter(out);

    //PrintWriter(fileName);

    pw.write(buffer.toString());
    pw.close();
    out.close();
  }

  // This function is created by Xin on Feb 14, 2005
  public void generateMatlabPlotFileWithTitleLabelLegend(String fileName,
      String title, String xLabel, String yLabel) throws IOException {

    StringBuffer buffer = new StringBuffer();
    buffer.append(getXValuesString());
    buffer.append(getValuesString());
    buffer.append("hold off\n");
    for (int i = 0; i != values.size(); i++) {
      buffer.append("plot(xvalues, value_" + i + ", 'b-" + sign[i]
                    + "')\n");
      buffer.append("hold on\n");
    }
    // generate the legend
    buffer.append("legend(");
    for (int i = 0; i != plotNames.size(); i++) {
      buffer.append("'" + (String) plotNames.get(i) + "'");
      if (i != plotNames.size() - 1) {
        buffer.append(", ");
      }
    }
    buffer.append(")\n");

    buffer.append("hold on\n");
    buffer.append("title('" + title + "')\n");
    buffer.append("hold on\n");
    buffer.append("xlabel('" + xLabel + "')\n");
    buffer.append("hold on\n");
    buffer.append("ylabel('" + yLabel + "')\n");

    FileOutputStream out = new FileOutputStream(fileName);
    PrintWriter pw = new PrintWriter(out);

    //PrintWriter(fileName);

    pw.write(buffer.toString());
    pw.close();
    out.close();
  }

  // This function is created by Xin on Feb 14, 2005
  public void generateMatlabErrorBarPlotFileWithTitleLabelLegend(String
      fileName,
      String title, String xLabel, String yLabel) throws IOException {

    StringBuffer buffer = new StringBuffer();
    buffer.append(getXValuesString());
    buffer.append(getValuesString());
    buffer.append("hold off\n");
    for (int i = 0; i != values.size(); i++) {
      buffer.append("plot(xvalues, value_" + i + ", 'b" + type[i / 2]
                    + "')\n");
      buffer.append("hold on\n");
      i = i + 1;
    }

    // generate the legend
    buffer.append("legend(");
    for (int i = 0; i != plotNames.size(); i++) {
      buffer.append("'" + (String) plotNames.get(i) + "'");
      if (i != plotNames.size() - 1) {
        buffer.append(", ");
      }
    }
    buffer.append(")\n");

    buffer.append("hold on\n");

    for (int i = 0; i != values.size(); i++) {
      buffer.append("errorbar(xvalues, value_" + i + ", value_" + (i + 1) +
                    ",'b"+type[i/2]+"')\n");
      buffer.append("hold on\n");
      i = i + 1;
    }

    buffer.append("title('" + title + "')\n");
    buffer.append("hold on\n");
    buffer.append("xlabel('" + xLabel + "')\n");
    buffer.append("hold on\n");
    buffer.append("ylabel('" + yLabel + "')\n");

    FileOutputStream out = new FileOutputStream(fileName);
    PrintWriter pw = new PrintWriter(out);

    //PrintWriter(fileName);

    pw.write(buffer.toString());
    pw.close();
    out.close();
  }

  private String getXValuesString() {
    String val = "xvalues = [";
    for (int i = 0; i < xPoints.length; i++) {
      val += xPoints[i] + " ";
    }
    val += "]\n";
    return val;
  }

  private String getValuesString() {
    String val = "";
    int count = 0;
    for (Iterator iter = values.iterator(); iter.hasNext(); ) {
      double[] element = (double[]) iter.next();
      val += "value_" + count + " = [";
      for (int i = 0; i < element.length; i++) {
        val += element[i] + " ";
      }
      val += "]\n";
      count++;
    }
    return val;
  }

  public static void main(String args[]) throws IOException {
    SimulationPlot s = new SimulationPlot();
    double xPoints[] = {
        10, 20, 30, 40};
    double res1[] = {
        10.0, 20, 30, 40};
    double res2[] = {
        50, 65, 15, 11};
    s.setXPoints(xPoints);
    s.addOnePlot("N=10", res1, "b-");
    s.addOnePlot("N=20", res2, "b-");
    s.generateMatlabPlotFile("G:\\MatLab7\\work\\myplot.m");
  }
}
