/*

 * Created on Sep 5, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.ui.visualization;



import java.awt.Dimension;

import java.awt.Graphics;

import java.awt.Graphics2D;

import java.awt.Image;

import java.awt.Rectangle;

import java.awt.geom.AffineTransform;

import java.awt.image.RenderedImage;

import java.io.File;

import java.io.IOException;

import java.util.ArrayList;

import java.util.HashMap;

import java.util.Iterator;

import java.util.List;

import java.util.Map;

import javax.imageio.ImageIO;

import javax.swing.JFrame;

import javax.swing.JPanel;

import yaes.framework.entity.vehicle.IMovingObject;

import yaes.framework.world.map.IMap;

import yaes.framework.world.map.Path;

import yaes.framework.world.map.SimpleFreeGround;

import yaes.ui.text.TextUi;



/**

 * @author Lotzi B?l?ni

 *

 * To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

public class VisualMap {



    private JFrame frame = null;

    private JPanel panel = null;

    private List objects;

    int scale = 2;

    int border = 0;

    private Map painters = new HashMap();



    public synchronized void addObject(Object o) {

    	if (o instanceof Path) {

    		addObject(o, new PathPainter());

    		return;

    	}

    	if (o instanceof IMovingObject) {

    		addObject(o, new MovingObjectPainter());

    		return;

    	}

    	TextUi.errorPrint("The added object " + o + " has no associated painter");

        objects.add(o);

    }



    public synchronized void addObject(Object o, IPainter painter) {

        objects.add(o);

        painters.put(o, painter);

        repaint();

    }

    

    

    public VisualMap() {

        objects = new ArrayList();

        frame = new JFrame();

        panel = new JPanel() {



            /**

             * Comment for <code>serialVersionUID</code>

             */

            private static final long serialVersionUID = 3256727281769920818L;



            public void paint(Graphics g) {

                Graphics2D g2 = (Graphics2D) g;

                invalidate();

            	g2.clearRect(0, 0, getSize().width, getSize().height);

                paintVisualMap(g2);

            }

        };



        panel.setPreferredSize(new Dimension(800, 800));

        panel.setDoubleBuffered(true);

        panel.setOpaque(true);

        frame.add(panel);

        frame.pack();

        frame.setVisible(true);

    }



	public void saveImage(String fileName) throws IOException {

		Rectangle rect = frame.getBounds();

		Image fileImage = frame.createImage(rect.width, rect.height);

		Graphics g = fileImage.getGraphics();

		//write to the image

		paintVisualMap((Graphics2D)g);

		// write it out in the format you want

		ImageIO.write((RenderedImage) fileImage, "png", new File(fileName));

		//dispose of the graphics content

		g.dispose();

	}    

    

    public synchronized void paintVisualMap(Graphics2D g) {   

        AffineTransform theTransform = g.getTransform();

        theTransform.scale(scale,scale);

        theTransform.translate(0,0);

        g.setTransform(theTransform);

        for (Iterator iter = objects.iterator(); iter.hasNext();) {

            Object element = (Object) iter.next();

            IPainter painter = (IPainter)painters.get(element);

            if (painter != null) {

                painter.paint(g, element);

                continue;

            }

            if (element instanceof IMap) {

                IMap theMap = (IMap) element;

                paintMap(g, theMap);

                continue;

            }

            TextUi.errorPrint("Object " + element + " is added to the map but I don't know how to print it");

        }

    }    

    

    private void paintMap(Graphics2D g, IMap fg) {

        SimpleFreeGround sfg = (SimpleFreeGround) fg;

        Image theImage = sfg.getImage();

        g.drawImage(theImage, null, null);

    }



    public void repaint() {

        panel.invalidate();

        panel.repaint();

    }



	/**

	 * @param b

	 */

	public void setVisible(boolean b) {

		frame.setVisible(b);

	}

}